/**
 */
package org.fortiss.af3.exploration.dsl.model.operators;

import org.eclipse.emf.ecore.EFactory;

import org.fortiss.af3.exploration.dsl.model.expressions.ArithmeticExpression;

import org.fortiss.tooling.base.model.element.IModelElement;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see org.fortiss.af3.exploration.dsl.model.operators.OperatorsPackage
 * @generated
 */
public interface OperatorsFactory extends EFactory {
	/**
	 * The singleton instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	OperatorsFactory eINSTANCE = org.fortiss.af3.exploration.dsl.model.operators.impl.OperatorsFactoryImpl.init();

	/**
	 * Returns a new object of class '<em>Dual Operator</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Dual Operator</em>'.
	 * @generated
	 */
	<LHT, OP, RHT> DualOperator<LHT, OP, RHT> createDualOperator();

	/**
	 * Returns a new object of class '<em>Arithmetic Op</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Arithmetic Op</em>'.
	 * @generated
	 */
	<T, LHE extends ArithmeticExpression<T>, RHE extends ArithmeticExpression<T>> ArithmeticOp<T, LHE, RHE> createArithmeticOp();

	/**
	 * Returns a new object of class '<em>Comparison Op</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Comparison Op</em>'.
	 * @generated
	 */
	<T, LHT extends ArithmeticExpression<T>, RHT extends ArithmeticExpression<T>> ComparisonOp<T, LHT, RHT> createComparisonOp();

	/**
	 * Returns a new object of class '<em>Location Op</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Location Op</em>'.
	 * @generated
	 */
	<LHT extends IModelElement, RHT extends IModelElement> LocationOp<LHT, RHT> createLocationOp();

	/**
	 * Returns a new object of class '<em>Optimization Direction</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Optimization Direction</em>'.
	 * @generated
	 */
	OptimizationDirection createOptimizationDirection();

	/**
	 * Returns a new object of class '<em>Quantifier Op</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Quantifier Op</em>'.
	 * @generated
	 */
	QuantifierOp createQuantifierOp();

	/**
	 * Returns a new object of class '<em>Summation Op</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Summation Op</em>'.
	 * @generated
	 */
	<T> SummationOp<T> createSummationOp();

	/**
	 * Returns the package supported by this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the package supported by this factory.
	 * @generated
	 */
	OperatorsPackage getOperatorsPackage();

} //OperatorsFactory
