/**
 */
package org.fortiss.af3.exploration.dsl.model.operators.impl;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

import org.fortiss.af3.exploration.dsl.model.expressions.ArithmeticExpression;

import org.fortiss.af3.exploration.dsl.model.operators.*;

import org.fortiss.tooling.base.model.element.IModelElement;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class OperatorsFactoryImpl extends EFactoryImpl implements OperatorsFactory {
	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static OperatorsFactory init() {
		try {
			OperatorsFactory theOperatorsFactory = (OperatorsFactory)EPackage.Registry.INSTANCE.getEFactory(OperatorsPackage.eNS_URI);
			if (theOperatorsFactory != null) {
				return theOperatorsFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new OperatorsFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OperatorsFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case OperatorsPackage.DUAL_OPERATOR: return createDualOperator();
			case OperatorsPackage.ARITHMETIC_OP: return createArithmeticOp();
			case OperatorsPackage.COMPARISON_OP: return createComparisonOp();
			case OperatorsPackage.LOCATION_OP: return createLocationOp();
			case OperatorsPackage.OPTIMIZATION_DIRECTION: return createOptimizationDirection();
			case OperatorsPackage.QUANTIFIER_OP: return createQuantifierOp();
			case OperatorsPackage.SUMMATION_OP: return createSummationOp();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object createFromString(EDataType eDataType, String initialValue) {
		switch (eDataType.getClassifierID()) {
			case OperatorsPackage.ARITHMETIC_OPERATOR_ENUM:
				return createArithmeticOperatorEnumFromString(eDataType, initialValue);
			case OperatorsPackage.BOOLEAN_OPERATOR_ENUM:
				return createBooleanOperatorEnumFromString(eDataType, initialValue);
			case OperatorsPackage.COMPARISON_OPERATOR_ENUM:
				return createComparisonOperatorEnumFromString(eDataType, initialValue);
			case OperatorsPackage.LOCATION_OPERATOR_ENUM:
				return createLocationOperatorEnumFromString(eDataType, initialValue);
			case OperatorsPackage.OPTIMIZATION_DIRECTION_ENUM:
				return createOptimizationDirectionEnumFromString(eDataType, initialValue);
			case OperatorsPackage.QUANTIFIER_ENUM:
				return createQuantifierEnumFromString(eDataType, initialValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String convertToString(EDataType eDataType, Object instanceValue) {
		switch (eDataType.getClassifierID()) {
			case OperatorsPackage.ARITHMETIC_OPERATOR_ENUM:
				return convertArithmeticOperatorEnumToString(eDataType, instanceValue);
			case OperatorsPackage.BOOLEAN_OPERATOR_ENUM:
				return convertBooleanOperatorEnumToString(eDataType, instanceValue);
			case OperatorsPackage.COMPARISON_OPERATOR_ENUM:
				return convertComparisonOperatorEnumToString(eDataType, instanceValue);
			case OperatorsPackage.LOCATION_OPERATOR_ENUM:
				return convertLocationOperatorEnumToString(eDataType, instanceValue);
			case OperatorsPackage.OPTIMIZATION_DIRECTION_ENUM:
				return convertOptimizationDirectionEnumToString(eDataType, instanceValue);
			case OperatorsPackage.QUANTIFIER_ENUM:
				return convertQuantifierEnumToString(eDataType, instanceValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public <LHT, OP, RHT> DualOperator<LHT, OP, RHT> createDualOperator() {
		DualOperatorImpl<LHT, OP, RHT> dualOperator = new DualOperatorImpl<LHT, OP, RHT>();
		return dualOperator;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public <T, LHE extends ArithmeticExpression<T>, RHE extends ArithmeticExpression<T>> ArithmeticOp<T, LHE, RHE> createArithmeticOp() {
		ArithmeticOpImpl<T, LHE, RHE> arithmeticOp = new ArithmeticOpImpl<T, LHE, RHE>();
		return arithmeticOp;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public <T, LHT extends ArithmeticExpression<T>, RHT extends ArithmeticExpression<T>> ComparisonOp<T, LHT, RHT> createComparisonOp() {
		ComparisonOpImpl<T, LHT, RHT> comparisonOp = new ComparisonOpImpl<T, LHT, RHT>();
		return comparisonOp;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public <LHT extends IModelElement, RHT extends IModelElement> LocationOp<LHT, RHT> createLocationOp() {
		LocationOpImpl<LHT, RHT> locationOp = new LocationOpImpl<LHT, RHT>();
		return locationOp;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OptimizationDirection createOptimizationDirection() {
		OptimizationDirectionImpl optimizationDirection = new OptimizationDirectionImpl();
		return optimizationDirection;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public QuantifierOp createQuantifierOp() {
		QuantifierOpImpl quantifierOp = new QuantifierOpImpl();
		return quantifierOp;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public <T> SummationOp<T> createSummationOp() {
		SummationOpImpl<T> summationOp = new SummationOpImpl<T>();
		return summationOp;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ArithmeticOperatorEnum createArithmeticOperatorEnumFromString(EDataType eDataType, String initialValue) {
		ArithmeticOperatorEnum result = ArithmeticOperatorEnum.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertArithmeticOperatorEnumToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BooleanOperatorEnum createBooleanOperatorEnumFromString(EDataType eDataType, String initialValue) {
		BooleanOperatorEnum result = BooleanOperatorEnum.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertBooleanOperatorEnumToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ComparisonOperatorEnum createComparisonOperatorEnumFromString(EDataType eDataType, String initialValue) {
		ComparisonOperatorEnum result = ComparisonOperatorEnum.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertComparisonOperatorEnumToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public LocationOperatorEnum createLocationOperatorEnumFromString(EDataType eDataType, String initialValue) {
		LocationOperatorEnum result = LocationOperatorEnum.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertLocationOperatorEnumToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OptimizationDirectionEnum createOptimizationDirectionEnumFromString(EDataType eDataType, String initialValue) {
		OptimizationDirectionEnum result = OptimizationDirectionEnum.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertOptimizationDirectionEnumToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public QuantifierEnum createQuantifierEnumFromString(EDataType eDataType, String initialValue) {
		QuantifierEnum result = QuantifierEnum.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertQuantifierEnumToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OperatorsPackage getOperatorsPackage() {
		return (OperatorsPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static OperatorsPackage getPackage() {
		return OperatorsPackage.eINSTANCE;
	}

} //OperatorsFactoryImpl
