/**
 */
package org.fortiss.af3.exploration.dsl.model.operators.util;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.util.Switch;

import org.fortiss.af3.exploration.dsl.model.expressions.ArithmeticExpression;
import org.fortiss.af3.exploration.dsl.model.expressions.BooleanExpression;
import org.fortiss.af3.exploration.dsl.model.expressions.Expression;

import org.fortiss.af3.exploration.dsl.model.operators.*;

import org.fortiss.tooling.base.model.element.IModelElement;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see org.fortiss.af3.exploration.dsl.model.operators.OperatorsPackage
 * @generated
 */
public class OperatorsSwitch<T1> extends Switch<T1> {
	/**
	 * The cached model package
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static OperatorsPackage modelPackage;

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OperatorsSwitch() {
		if (modelPackage == null) {
			modelPackage = OperatorsPackage.eINSTANCE;
		}
	}

	/**
	 * Checks whether this is a switch for the given package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @parameter ePackage the package in question.
	 * @return whether this is a switch for the given package.
	 * @generated
	 */
	@Override
	protected boolean isSwitchFor(EPackage ePackage) {
		return ePackage == modelPackage;
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	@Override
	protected T1 doSwitch(int classifierID, EObject theEObject) {
		switch (classifierID) {
			case OperatorsPackage.OPERATOR: {
				Operator<?, ?> operator = (Operator<?, ?>)theEObject;
				T1 result = caseOperator(operator);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case OperatorsPackage.DUAL_OPERATOR: {
				DualOperator<?, ?, ?> dualOperator = (DualOperator<?, ?, ?>)theEObject;
				T1 result = caseDualOperator(dualOperator);
				if (result == null) result = caseOperator(dualOperator);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case OperatorsPackage.ARITHMETIC_OP: {
				ArithmeticOp<?, ?, ?> arithmeticOp = (ArithmeticOp<?, ?, ?>)theEObject;
				T1 result = caseArithmeticOp(arithmeticOp);
				if (result == null) result = caseDualOperator(arithmeticOp);
				if (result == null) result = caseArithmeticExpression(arithmeticOp);
				if (result == null) result = caseOperator(arithmeticOp);
				if (result == null) result = caseExpression(arithmeticOp);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case OperatorsPackage.COMPARISON_OP: {
				ComparisonOp<?, ?, ?> comparisonOp = (ComparisonOp<?, ?, ?>)theEObject;
				T1 result = caseComparisonOp(comparisonOp);
				if (result == null) result = caseDualOperator(comparisonOp);
				if (result == null) result = caseBooleanExpression(comparisonOp);
				if (result == null) result = caseOperator(comparisonOp);
				if (result == null) result = caseExpression(comparisonOp);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case OperatorsPackage.LOCATION_OP: {
				LocationOp<?, ?> locationOp = (LocationOp<?, ?>)theEObject;
				T1 result = caseLocationOp(locationOp);
				if (result == null) result = caseDualOperator(locationOp);
				if (result == null) result = caseBooleanExpression(locationOp);
				if (result == null) result = caseOperator(locationOp);
				if (result == null) result = caseExpression(locationOp);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case OperatorsPackage.OPTIMIZATION_DIRECTION: {
				OptimizationDirection optimizationDirection = (OptimizationDirection)theEObject;
				T1 result = caseOptimizationDirection(optimizationDirection);
				if (result == null) result = caseOperator(optimizationDirection);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case OperatorsPackage.QUANTIFIER_OP: {
				QuantifierOp quantifierOp = (QuantifierOp)theEObject;
				T1 result = caseQuantifierOp(quantifierOp);
				if (result == null) result = caseOperator(quantifierOp);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case OperatorsPackage.SUMMATION_OP: {
				SummationOp<?> summationOp = (SummationOp<?>)theEObject;
				T1 result = caseSummationOp(summationOp);
				if (result == null) result = caseOperator(summationOp);
				if (result == null) result = caseArithmeticExpression(summationOp);
				if (result == null) result = caseExpression(summationOp);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			default: return defaultCase(theEObject);
		}
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Operator</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Operator</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public <OP, RHT> T1 caseOperator(Operator<OP, RHT> object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Dual Operator</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Dual Operator</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public <LHT, OP, RHT> T1 caseDualOperator(DualOperator<LHT, OP, RHT> object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Arithmetic Op</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Arithmetic Op</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public <T, LHE extends ArithmeticExpression<T>, RHE extends ArithmeticExpression<T>> T1 caseArithmeticOp(ArithmeticOp<T, LHE, RHE> object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Comparison Op</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Comparison Op</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public <T, LHT extends ArithmeticExpression<T>, RHT extends ArithmeticExpression<T>> T1 caseComparisonOp(ComparisonOp<T, LHT, RHT> object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Location Op</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Location Op</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public <LHT extends IModelElement, RHT extends IModelElement> T1 caseLocationOp(LocationOp<LHT, RHT> object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Optimization Direction</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Optimization Direction</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T1 caseOptimizationDirection(OptimizationDirection object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Quantifier Op</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Quantifier Op</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T1 caseQuantifierOp(QuantifierOp object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Summation Op</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Summation Op</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public <T> T1 caseSummationOp(SummationOp<T> object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Expression</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Expression</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T1 caseExpression(Expression object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Arithmetic Expression</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Arithmetic Expression</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public <T> T1 caseArithmeticExpression(ArithmeticExpression<T> object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Boolean Expression</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Boolean Expression</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T1 caseBooleanExpression(BooleanExpression object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch, but this is the last case anyway.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject)
	 * @generated
	 */
	@Override
	public T1 defaultCase(EObject object) {
		return null;
	}

} //OperatorsSwitch
