/**
 */
package org.fortiss.af3.exploration.dsl.model.patterns;

import org.eclipse.emf.ecore.EFactory;

import org.fortiss.af3.exploration.dsl.model.expressions.ArithmeticExpression;

import org.fortiss.tooling.base.model.element.IModelElement;

/**
 * <!-- begin-user-doc -->
 * The <b>Factory</b> for the model.
 * It provides a create method for each non-abstract class of the model.
 * <!-- end-user-doc -->
 * @see org.fortiss.af3.exploration.dsl.model.patterns.PatternsPackage
 * @generated
 */
public interface PatternsFactory extends EFactory {
	/**
	 * The singleton instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	PatternsFactory eINSTANCE = org.fortiss.af3.exploration.dsl.model.patterns.impl.PatternsFactoryImpl.init();

	/**
	 * Returns a new object of class '<em>Location Pattern</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Location Pattern</em>'.
	 * @generated
	 */
	<LHT extends IModelElement, RHT extends IModelElement> LocationPattern<LHT, RHT> createLocationPattern();

	/**
	 * Returns a new object of class '<em>Element Property</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Element Property</em>'.
	 * @generated
	 */
	<ME extends IModelElement, T> ElementProperty<ME, T> createElementProperty();

	/**
	 * Returns a new object of class '<em>Location Property</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Location Property</em>'.
	 * @generated
	 */
	<LA extends IModelElement, RA extends IModelElement, T> LocationProperty<LA, RA, T> createLocationProperty();

	/**
	 * Returns a new object of class '<em>Value Comparison</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Value Comparison</em>'.
	 * @generated
	 */
	<T, AE extends ArithmeticExpression<T>> ValueComparison<T, AE> createValueComparison();

	/**
	 * Returns a new object of class '<em>Single Prop Value Comparison</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Single Prop Value Comparison</em>'.
	 * @generated
	 */
	<T, ME extends IModelElement> SinglePropValueComparison<T, ME> createSinglePropValueComparison();

	/**
	 * Returns a new object of class '<em>Two Property Value Comparison</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Two Property Value Comparison</em>'.
	 * @generated
	 */
	<T, LME extends IModelElement, RME extends IModelElement> TwoPropertyValueComparison<T, LME, RME> createTwoPropertyValueComparison();

	/**
	 * Returns a new object of class '<em>Two Prop Calc Expression</em>'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return a new object of class '<em>Two Prop Calc Expression</em>'.
	 * @generated
	 */
	<T, LME extends IModelElement, RME extends IModelElement> TwoPropCalcExpression<T, LME, RME> createTwoPropCalcExpression();

	/**
	 * Returns the package supported by this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the package supported by this factory.
	 * @generated
	 */
	PatternsPackage getPatternsPackage();

} //PatternsFactory
