/**
 */
package org.fortiss.af3.exploration.dsl.model.patterns;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

import org.fortiss.af3.exploration.dsl.model.expressions.ExpressionsPackage;

import org.fortiss.af3.exploration.dsl.model.operators.OperatorsPackage;

import org.fortiss.af3.exploration.dsl.model.types.TypesPackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see org.fortiss.af3.exploration.dsl.model.patterns.PatternsFactory
 * @model kind="package"
 * @generated
 */
public interface PatternsPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "patterns";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.fortiss.org/af3/exploration/patterns";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "org-fortiss-af3-exploration-patterns";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	PatternsPackage eINSTANCE = org.fortiss.af3.exploration.dsl.model.patterns.impl.PatternsPackageImpl.init();

	/**
	 * The meta object id for the '{@link org.fortiss.af3.exploration.dsl.model.patterns.impl.LocationPatternImpl <em>Location Pattern</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.fortiss.af3.exploration.dsl.model.patterns.impl.LocationPatternImpl
	 * @see org.fortiss.af3.exploration.dsl.model.patterns.impl.PatternsPackageImpl#getLocationPattern()
	 * @generated
	 */
	int LOCATION_PATTERN = 0;

	/**
	 * The feature id for the '<em><b>Prefix</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOCATION_PATTERN__PREFIX = ExpressionsPackage.CONSTRAINT_EXPRESSION__PREFIX;

	/**
	 * The feature id for the '<em><b>Predicate</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOCATION_PATTERN__PREDICATE = ExpressionsPackage.CONSTRAINT_EXPRESSION__PREDICATE;

	/**
	 * The feature id for the '<em><b>Expression</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOCATION_PATTERN__EXPRESSION = ExpressionsPackage.CONSTRAINT_EXPRESSION__EXPRESSION;

	/**
	 * The number of structural features of the '<em>Location Pattern</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOCATION_PATTERN_FEATURE_COUNT = ExpressionsPackage.CONSTRAINT_EXPRESSION_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.fortiss.af3.exploration.dsl.model.patterns.impl.ElementPropertyImpl <em>Element Property</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.fortiss.af3.exploration.dsl.model.patterns.impl.ElementPropertyImpl
	 * @see org.fortiss.af3.exploration.dsl.model.patterns.impl.PatternsPackageImpl#getElementProperty()
	 * @generated
	 */
	int ELEMENT_PROPERTY = 1;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELEMENT_PROPERTY__VALUE = TypesPackage.ARITHMETIC_VARIABLE__VALUE;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELEMENT_PROPERTY__MODEL_ELEMENT = TypesPackage.ARITHMETIC_VARIABLE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Property Getter</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELEMENT_PROPERTY__PROPERTY_GETTER = TypesPackage.ARITHMETIC_VARIABLE_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Element Property</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ELEMENT_PROPERTY_FEATURE_COUNT = TypesPackage.ARITHMETIC_VARIABLE_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link org.fortiss.af3.exploration.dsl.model.patterns.impl.LocationPropertyImpl <em>Location Property</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.fortiss.af3.exploration.dsl.model.patterns.impl.LocationPropertyImpl
	 * @see org.fortiss.af3.exploration.dsl.model.patterns.impl.PatternsPackageImpl#getLocationProperty()
	 * @generated
	 */
	int LOCATION_PROPERTY = 2;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOCATION_PROPERTY__VALUE = TypesPackage.ARITHMETIC_VARIABLE__VALUE;

	/**
	 * The feature id for the '<em><b>Loc Op</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOCATION_PROPERTY__LOC_OP = TypesPackage.ARITHMETIC_VARIABLE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Location Property</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOCATION_PROPERTY_FEATURE_COUNT = TypesPackage.ARITHMETIC_VARIABLE_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link org.fortiss.af3.exploration.dsl.model.patterns.impl.ValueComparisonImpl <em>Value Comparison</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.fortiss.af3.exploration.dsl.model.patterns.impl.ValueComparisonImpl
	 * @see org.fortiss.af3.exploration.dsl.model.patterns.impl.PatternsPackageImpl#getValueComparison()
	 * @generated
	 */
	int VALUE_COMPARISON = 3;

	/**
	 * The feature id for the '<em><b>Operator</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_COMPARISON__OPERATOR = OperatorsPackage.COMPARISON_OP__OPERATOR;

	/**
	 * The feature id for the '<em><b>Right</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_COMPARISON__RIGHT = OperatorsPackage.COMPARISON_OP__RIGHT;

	/**
	 * The feature id for the '<em><b>Left</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_COMPARISON__LEFT = OperatorsPackage.COMPARISON_OP__LEFT;

	/**
	 * The number of structural features of the '<em>Value Comparison</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VALUE_COMPARISON_FEATURE_COUNT = OperatorsPackage.COMPARISON_OP_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.fortiss.af3.exploration.dsl.model.patterns.impl.SinglePropValueComparisonImpl <em>Single Prop Value Comparison</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.fortiss.af3.exploration.dsl.model.patterns.impl.SinglePropValueComparisonImpl
	 * @see org.fortiss.af3.exploration.dsl.model.patterns.impl.PatternsPackageImpl#getSinglePropValueComparison()
	 * @generated
	 */
	int SINGLE_PROP_VALUE_COMPARISON = 4;

	/**
	 * The feature id for the '<em><b>Operator</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SINGLE_PROP_VALUE_COMPARISON__OPERATOR = VALUE_COMPARISON__OPERATOR;

	/**
	 * The feature id for the '<em><b>Right</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SINGLE_PROP_VALUE_COMPARISON__RIGHT = VALUE_COMPARISON__RIGHT;

	/**
	 * The feature id for the '<em><b>Left</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SINGLE_PROP_VALUE_COMPARISON__LEFT = VALUE_COMPARISON__LEFT;

	/**
	 * The number of structural features of the '<em>Single Prop Value Comparison</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SINGLE_PROP_VALUE_COMPARISON_FEATURE_COUNT = VALUE_COMPARISON_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.fortiss.af3.exploration.dsl.model.patterns.impl.TwoPropertyValueComparisonImpl <em>Two Property Value Comparison</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.fortiss.af3.exploration.dsl.model.patterns.impl.TwoPropertyValueComparisonImpl
	 * @see org.fortiss.af3.exploration.dsl.model.patterns.impl.PatternsPackageImpl#getTwoPropertyValueComparison()
	 * @generated
	 */
	int TWO_PROPERTY_VALUE_COMPARISON = 5;

	/**
	 * The feature id for the '<em><b>Operator</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TWO_PROPERTY_VALUE_COMPARISON__OPERATOR = VALUE_COMPARISON__OPERATOR;

	/**
	 * The feature id for the '<em><b>Right</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TWO_PROPERTY_VALUE_COMPARISON__RIGHT = VALUE_COMPARISON__RIGHT;

	/**
	 * The feature id for the '<em><b>Left</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TWO_PROPERTY_VALUE_COMPARISON__LEFT = VALUE_COMPARISON__LEFT;

	/**
	 * The number of structural features of the '<em>Two Property Value Comparison</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TWO_PROPERTY_VALUE_COMPARISON_FEATURE_COUNT = VALUE_COMPARISON_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.fortiss.af3.exploration.dsl.model.patterns.impl.TwoPropCalcExpressionImpl <em>Two Prop Calc Expression</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.fortiss.af3.exploration.dsl.model.patterns.impl.TwoPropCalcExpressionImpl
	 * @see org.fortiss.af3.exploration.dsl.model.patterns.impl.PatternsPackageImpl#getTwoPropCalcExpression()
	 * @generated
	 */
	int TWO_PROP_CALC_EXPRESSION = 6;

	/**
	 * The feature id for the '<em><b>Operator</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TWO_PROP_CALC_EXPRESSION__OPERATOR = OperatorsPackage.ARITHMETIC_OP__OPERATOR;

	/**
	 * The feature id for the '<em><b>Right</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TWO_PROP_CALC_EXPRESSION__RIGHT = OperatorsPackage.ARITHMETIC_OP__RIGHT;

	/**
	 * The feature id for the '<em><b>Left</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TWO_PROP_CALC_EXPRESSION__LEFT = OperatorsPackage.ARITHMETIC_OP__LEFT;

	/**
	 * The number of structural features of the '<em>Two Prop Calc Expression</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TWO_PROP_CALC_EXPRESSION_FEATURE_COUNT = OperatorsPackage.ARITHMETIC_OP_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '<em>Function</em>' data type.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see java.util.function.Function
	 * @see org.fortiss.af3.exploration.dsl.model.patterns.impl.PatternsPackageImpl#getFunction()
	 * @generated
	 */
	int FUNCTION = 7;


	/**
	 * Returns the meta object for class '{@link org.fortiss.af3.exploration.dsl.model.patterns.LocationPattern <em>Location Pattern</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Location Pattern</em>'.
	 * @see org.fortiss.af3.exploration.dsl.model.patterns.LocationPattern
	 * @generated
	 */
	EClass getLocationPattern();

	/**
	 * Returns the meta object for class '{@link org.fortiss.af3.exploration.dsl.model.patterns.ElementProperty <em>Element Property</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Element Property</em>'.
	 * @see org.fortiss.af3.exploration.dsl.model.patterns.ElementProperty
	 * @generated
	 */
	EClass getElementProperty();

	/**
	 * Returns the meta object for the reference '{@link org.fortiss.af3.exploration.dsl.model.patterns.ElementProperty#getModelElement <em>Model Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Model Element</em>'.
	 * @see org.fortiss.af3.exploration.dsl.model.patterns.ElementProperty#getModelElement()
	 * @see #getElementProperty()
	 * @generated
	 */
	EReference getElementProperty_ModelElement();

	/**
	 * Returns the meta object for the attribute '{@link org.fortiss.af3.exploration.dsl.model.patterns.ElementProperty#getPropertyGetter <em>Property Getter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Property Getter</em>'.
	 * @see org.fortiss.af3.exploration.dsl.model.patterns.ElementProperty#getPropertyGetter()
	 * @see #getElementProperty()
	 * @generated
	 */
	EAttribute getElementProperty_PropertyGetter();

	/**
	 * Returns the meta object for class '{@link org.fortiss.af3.exploration.dsl.model.patterns.LocationProperty <em>Location Property</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Location Property</em>'.
	 * @see org.fortiss.af3.exploration.dsl.model.patterns.LocationProperty
	 * @generated
	 */
	EClass getLocationProperty();

	/**
	 * Returns the meta object for the containment reference '{@link org.fortiss.af3.exploration.dsl.model.patterns.LocationProperty#getLocOp <em>Loc Op</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Loc Op</em>'.
	 * @see org.fortiss.af3.exploration.dsl.model.patterns.LocationProperty#getLocOp()
	 * @see #getLocationProperty()
	 * @generated
	 */
	EReference getLocationProperty_LocOp();

	/**
	 * Returns the meta object for class '{@link org.fortiss.af3.exploration.dsl.model.patterns.ValueComparison <em>Value Comparison</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Value Comparison</em>'.
	 * @see org.fortiss.af3.exploration.dsl.model.patterns.ValueComparison
	 * @generated
	 */
	EClass getValueComparison();

	/**
	 * Returns the meta object for class '{@link org.fortiss.af3.exploration.dsl.model.patterns.SinglePropValueComparison <em>Single Prop Value Comparison</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Single Prop Value Comparison</em>'.
	 * @see org.fortiss.af3.exploration.dsl.model.patterns.SinglePropValueComparison
	 * @generated
	 */
	EClass getSinglePropValueComparison();

	/**
	 * Returns the meta object for class '{@link org.fortiss.af3.exploration.dsl.model.patterns.TwoPropertyValueComparison <em>Two Property Value Comparison</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Two Property Value Comparison</em>'.
	 * @see org.fortiss.af3.exploration.dsl.model.patterns.TwoPropertyValueComparison
	 * @generated
	 */
	EClass getTwoPropertyValueComparison();

	/**
	 * Returns the meta object for class '{@link org.fortiss.af3.exploration.dsl.model.patterns.TwoPropCalcExpression <em>Two Prop Calc Expression</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Two Prop Calc Expression</em>'.
	 * @see org.fortiss.af3.exploration.dsl.model.patterns.TwoPropCalcExpression
	 * @generated
	 */
	EClass getTwoPropCalcExpression();

	/**
	 * Returns the meta object for data type '{@link java.util.function.Function <em>Function</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for data type '<em>Function</em>'.
	 * @see java.util.function.Function
	 * @model instanceClass="java.util.function.Function" typeParameters="T R"
	 * @generated
	 */
	EDataType getFunction();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	PatternsFactory getPatternsFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link org.fortiss.af3.exploration.dsl.model.patterns.impl.LocationPatternImpl <em>Location Pattern</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.fortiss.af3.exploration.dsl.model.patterns.impl.LocationPatternImpl
		 * @see org.fortiss.af3.exploration.dsl.model.patterns.impl.PatternsPackageImpl#getLocationPattern()
		 * @generated
		 */
		EClass LOCATION_PATTERN = eINSTANCE.getLocationPattern();

		/**
		 * The meta object literal for the '{@link org.fortiss.af3.exploration.dsl.model.patterns.impl.ElementPropertyImpl <em>Element Property</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.fortiss.af3.exploration.dsl.model.patterns.impl.ElementPropertyImpl
		 * @see org.fortiss.af3.exploration.dsl.model.patterns.impl.PatternsPackageImpl#getElementProperty()
		 * @generated
		 */
		EClass ELEMENT_PROPERTY = eINSTANCE.getElementProperty();

		/**
		 * The meta object literal for the '<em><b>Model Element</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ELEMENT_PROPERTY__MODEL_ELEMENT = eINSTANCE.getElementProperty_ModelElement();

		/**
		 * The meta object literal for the '<em><b>Property Getter</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ELEMENT_PROPERTY__PROPERTY_GETTER = eINSTANCE.getElementProperty_PropertyGetter();

		/**
		 * The meta object literal for the '{@link org.fortiss.af3.exploration.dsl.model.patterns.impl.LocationPropertyImpl <em>Location Property</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.fortiss.af3.exploration.dsl.model.patterns.impl.LocationPropertyImpl
		 * @see org.fortiss.af3.exploration.dsl.model.patterns.impl.PatternsPackageImpl#getLocationProperty()
		 * @generated
		 */
		EClass LOCATION_PROPERTY = eINSTANCE.getLocationProperty();

		/**
		 * The meta object literal for the '<em><b>Loc Op</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference LOCATION_PROPERTY__LOC_OP = eINSTANCE.getLocationProperty_LocOp();

		/**
		 * The meta object literal for the '{@link org.fortiss.af3.exploration.dsl.model.patterns.impl.ValueComparisonImpl <em>Value Comparison</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.fortiss.af3.exploration.dsl.model.patterns.impl.ValueComparisonImpl
		 * @see org.fortiss.af3.exploration.dsl.model.patterns.impl.PatternsPackageImpl#getValueComparison()
		 * @generated
		 */
		EClass VALUE_COMPARISON = eINSTANCE.getValueComparison();

		/**
		 * The meta object literal for the '{@link org.fortiss.af3.exploration.dsl.model.patterns.impl.SinglePropValueComparisonImpl <em>Single Prop Value Comparison</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.fortiss.af3.exploration.dsl.model.patterns.impl.SinglePropValueComparisonImpl
		 * @see org.fortiss.af3.exploration.dsl.model.patterns.impl.PatternsPackageImpl#getSinglePropValueComparison()
		 * @generated
		 */
		EClass SINGLE_PROP_VALUE_COMPARISON = eINSTANCE.getSinglePropValueComparison();

		/**
		 * The meta object literal for the '{@link org.fortiss.af3.exploration.dsl.model.patterns.impl.TwoPropertyValueComparisonImpl <em>Two Property Value Comparison</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.fortiss.af3.exploration.dsl.model.patterns.impl.TwoPropertyValueComparisonImpl
		 * @see org.fortiss.af3.exploration.dsl.model.patterns.impl.PatternsPackageImpl#getTwoPropertyValueComparison()
		 * @generated
		 */
		EClass TWO_PROPERTY_VALUE_COMPARISON = eINSTANCE.getTwoPropertyValueComparison();

		/**
		 * The meta object literal for the '{@link org.fortiss.af3.exploration.dsl.model.patterns.impl.TwoPropCalcExpressionImpl <em>Two Prop Calc Expression</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.fortiss.af3.exploration.dsl.model.patterns.impl.TwoPropCalcExpressionImpl
		 * @see org.fortiss.af3.exploration.dsl.model.patterns.impl.PatternsPackageImpl#getTwoPropCalcExpression()
		 * @generated
		 */
		EClass TWO_PROP_CALC_EXPRESSION = eINSTANCE.getTwoPropCalcExpression();

		/**
		 * The meta object literal for the '<em>Function</em>' data type.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see java.util.function.Function
		 * @see org.fortiss.af3.exploration.dsl.model.patterns.impl.PatternsPackageImpl#getFunction()
		 * @generated
		 */
		EDataType FUNCTION = eINSTANCE.getFunction();

	}

} //PatternsPackage
