/**
 */
package org.fortiss.af3.exploration.dsl.model.patterns.impl;

import java.util.function.Function;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

import org.fortiss.af3.exploration.dsl.model.expressions.ArithmeticExpression;

import org.fortiss.af3.exploration.dsl.model.patterns.*;

import org.fortiss.tooling.base.model.element.IModelElement;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class PatternsFactoryImpl extends EFactoryImpl implements PatternsFactory {
	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static PatternsFactory init() {
		try {
			PatternsFactory thePatternsFactory = (PatternsFactory)EPackage.Registry.INSTANCE.getEFactory(PatternsPackage.eNS_URI);
			if (thePatternsFactory != null) {
				return thePatternsFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new PatternsFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PatternsFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case PatternsPackage.LOCATION_PATTERN: return createLocationPattern();
			case PatternsPackage.ELEMENT_PROPERTY: return createElementProperty();
			case PatternsPackage.LOCATION_PROPERTY: return createLocationProperty();
			case PatternsPackage.VALUE_COMPARISON: return createValueComparison();
			case PatternsPackage.SINGLE_PROP_VALUE_COMPARISON: return createSinglePropValueComparison();
			case PatternsPackage.TWO_PROPERTY_VALUE_COMPARISON: return createTwoPropertyValueComparison();
			case PatternsPackage.TWO_PROP_CALC_EXPRESSION: return createTwoPropCalcExpression();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object createFromString(EDataType eDataType, String initialValue) {
		switch (eDataType.getClassifierID()) {
			case PatternsPackage.FUNCTION:
				return createFunctionFromString(eDataType, initialValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String convertToString(EDataType eDataType, Object instanceValue) {
		switch (eDataType.getClassifierID()) {
			case PatternsPackage.FUNCTION:
				return convertFunctionToString(eDataType, instanceValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public <LHT extends IModelElement, RHT extends IModelElement> LocationPattern<LHT, RHT> createLocationPattern() {
		LocationPatternImpl<LHT, RHT> locationPattern = new LocationPatternImpl<LHT, RHT>();
		return locationPattern;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public <ME extends IModelElement, T> ElementProperty<ME, T> createElementProperty() {
		ElementPropertyImpl<ME, T> elementProperty = new ElementPropertyImpl<ME, T>();
		return elementProperty;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public <LA extends IModelElement, RA extends IModelElement, T> LocationProperty<LA, RA, T> createLocationProperty() {
		LocationPropertyImpl<LA, RA, T> locationProperty = new LocationPropertyImpl<LA, RA, T>();
		return locationProperty;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public <T, AE extends ArithmeticExpression<T>> ValueComparison<T, AE> createValueComparison() {
		ValueComparisonImpl<T, AE> valueComparison = new ValueComparisonImpl<T, AE>();
		return valueComparison;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public <T, ME extends IModelElement> SinglePropValueComparison<T, ME> createSinglePropValueComparison() {
		SinglePropValueComparisonImpl<T, ME> singlePropValueComparison = new SinglePropValueComparisonImpl<T, ME>();
		return singlePropValueComparison;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public <T, LME extends IModelElement, RME extends IModelElement> TwoPropertyValueComparison<T, LME, RME> createTwoPropertyValueComparison() {
		TwoPropertyValueComparisonImpl<T, LME, RME> twoPropertyValueComparison = new TwoPropertyValueComparisonImpl<T, LME, RME>();
		return twoPropertyValueComparison;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public <T, LME extends IModelElement, RME extends IModelElement> TwoPropCalcExpression<T, LME, RME> createTwoPropCalcExpression() {
		TwoPropCalcExpressionImpl<T, LME, RME> twoPropCalcExpression = new TwoPropCalcExpressionImpl<T, LME, RME>();
		return twoPropCalcExpression;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Function<?, ?> createFunctionFromString(EDataType eDataType, String initialValue) {
		return (Function<?, ?>)super.createFromString(initialValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertFunctionToString(EDataType eDataType, Object instanceValue) {
		return super.convertToString(instanceValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PatternsPackage getPatternsPackage() {
		return (PatternsPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static PatternsPackage getPackage() {
		return PatternsPackage.eINSTANCE;
	}

} //PatternsFactoryImpl
