/**
 */
package org.fortiss.af3.exploration.dsl.model.patterns.impl;

import java.util.function.Function;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EGenericType;
import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.ETypeParameter;

import org.eclipse.emf.ecore.impl.EPackageImpl;

import org.fortiss.af3.exploration.dsl.model.ModelPackage;

import org.fortiss.af3.exploration.dsl.model.expressions.ExpressionsPackage;

import org.fortiss.af3.exploration.dsl.model.expressions.impl.ExpressionsPackageImpl;

import org.fortiss.af3.exploration.dsl.model.impl.ModelPackageImpl;

import org.fortiss.af3.exploration.dsl.model.operators.OperatorsPackage;

import org.fortiss.af3.exploration.dsl.model.operators.impl.OperatorsPackageImpl;

import org.fortiss.af3.exploration.dsl.model.patterns.ElementProperty;
import org.fortiss.af3.exploration.dsl.model.patterns.LocationPattern;
import org.fortiss.af3.exploration.dsl.model.patterns.LocationProperty;
import org.fortiss.af3.exploration.dsl.model.patterns.PatternsFactory;
import org.fortiss.af3.exploration.dsl.model.patterns.PatternsPackage;
import org.fortiss.af3.exploration.dsl.model.patterns.SinglePropValueComparison;
import org.fortiss.af3.exploration.dsl.model.patterns.TwoPropCalcExpression;
import org.fortiss.af3.exploration.dsl.model.patterns.TwoPropertyValueComparison;
import org.fortiss.af3.exploration.dsl.model.patterns.ValueComparison;

import org.fortiss.af3.exploration.dsl.model.types.TypesPackage;

import org.fortiss.af3.exploration.dsl.model.types.impl.TypesPackageImpl;

import org.fortiss.tooling.base.model.base.BasePackage;

import org.fortiss.tooling.base.model.element.ElementPackage;

import org.fortiss.tooling.base.model.layout.LayoutPackage;

import org.fortiss.tooling.base.model.visualization.VisualizationPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class PatternsPackageImpl extends EPackageImpl implements PatternsPackage {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass locationPatternEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass elementPropertyEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass locationPropertyEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass valueComparisonEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass singlePropValueComparisonEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass twoPropertyValueComparisonEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass twoPropCalcExpressionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EDataType functionEDataType = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see org.fortiss.af3.exploration.dsl.model.patterns.PatternsPackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private PatternsPackageImpl() {
		super(eNS_URI, PatternsFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
	 * 
	 * <p>This method is used to initialize {@link PatternsPackage#eINSTANCE} when that field is accessed.
	 * Clients should not invoke it directly. Instead, they should simply access that field to obtain the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
	public static PatternsPackage init() {
		if (isInited) return (PatternsPackage)EPackage.Registry.INSTANCE.getEPackage(PatternsPackage.eNS_URI);

		// Obtain or create and register package
		PatternsPackageImpl thePatternsPackage = (PatternsPackageImpl)(EPackage.Registry.INSTANCE.get(eNS_URI) instanceof PatternsPackageImpl ? EPackage.Registry.INSTANCE.get(eNS_URI) : new PatternsPackageImpl());

		isInited = true;

		// Initialize simple dependencies
		ElementPackage.eINSTANCE.eClass();
		LayoutPackage.eINSTANCE.eClass();
		BasePackage.eINSTANCE.eClass();
		VisualizationPackage.eINSTANCE.eClass();

		// Obtain or create and register interdependencies
		ModelPackageImpl theModelPackage = (ModelPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(ModelPackage.eNS_URI) instanceof ModelPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(ModelPackage.eNS_URI) : ModelPackage.eINSTANCE);
		OperatorsPackageImpl theOperatorsPackage = (OperatorsPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(OperatorsPackage.eNS_URI) instanceof OperatorsPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(OperatorsPackage.eNS_URI) : OperatorsPackage.eINSTANCE);
		ExpressionsPackageImpl theExpressionsPackage = (ExpressionsPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(ExpressionsPackage.eNS_URI) instanceof ExpressionsPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(ExpressionsPackage.eNS_URI) : ExpressionsPackage.eINSTANCE);
		TypesPackageImpl theTypesPackage = (TypesPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(TypesPackage.eNS_URI) instanceof TypesPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(TypesPackage.eNS_URI) : TypesPackage.eINSTANCE);

		// Create package meta-data objects
		thePatternsPackage.createPackageContents();
		theModelPackage.createPackageContents();
		theOperatorsPackage.createPackageContents();
		theExpressionsPackage.createPackageContents();
		theTypesPackage.createPackageContents();

		// Initialize created meta-data
		thePatternsPackage.initializePackageContents();
		theModelPackage.initializePackageContents();
		theOperatorsPackage.initializePackageContents();
		theExpressionsPackage.initializePackageContents();
		theTypesPackage.initializePackageContents();

		// Mark meta-data to indicate it can't be changed
		thePatternsPackage.freeze();

  
		// Update the registry and return the package
		EPackage.Registry.INSTANCE.put(PatternsPackage.eNS_URI, thePatternsPackage);
		return thePatternsPackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getLocationPattern() {
		return locationPatternEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getElementProperty() {
		return elementPropertyEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getElementProperty_ModelElement() {
		return (EReference)elementPropertyEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getElementProperty_PropertyGetter() {
		return (EAttribute)elementPropertyEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getLocationProperty() {
		return locationPropertyEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getLocationProperty_LocOp() {
		return (EReference)locationPropertyEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getValueComparison() {
		return valueComparisonEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getSinglePropValueComparison() {
		return singlePropValueComparisonEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTwoPropertyValueComparison() {
		return twoPropertyValueComparisonEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTwoPropCalcExpression() {
		return twoPropCalcExpressionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EDataType getFunction() {
		return functionEDataType;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PatternsFactory getPatternsFactory() {
		return (PatternsFactory)getEFactoryInstance();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isCreated = false;

	/**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void createPackageContents() {
		if (isCreated) return;
		isCreated = true;

		// Create classes and their features
		locationPatternEClass = createEClass(LOCATION_PATTERN);

		elementPropertyEClass = createEClass(ELEMENT_PROPERTY);
		createEReference(elementPropertyEClass, ELEMENT_PROPERTY__MODEL_ELEMENT);
		createEAttribute(elementPropertyEClass, ELEMENT_PROPERTY__PROPERTY_GETTER);

		locationPropertyEClass = createEClass(LOCATION_PROPERTY);
		createEReference(locationPropertyEClass, LOCATION_PROPERTY__LOC_OP);

		valueComparisonEClass = createEClass(VALUE_COMPARISON);

		singlePropValueComparisonEClass = createEClass(SINGLE_PROP_VALUE_COMPARISON);

		twoPropertyValueComparisonEClass = createEClass(TWO_PROPERTY_VALUE_COMPARISON);

		twoPropCalcExpressionEClass = createEClass(TWO_PROP_CALC_EXPRESSION);

		// Create data types
		functionEDataType = createEDataType(FUNCTION);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isInitialized = false;

	/**
	 * Complete the initialization of the package and its meta-model.  This
	 * method is guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void initializePackageContents() {
		if (isInitialized) return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Obtain other dependent packages
		ElementPackage theElementPackage = (ElementPackage)EPackage.Registry.INSTANCE.getEPackage(ElementPackage.eNS_URI);
		ExpressionsPackage theExpressionsPackage = (ExpressionsPackage)EPackage.Registry.INSTANCE.getEPackage(ExpressionsPackage.eNS_URI);
		OperatorsPackage theOperatorsPackage = (OperatorsPackage)EPackage.Registry.INSTANCE.getEPackage(OperatorsPackage.eNS_URI);
		TypesPackage theTypesPackage = (TypesPackage)EPackage.Registry.INSTANCE.getEPackage(TypesPackage.eNS_URI);

		// Create type parameters
		ETypeParameter locationPatternEClass_LHT = addETypeParameter(locationPatternEClass, "LHT");
		ETypeParameter locationPatternEClass_RHT = addETypeParameter(locationPatternEClass, "RHT");
		ETypeParameter elementPropertyEClass_ME = addETypeParameter(elementPropertyEClass, "ME");
		ETypeParameter elementPropertyEClass_T = addETypeParameter(elementPropertyEClass, "T");
		ETypeParameter locationPropertyEClass_LA = addETypeParameter(locationPropertyEClass, "LA");
		ETypeParameter locationPropertyEClass_RA = addETypeParameter(locationPropertyEClass, "RA");
		ETypeParameter locationPropertyEClass_T = addETypeParameter(locationPropertyEClass, "T");
		ETypeParameter valueComparisonEClass_T = addETypeParameter(valueComparisonEClass, "T");
		ETypeParameter valueComparisonEClass_AE = addETypeParameter(valueComparisonEClass, "AE");
		ETypeParameter singlePropValueComparisonEClass_T = addETypeParameter(singlePropValueComparisonEClass, "T");
		ETypeParameter singlePropValueComparisonEClass_ME = addETypeParameter(singlePropValueComparisonEClass, "ME");
		ETypeParameter twoPropertyValueComparisonEClass_T = addETypeParameter(twoPropertyValueComparisonEClass, "T");
		ETypeParameter twoPropertyValueComparisonEClass_LME = addETypeParameter(twoPropertyValueComparisonEClass, "LME");
		ETypeParameter twoPropertyValueComparisonEClass_RME = addETypeParameter(twoPropertyValueComparisonEClass, "RME");
		ETypeParameter twoPropCalcExpressionEClass_T = addETypeParameter(twoPropCalcExpressionEClass, "T");
		ETypeParameter twoPropCalcExpressionEClass_LME = addETypeParameter(twoPropCalcExpressionEClass, "LME");
		ETypeParameter twoPropCalcExpressionEClass_RME = addETypeParameter(twoPropCalcExpressionEClass, "RME");
		addETypeParameter(functionEDataType, "T");
		addETypeParameter(functionEDataType, "R");

		// Set bounds for type parameters
		EGenericType g1 = createEGenericType(theElementPackage.getIModelElement());
		locationPatternEClass_LHT.getEBounds().add(g1);
		g1 = createEGenericType(theElementPackage.getIModelElement());
		locationPatternEClass_RHT.getEBounds().add(g1);
		g1 = createEGenericType(theElementPackage.getIModelElement());
		elementPropertyEClass_ME.getEBounds().add(g1);
		g1 = createEGenericType(theElementPackage.getIModelElement());
		locationPropertyEClass_LA.getEBounds().add(g1);
		g1 = createEGenericType(theElementPackage.getIModelElement());
		locationPropertyEClass_RA.getEBounds().add(g1);
		g1 = createEGenericType(theExpressionsPackage.getArithmeticExpression());
		EGenericType g2 = createEGenericType(valueComparisonEClass_T);
		g1.getETypeArguments().add(g2);
		valueComparisonEClass_AE.getEBounds().add(g1);
		g1 = createEGenericType(theElementPackage.getIModelElement());
		singlePropValueComparisonEClass_ME.getEBounds().add(g1);
		g1 = createEGenericType(theElementPackage.getIModelElement());
		twoPropertyValueComparisonEClass_LME.getEBounds().add(g1);
		g1 = createEGenericType(theElementPackage.getIModelElement());
		twoPropertyValueComparisonEClass_RME.getEBounds().add(g1);
		g1 = createEGenericType(theElementPackage.getIModelElement());
		twoPropCalcExpressionEClass_LME.getEBounds().add(g1);
		g1 = createEGenericType(theElementPackage.getIModelElement());
		twoPropCalcExpressionEClass_RME.getEBounds().add(g1);

		// Add supertypes to classes
		g1 = createEGenericType(theExpressionsPackage.getConstraintExpression());
		g2 = createEGenericType(theOperatorsPackage.getLocationOp());
		g1.getETypeArguments().add(g2);
		EGenericType g3 = createEGenericType(locationPatternEClass_LHT);
		g2.getETypeArguments().add(g3);
		g3 = createEGenericType(locationPatternEClass_RHT);
		g2.getETypeArguments().add(g3);
		locationPatternEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(theTypesPackage.getArithmeticVariable());
		g2 = createEGenericType(elementPropertyEClass_T);
		g1.getETypeArguments().add(g2);
		elementPropertyEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(theTypesPackage.getArithmeticVariable());
		g2 = createEGenericType(locationPropertyEClass_T);
		g1.getETypeArguments().add(g2);
		locationPropertyEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(theOperatorsPackage.getComparisonOp());
		g2 = createEGenericType(valueComparisonEClass_T);
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(valueComparisonEClass_AE);
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(theTypesPackage.getNumberLiteral());
		g1.getETypeArguments().add(g2);
		g3 = createEGenericType(valueComparisonEClass_T);
		g2.getETypeArguments().add(g3);
		valueComparisonEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(this.getValueComparison());
		g2 = createEGenericType(singlePropValueComparisonEClass_T);
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(this.getElementProperty());
		g1.getETypeArguments().add(g2);
		g3 = createEGenericType(singlePropValueComparisonEClass_ME);
		g2.getETypeArguments().add(g3);
		g3 = createEGenericType(singlePropValueComparisonEClass_T);
		g2.getETypeArguments().add(g3);
		singlePropValueComparisonEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(this.getValueComparison());
		g2 = createEGenericType(twoPropertyValueComparisonEClass_T);
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(this.getTwoPropCalcExpression());
		g1.getETypeArguments().add(g2);
		g3 = createEGenericType(twoPropertyValueComparisonEClass_T);
		g2.getETypeArguments().add(g3);
		g3 = createEGenericType(twoPropertyValueComparisonEClass_LME);
		g2.getETypeArguments().add(g3);
		g3 = createEGenericType(twoPropertyValueComparisonEClass_RME);
		g2.getETypeArguments().add(g3);
		twoPropertyValueComparisonEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(theOperatorsPackage.getArithmeticOp());
		g2 = createEGenericType(twoPropCalcExpressionEClass_T);
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(this.getElementProperty());
		g1.getETypeArguments().add(g2);
		g3 = createEGenericType(twoPropCalcExpressionEClass_LME);
		g2.getETypeArguments().add(g3);
		g3 = createEGenericType(twoPropCalcExpressionEClass_T);
		g2.getETypeArguments().add(g3);
		g2 = createEGenericType(this.getElementProperty());
		g1.getETypeArguments().add(g2);
		g3 = createEGenericType(twoPropCalcExpressionEClass_RME);
		g2.getETypeArguments().add(g3);
		g3 = createEGenericType(twoPropCalcExpressionEClass_T);
		g2.getETypeArguments().add(g3);
		twoPropCalcExpressionEClass.getEGenericSuperTypes().add(g1);

		// Initialize classes and features; add operations and parameters
		initEClass(locationPatternEClass, LocationPattern.class, "LocationPattern", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(elementPropertyEClass, ElementProperty.class, "ElementProperty", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		g1 = createEGenericType(elementPropertyEClass_ME);
		initEReference(getElementProperty_ModelElement(), g1, null, "modelElement", null, 1, 1, ElementProperty.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		g1 = createEGenericType(this.getFunction());
		g2 = createEGenericType(elementPropertyEClass_ME);
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(elementPropertyEClass_T);
		g1.getETypeArguments().add(g2);
		initEAttribute(getElementProperty_PropertyGetter(), g1, "propertyGetter", null, 1, 1, ElementProperty.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		EOperation op = addEOperation(elementPropertyEClass, null, "getProperty", 1, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(elementPropertyEClass_T);
		initEOperation(op, g1);

		initEClass(locationPropertyEClass, LocationProperty.class, "LocationProperty", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		g1 = createEGenericType(theOperatorsPackage.getLocationOp());
		g2 = createEGenericType(locationPropertyEClass_LA);
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(locationPropertyEClass_RA);
		g1.getETypeArguments().add(g2);
		initEReference(getLocationProperty_LocOp(), g1, null, "locOp", null, 1, 1, LocationProperty.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(valueComparisonEClass, ValueComparison.class, "ValueComparison", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(singlePropValueComparisonEClass, SinglePropValueComparison.class, "SinglePropValueComparison", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(twoPropertyValueComparisonEClass, TwoPropertyValueComparison.class, "TwoPropertyValueComparison", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(twoPropCalcExpressionEClass, TwoPropCalcExpression.class, "TwoPropCalcExpression", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		// Initialize data types
		initEDataType(functionEDataType, Function.class, "Function", IS_SERIALIZABLE, !IS_GENERATED_INSTANCE_CLASS);
	}

} //PatternsPackageImpl
