/**
 */
package org.fortiss.af3.exploration.dsl.model.patterns.util;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.util.Switch;

import org.fortiss.af3.exploration.dsl.model.expressions.ArithmeticExpression;
import org.fortiss.af3.exploration.dsl.model.expressions.BooleanExpression;
import org.fortiss.af3.exploration.dsl.model.expressions.ConstraintExpression;
import org.fortiss.af3.exploration.dsl.model.expressions.Expression;

import org.fortiss.af3.exploration.dsl.model.operators.ArithmeticOp;
import org.fortiss.af3.exploration.dsl.model.operators.ComparisonOp;
import org.fortiss.af3.exploration.dsl.model.operators.DualOperator;
import org.fortiss.af3.exploration.dsl.model.operators.Operator;

import org.fortiss.af3.exploration.dsl.model.patterns.*;

import org.fortiss.af3.exploration.dsl.model.types.ArithmeticVariable;
import org.fortiss.af3.exploration.dsl.model.types.Variable;

import org.fortiss.tooling.base.model.element.IModelElement;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see org.fortiss.af3.exploration.dsl.model.patterns.PatternsPackage
 * @generated
 */
public class PatternsSwitch<T1> extends Switch<T1> {
	/**
	 * The cached model package
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static PatternsPackage modelPackage;

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PatternsSwitch() {
		if (modelPackage == null) {
			modelPackage = PatternsPackage.eINSTANCE;
		}
	}

	/**
	 * Checks whether this is a switch for the given package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @parameter ePackage the package in question.
	 * @return whether this is a switch for the given package.
	 * @generated
	 */
	@Override
	protected boolean isSwitchFor(EPackage ePackage) {
		return ePackage == modelPackage;
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	@Override
	protected T1 doSwitch(int classifierID, EObject theEObject) {
		switch (classifierID) {
			case PatternsPackage.LOCATION_PATTERN: {
				LocationPattern<?, ?> locationPattern = (LocationPattern<?, ?>)theEObject;
				T1 result = caseLocationPattern(locationPattern);
				if (result == null) result = caseConstraintExpression(locationPattern);
				if (result == null) result = caseExpression(locationPattern);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case PatternsPackage.ELEMENT_PROPERTY: {
				ElementProperty<?, ?> elementProperty = (ElementProperty<?, ?>)theEObject;
				T1 result = caseElementProperty(elementProperty);
				if (result == null) result = caseArithmeticVariable(elementProperty);
				if (result == null) result = caseVariable(elementProperty);
				if (result == null) result = caseArithmeticExpression(elementProperty);
				if (result == null) result = caseExpression(elementProperty);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case PatternsPackage.LOCATION_PROPERTY: {
				LocationProperty<?, ?, ?> locationProperty = (LocationProperty<?, ?, ?>)theEObject;
				T1 result = caseLocationProperty(locationProperty);
				if (result == null) result = caseArithmeticVariable(locationProperty);
				if (result == null) result = caseVariable(locationProperty);
				if (result == null) result = caseArithmeticExpression(locationProperty);
				if (result == null) result = caseExpression(locationProperty);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case PatternsPackage.VALUE_COMPARISON: {
				ValueComparison<?, ?> valueComparison = (ValueComparison<?, ?>)theEObject;
				T1 result = caseValueComparison(valueComparison);
				if (result == null) result = caseComparisonOp(valueComparison);
				if (result == null) result = caseDualOperator(valueComparison);
				if (result == null) result = caseBooleanExpression(valueComparison);
				if (result == null) result = caseOperator(valueComparison);
				if (result == null) result = caseExpression(valueComparison);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case PatternsPackage.SINGLE_PROP_VALUE_COMPARISON: {
				SinglePropValueComparison<?, ?> singlePropValueComparison = (SinglePropValueComparison<?, ?>)theEObject;
				T1 result = caseSinglePropValueComparison(singlePropValueComparison);
				if (result == null) result = caseValueComparison(singlePropValueComparison);
				if (result == null) result = caseComparisonOp(singlePropValueComparison);
				if (result == null) result = caseDualOperator(singlePropValueComparison);
				if (result == null) result = caseBooleanExpression(singlePropValueComparison);
				if (result == null) result = caseOperator(singlePropValueComparison);
				if (result == null) result = caseExpression(singlePropValueComparison);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case PatternsPackage.TWO_PROPERTY_VALUE_COMPARISON: {
				TwoPropertyValueComparison<?, ?, ?> twoPropertyValueComparison = (TwoPropertyValueComparison<?, ?, ?>)theEObject;
				T1 result = caseTwoPropertyValueComparison(twoPropertyValueComparison);
				if (result == null) result = caseValueComparison(twoPropertyValueComparison);
				if (result == null) result = caseComparisonOp(twoPropertyValueComparison);
				if (result == null) result = caseDualOperator(twoPropertyValueComparison);
				if (result == null) result = caseBooleanExpression(twoPropertyValueComparison);
				if (result == null) result = caseOperator(twoPropertyValueComparison);
				if (result == null) result = caseExpression(twoPropertyValueComparison);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case PatternsPackage.TWO_PROP_CALC_EXPRESSION: {
				TwoPropCalcExpression<?, ?, ?> twoPropCalcExpression = (TwoPropCalcExpression<?, ?, ?>)theEObject;
				T1 result = caseTwoPropCalcExpression(twoPropCalcExpression);
				if (result == null) result = caseArithmeticOp(twoPropCalcExpression);
				if (result == null) result = caseDualOperator(twoPropCalcExpression);
				if (result == null) result = caseArithmeticExpression(twoPropCalcExpression);
				if (result == null) result = caseOperator(twoPropCalcExpression);
				if (result == null) result = caseExpression(twoPropCalcExpression);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			default: return defaultCase(theEObject);
		}
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Location Pattern</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Location Pattern</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public <LHT extends IModelElement, RHT extends IModelElement> T1 caseLocationPattern(LocationPattern<LHT, RHT> object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Element Property</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Element Property</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public <ME extends IModelElement, T> T1 caseElementProperty(ElementProperty<ME, T> object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Location Property</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Location Property</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public <LA extends IModelElement, RA extends IModelElement, T> T1 caseLocationProperty(LocationProperty<LA, RA, T> object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Value Comparison</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Value Comparison</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public <T, AE extends ArithmeticExpression<T>> T1 caseValueComparison(ValueComparison<T, AE> object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Single Prop Value Comparison</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Single Prop Value Comparison</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public <T, ME extends IModelElement> T1 caseSinglePropValueComparison(SinglePropValueComparison<T, ME> object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Two Property Value Comparison</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Two Property Value Comparison</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public <T, LME extends IModelElement, RME extends IModelElement> T1 caseTwoPropertyValueComparison(TwoPropertyValueComparison<T, LME, RME> object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Two Prop Calc Expression</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Two Prop Calc Expression</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public <T, LME extends IModelElement, RME extends IModelElement> T1 caseTwoPropCalcExpression(TwoPropCalcExpression<T, LME, RME> object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Expression</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Expression</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T1 caseExpression(Expression object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Constraint Expression</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Constraint Expression</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public <T extends BooleanExpression> T1 caseConstraintExpression(ConstraintExpression<T> object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Variable</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Variable</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public <T> T1 caseVariable(Variable<T> object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Arithmetic Expression</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Arithmetic Expression</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public <T> T1 caseArithmeticExpression(ArithmeticExpression<T> object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Arithmetic Variable</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Arithmetic Variable</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public <T> T1 caseArithmeticVariable(ArithmeticVariable<T> object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Operator</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Operator</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public <OP, RHT> T1 caseOperator(Operator<OP, RHT> object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Dual Operator</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Dual Operator</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public <LHT, OP, RHT> T1 caseDualOperator(DualOperator<LHT, OP, RHT> object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Boolean Expression</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Boolean Expression</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T1 caseBooleanExpression(BooleanExpression object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Comparison Op</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Comparison Op</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public <T, LHT extends ArithmeticExpression<T>, RHT extends ArithmeticExpression<T>> T1 caseComparisonOp(ComparisonOp<T, LHT, RHT> object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Arithmetic Op</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Arithmetic Op</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public <T, LHE extends ArithmeticExpression<T>, RHE extends ArithmeticExpression<T>> T1 caseArithmeticOp(ArithmeticOp<T, LHE, RHE> object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch, but this is the last case anyway.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject)
	 * @generated
	 */
	@Override
	public T1 defaultCase(EObject object) {
		return null;
	}

} //PatternsSwitch
