/**
 */
package org.fortiss.af3.exploration.dsl.model.types;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;

import org.fortiss.af3.exploration.dsl.model.expressions.ExpressionsPackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see org.fortiss.af3.exploration.dsl.model.types.TypesFactory
 * @model kind="package"
 * @generated
 */
public interface TypesPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "types";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.fortiss.org/af3/exploration/types";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "org-fortiss-af3-exploration-types";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	TypesPackage eINSTANCE = org.fortiss.af3.exploration.dsl.model.types.impl.TypesPackageImpl.init();

	/**
	 * The meta object id for the '{@link org.fortiss.af3.exploration.dsl.model.types.impl.NumberLiteralImpl <em>Number Literal</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.fortiss.af3.exploration.dsl.model.types.impl.NumberLiteralImpl
	 * @see org.fortiss.af3.exploration.dsl.model.types.impl.TypesPackageImpl#getNumberLiteral()
	 * @generated
	 */
	int NUMBER_LITERAL = 0;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NUMBER_LITERAL__VALUE = ExpressionsPackage.ARITHMETIC_EXPRESSION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Number Literal</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NUMBER_LITERAL_FEATURE_COUNT = ExpressionsPackage.ARITHMETIC_EXPRESSION_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link org.fortiss.af3.exploration.dsl.model.types.impl.RealLiteralImpl <em>Real Literal</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.fortiss.af3.exploration.dsl.model.types.impl.RealLiteralImpl
	 * @see org.fortiss.af3.exploration.dsl.model.types.impl.TypesPackageImpl#getRealLiteral()
	 * @generated
	 */
	int REAL_LITERAL = 1;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL_LITERAL__VALUE = NUMBER_LITERAL__VALUE;

	/**
	 * The number of structural features of the '<em>Real Literal</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REAL_LITERAL_FEATURE_COUNT = NUMBER_LITERAL_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.fortiss.af3.exploration.dsl.model.types.impl.IntegerLiteralImpl <em>Integer Literal</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.fortiss.af3.exploration.dsl.model.types.impl.IntegerLiteralImpl
	 * @see org.fortiss.af3.exploration.dsl.model.types.impl.TypesPackageImpl#getIntegerLiteral()
	 * @generated
	 */
	int INTEGER_LITERAL = 2;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTEGER_LITERAL__VALUE = NUMBER_LITERAL__VALUE;

	/**
	 * The number of structural features of the '<em>Integer Literal</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INTEGER_LITERAL_FEATURE_COUNT = NUMBER_LITERAL_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.fortiss.af3.exploration.dsl.model.types.impl.VariableImpl <em>Variable</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.fortiss.af3.exploration.dsl.model.types.impl.VariableImpl
	 * @see org.fortiss.af3.exploration.dsl.model.types.impl.TypesPackageImpl#getVariable()
	 * @generated
	 */
	int VARIABLE = 3;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE__VALUE = 0;

	/**
	 * The number of structural features of the '<em>Variable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link org.fortiss.af3.exploration.dsl.model.types.impl.ArithmeticVariableImpl <em>Arithmetic Variable</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.fortiss.af3.exploration.dsl.model.types.impl.ArithmeticVariableImpl
	 * @see org.fortiss.af3.exploration.dsl.model.types.impl.TypesPackageImpl#getArithmeticVariable()
	 * @generated
	 */
	int ARITHMETIC_VARIABLE = 4;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARITHMETIC_VARIABLE__VALUE = VARIABLE__VALUE;

	/**
	 * The number of structural features of the '<em>Arithmetic Variable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARITHMETIC_VARIABLE_FEATURE_COUNT = VARIABLE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.fortiss.af3.exploration.dsl.model.types.impl.SetTypeImpl <em>Set Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.fortiss.af3.exploration.dsl.model.types.impl.SetTypeImpl
	 * @see org.fortiss.af3.exploration.dsl.model.types.impl.TypesPackageImpl#getSetType()
	 * @generated
	 */
	int SET_TYPE = 5;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_TYPE__VALUE = VARIABLE__VALUE;

	/**
	 * The number of structural features of the '<em>Set Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_TYPE_FEATURE_COUNT = VARIABLE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.fortiss.af3.exploration.dsl.model.types.impl.ModelElementVariableImpl <em>Model Element Variable</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.fortiss.af3.exploration.dsl.model.types.impl.ModelElementVariableImpl
	 * @see org.fortiss.af3.exploration.dsl.model.types.impl.TypesPackageImpl#getModelElementVariable()
	 * @generated
	 */
	int MODEL_ELEMENT_VARIABLE = 6;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ELEMENT_VARIABLE__VALUE = VARIABLE__VALUE;

	/**
	 * The feature id for the '<em><b>Model Element</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ELEMENT_VARIABLE__MODEL_ELEMENT = VARIABLE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Model Element Variable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ELEMENT_VARIABLE_FEATURE_COUNT = VARIABLE_FEATURE_COUNT + 1;


	/**
	 * Returns the meta object for class '{@link org.fortiss.af3.exploration.dsl.model.types.NumberLiteral <em>Number Literal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Number Literal</em>'.
	 * @see org.fortiss.af3.exploration.dsl.model.types.NumberLiteral
	 * @generated
	 */
	EClass getNumberLiteral();

	/**
	 * Returns the meta object for the attribute '{@link org.fortiss.af3.exploration.dsl.model.types.NumberLiteral#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see org.fortiss.af3.exploration.dsl.model.types.NumberLiteral#getValue()
	 * @see #getNumberLiteral()
	 * @generated
	 */
	EAttribute getNumberLiteral_Value();

	/**
	 * Returns the meta object for class '{@link org.fortiss.af3.exploration.dsl.model.types.RealLiteral <em>Real Literal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Real Literal</em>'.
	 * @see org.fortiss.af3.exploration.dsl.model.types.RealLiteral
	 * @generated
	 */
	EClass getRealLiteral();

	/**
	 * Returns the meta object for class '{@link org.fortiss.af3.exploration.dsl.model.types.IntegerLiteral <em>Integer Literal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Integer Literal</em>'.
	 * @see org.fortiss.af3.exploration.dsl.model.types.IntegerLiteral
	 * @generated
	 */
	EClass getIntegerLiteral();

	/**
	 * Returns the meta object for class '{@link org.fortiss.af3.exploration.dsl.model.types.Variable <em>Variable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Variable</em>'.
	 * @see org.fortiss.af3.exploration.dsl.model.types.Variable
	 * @generated
	 */
	EClass getVariable();

	/**
	 * Returns the meta object for the attribute '{@link org.fortiss.af3.exploration.dsl.model.types.Variable#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see org.fortiss.af3.exploration.dsl.model.types.Variable#getValue()
	 * @see #getVariable()
	 * @generated
	 */
	EAttribute getVariable_Value();

	/**
	 * Returns the meta object for class '{@link org.fortiss.af3.exploration.dsl.model.types.ArithmeticVariable <em>Arithmetic Variable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Arithmetic Variable</em>'.
	 * @see org.fortiss.af3.exploration.dsl.model.types.ArithmeticVariable
	 * @generated
	 */
	EClass getArithmeticVariable();

	/**
	 * Returns the meta object for class '{@link org.fortiss.af3.exploration.dsl.model.types.SetType <em>Set Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Set Type</em>'.
	 * @see org.fortiss.af3.exploration.dsl.model.types.SetType
	 * @generated
	 */
	EClass getSetType();

	/**
	 * Returns the meta object for class '{@link org.fortiss.af3.exploration.dsl.model.types.ModelElementVariable <em>Model Element Variable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Model Element Variable</em>'.
	 * @see org.fortiss.af3.exploration.dsl.model.types.ModelElementVariable
	 * @generated
	 */
	EClass getModelElementVariable();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	TypesFactory getTypesFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link org.fortiss.af3.exploration.dsl.model.types.impl.NumberLiteralImpl <em>Number Literal</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.fortiss.af3.exploration.dsl.model.types.impl.NumberLiteralImpl
		 * @see org.fortiss.af3.exploration.dsl.model.types.impl.TypesPackageImpl#getNumberLiteral()
		 * @generated
		 */
		EClass NUMBER_LITERAL = eINSTANCE.getNumberLiteral();

		/**
		 * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute NUMBER_LITERAL__VALUE = eINSTANCE.getNumberLiteral_Value();

		/**
		 * The meta object literal for the '{@link org.fortiss.af3.exploration.dsl.model.types.impl.RealLiteralImpl <em>Real Literal</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.fortiss.af3.exploration.dsl.model.types.impl.RealLiteralImpl
		 * @see org.fortiss.af3.exploration.dsl.model.types.impl.TypesPackageImpl#getRealLiteral()
		 * @generated
		 */
		EClass REAL_LITERAL = eINSTANCE.getRealLiteral();

		/**
		 * The meta object literal for the '{@link org.fortiss.af3.exploration.dsl.model.types.impl.IntegerLiteralImpl <em>Integer Literal</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.fortiss.af3.exploration.dsl.model.types.impl.IntegerLiteralImpl
		 * @see org.fortiss.af3.exploration.dsl.model.types.impl.TypesPackageImpl#getIntegerLiteral()
		 * @generated
		 */
		EClass INTEGER_LITERAL = eINSTANCE.getIntegerLiteral();

		/**
		 * The meta object literal for the '{@link org.fortiss.af3.exploration.dsl.model.types.impl.VariableImpl <em>Variable</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.fortiss.af3.exploration.dsl.model.types.impl.VariableImpl
		 * @see org.fortiss.af3.exploration.dsl.model.types.impl.TypesPackageImpl#getVariable()
		 * @generated
		 */
		EClass VARIABLE = eINSTANCE.getVariable();

		/**
		 * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute VARIABLE__VALUE = eINSTANCE.getVariable_Value();

		/**
		 * The meta object literal for the '{@link org.fortiss.af3.exploration.dsl.model.types.impl.ArithmeticVariableImpl <em>Arithmetic Variable</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.fortiss.af3.exploration.dsl.model.types.impl.ArithmeticVariableImpl
		 * @see org.fortiss.af3.exploration.dsl.model.types.impl.TypesPackageImpl#getArithmeticVariable()
		 * @generated
		 */
		EClass ARITHMETIC_VARIABLE = eINSTANCE.getArithmeticVariable();

		/**
		 * The meta object literal for the '{@link org.fortiss.af3.exploration.dsl.model.types.impl.SetTypeImpl <em>Set Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.fortiss.af3.exploration.dsl.model.types.impl.SetTypeImpl
		 * @see org.fortiss.af3.exploration.dsl.model.types.impl.TypesPackageImpl#getSetType()
		 * @generated
		 */
		EClass SET_TYPE = eINSTANCE.getSetType();

		/**
		 * The meta object literal for the '{@link org.fortiss.af3.exploration.dsl.model.types.impl.ModelElementVariableImpl <em>Model Element Variable</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.fortiss.af3.exploration.dsl.model.types.impl.ModelElementVariableImpl
		 * @see org.fortiss.af3.exploration.dsl.model.types.impl.TypesPackageImpl#getModelElementVariable()
		 * @generated
		 */
		EClass MODEL_ELEMENT_VARIABLE = eINSTANCE.getModelElementVariable();

	}

} //TypesPackage
