/**
 */
package org.fortiss.af3.exploration.model;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see org.fortiss.af3.exploration.model.CommonFactory
 * @model kind="package"
 * @generated
 */
public interface CommonPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "model";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.fortiss.org/af3/exploration/common";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "org-fortiss-af3-exploration-common";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	CommonPackage eINSTANCE = org.fortiss.af3.exploration.model.impl.CommonPackageImpl.init();

	/**
	 * The meta object id for the '{@link org.fortiss.af3.exploration.model.MOExplorationObjective <em>MO Exploration Objective</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.fortiss.af3.exploration.model.MOExplorationObjective
	 * @see org.fortiss.af3.exploration.model.impl.CommonPackageImpl#getMOExplorationObjective()
	 * @generated
	 */
	int MO_EXPLORATION_OBJECTIVE = 0;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MO_EXPLORATION_OBJECTIVE__ID = ExplorationPackage.EXPLORATION_OBJECTIVE__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MO_EXPLORATION_OBJECTIVE__NAME = ExplorationPackage.EXPLORATION_OBJECTIVE__NAME;

	/**
	 * The feature id for the '<em><b>Comment</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MO_EXPLORATION_OBJECTIVE__COMMENT = ExplorationPackage.EXPLORATION_OBJECTIVE__COMMENT;

	/**
	 * The feature id for the '<em><b>Priority</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MO_EXPLORATION_OBJECTIVE__PRIORITY = ExplorationPackage.EXPLORATION_OBJECTIVE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>MO Exploration Objective</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MO_EXPLORATION_OBJECTIVE_FEATURE_COUNT = ExplorationPackage.EXPLORATION_OBJECTIVE_FEATURE_COUNT + 1;


	/**
	 * Returns the meta object for class '{@link org.fortiss.af3.exploration.model.MOExplorationObjective <em>MO Exploration Objective</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>MO Exploration Objective</em>'.
	 * @see org.fortiss.af3.exploration.model.MOExplorationObjective
	 * @generated
	 */
	EClass getMOExplorationObjective();

	/**
	 * Returns the meta object for the attribute '{@link org.fortiss.af3.exploration.model.MOExplorationObjective#getPriority <em>Priority</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Priority</em>'.
	 * @see org.fortiss.af3.exploration.model.MOExplorationObjective#getPriority()
	 * @see #getMOExplorationObjective()
	 * @generated
	 */
	EAttribute getMOExplorationObjective_Priority();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	CommonFactory getCommonFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link org.fortiss.af3.exploration.model.MOExplorationObjective <em>MO Exploration Objective</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.fortiss.af3.exploration.model.MOExplorationObjective
		 * @see org.fortiss.af3.exploration.model.impl.CommonPackageImpl#getMOExplorationObjective()
		 * @generated
		 */
		EClass MO_EXPLORATION_OBJECTIVE = eINSTANCE.getMOExplorationObjective();

		/**
		 * The meta object literal for the '<em><b>Priority</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MO_EXPLORATION_OBJECTIVE__PRIORITY = eINSTANCE.getMOExplorationObjective_Priority();

	}

} //CommonPackage
