/**
 */
package org.fortiss.af3.exploration.model.location;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;

import org.fortiss.af3.exploration.model.ExplorationPackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see org.fortiss.af3.exploration.model.location.LocationFactory
 * @model kind="package"
 * @generated
 */
public interface LocationPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "location";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.fortiss.org/af3/exploration/common/location";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "org-fortiss-af3-exploration-common-location";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	LocationPackage eINSTANCE = org.fortiss.af3.exploration.model.location.impl.LocationPackageImpl.init();

	/**
	 * The meta object id for the '{@link org.fortiss.af3.exploration.model.location.LocationDimension <em>Dimension</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.fortiss.af3.exploration.model.location.LocationDimension
	 * @see org.fortiss.af3.exploration.model.location.impl.LocationPackageImpl#getLocationDimension()
	 * @generated
	 */
	int LOCATION_DIMENSION = 0;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOCATION_DIMENSION__ID = ExplorationPackage.IPROBLEM_DIMENSION__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOCATION_DIMENSION__NAME = ExplorationPackage.IPROBLEM_DIMENSION__NAME;

	/**
	 * The feature id for the '<em><b>Comment</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOCATION_DIMENSION__COMMENT = ExplorationPackage.IPROBLEM_DIMENSION__COMMENT;

	/**
	 * The number of structural features of the '<em>Dimension</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOCATION_DIMENSION_FEATURE_COUNT = ExplorationPackage.IPROBLEM_DIMENSION_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.fortiss.af3.exploration.model.location.impl.LocationConstraintImpl <em>Constraint</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.fortiss.af3.exploration.model.location.impl.LocationConstraintImpl
	 * @see org.fortiss.af3.exploration.model.location.impl.LocationPackageImpl#getLocationConstraint()
	 * @generated
	 */
	int LOCATION_CONSTRAINT = 1;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOCATION_CONSTRAINT__ID = LOCATION_DIMENSION__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOCATION_CONSTRAINT__NAME = LOCATION_DIMENSION__NAME;

	/**
	 * The feature id for the '<em><b>Comment</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOCATION_CONSTRAINT__COMMENT = LOCATION_DIMENSION__COMMENT;

	/**
	 * The feature id for the '<em><b>Expression</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOCATION_CONSTRAINT__EXPRESSION = LOCATION_DIMENSION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Constraint</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOCATION_CONSTRAINT_FEATURE_COUNT = LOCATION_DIMENSION_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link org.fortiss.af3.exploration.model.location.impl.ComponentAllocationConstraintImpl <em>Component Allocation Constraint</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.fortiss.af3.exploration.model.location.impl.ComponentAllocationConstraintImpl
	 * @see org.fortiss.af3.exploration.model.location.impl.LocationPackageImpl#getComponentAllocationConstraint()
	 * @generated
	 */
	int COMPONENT_ALLOCATION_CONSTRAINT = 2;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_ALLOCATION_CONSTRAINT__ID = LOCATION_CONSTRAINT__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_ALLOCATION_CONSTRAINT__NAME = LOCATION_CONSTRAINT__NAME;

	/**
	 * The feature id for the '<em><b>Comment</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_ALLOCATION_CONSTRAINT__COMMENT = LOCATION_CONSTRAINT__COMMENT;

	/**
	 * The feature id for the '<em><b>Expression</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_ALLOCATION_CONSTRAINT__EXPRESSION = LOCATION_CONSTRAINT__EXPRESSION;

	/**
	 * The feature id for the '<em><b>Is Soft</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_ALLOCATION_CONSTRAINT__IS_SOFT = LOCATION_CONSTRAINT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Implicit</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_ALLOCATION_CONSTRAINT__IMPLICIT = LOCATION_CONSTRAINT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Component Allocation Constraint</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_ALLOCATION_CONSTRAINT_FEATURE_COUNT = LOCATION_CONSTRAINT_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link org.fortiss.af3.exploration.model.location.impl.ComponentDislocationConstraintImpl <em>Component Dislocation Constraint</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.fortiss.af3.exploration.model.location.impl.ComponentDislocationConstraintImpl
	 * @see org.fortiss.af3.exploration.model.location.impl.LocationPackageImpl#getComponentDislocationConstraint()
	 * @generated
	 */
	int COMPONENT_DISLOCATION_CONSTRAINT = 3;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_DISLOCATION_CONSTRAINT__ID = LOCATION_CONSTRAINT__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_DISLOCATION_CONSTRAINT__NAME = LOCATION_CONSTRAINT__NAME;

	/**
	 * The feature id for the '<em><b>Comment</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_DISLOCATION_CONSTRAINT__COMMENT = LOCATION_CONSTRAINT__COMMENT;

	/**
	 * The feature id for the '<em><b>Expression</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_DISLOCATION_CONSTRAINT__EXPRESSION = LOCATION_CONSTRAINT__EXPRESSION;

	/**
	 * The feature id for the '<em><b>Is Soft</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_DISLOCATION_CONSTRAINT__IS_SOFT = LOCATION_CONSTRAINT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Implicit</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_DISLOCATION_CONSTRAINT__IMPLICIT = LOCATION_CONSTRAINT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Component Dislocation Constraint</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_DISLOCATION_CONSTRAINT_FEATURE_COUNT = LOCATION_CONSTRAINT_FEATURE_COUNT + 2;


	/**
	 * Returns the meta object for class '{@link org.fortiss.af3.exploration.model.location.LocationDimension <em>Dimension</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Dimension</em>'.
	 * @see org.fortiss.af3.exploration.model.location.LocationDimension
	 * @generated
	 */
	EClass getLocationDimension();

	/**
	 * Returns the meta object for class '{@link org.fortiss.af3.exploration.model.location.LocationConstraint <em>Constraint</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Constraint</em>'.
	 * @see org.fortiss.af3.exploration.model.location.LocationConstraint
	 * @generated
	 */
	EClass getLocationConstraint();

	/**
	 * Returns the meta object for class '{@link org.fortiss.af3.exploration.model.location.ComponentAllocationConstraint <em>Component Allocation Constraint</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Component Allocation Constraint</em>'.
	 * @see org.fortiss.af3.exploration.model.location.ComponentAllocationConstraint
	 * @generated
	 */
	EClass getComponentAllocationConstraint();

	/**
	 * Returns the meta object for class '{@link org.fortiss.af3.exploration.model.location.ComponentDislocationConstraint <em>Component Dislocation Constraint</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Component Dislocation Constraint</em>'.
	 * @see org.fortiss.af3.exploration.model.location.ComponentDislocationConstraint
	 * @generated
	 */
	EClass getComponentDislocationConstraint();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	LocationFactory getLocationFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link org.fortiss.af3.exploration.model.location.LocationDimension <em>Dimension</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.fortiss.af3.exploration.model.location.LocationDimension
		 * @see org.fortiss.af3.exploration.model.location.impl.LocationPackageImpl#getLocationDimension()
		 * @generated
		 */
		EClass LOCATION_DIMENSION = eINSTANCE.getLocationDimension();

		/**
		 * The meta object literal for the '{@link org.fortiss.af3.exploration.model.location.impl.LocationConstraintImpl <em>Constraint</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.fortiss.af3.exploration.model.location.impl.LocationConstraintImpl
		 * @see org.fortiss.af3.exploration.model.location.impl.LocationPackageImpl#getLocationConstraint()
		 * @generated
		 */
		EClass LOCATION_CONSTRAINT = eINSTANCE.getLocationConstraint();

		/**
		 * The meta object literal for the '{@link org.fortiss.af3.exploration.model.location.impl.ComponentAllocationConstraintImpl <em>Component Allocation Constraint</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.fortiss.af3.exploration.model.location.impl.ComponentAllocationConstraintImpl
		 * @see org.fortiss.af3.exploration.model.location.impl.LocationPackageImpl#getComponentAllocationConstraint()
		 * @generated
		 */
		EClass COMPONENT_ALLOCATION_CONSTRAINT = eINSTANCE.getComponentAllocationConstraint();

		/**
		 * The meta object literal for the '{@link org.fortiss.af3.exploration.model.location.impl.ComponentDislocationConstraintImpl <em>Component Dislocation Constraint</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.fortiss.af3.exploration.model.location.impl.ComponentDislocationConstraintImpl
		 * @see org.fortiss.af3.exploration.model.location.impl.LocationPackageImpl#getComponentDislocationConstraint()
		 * @generated
		 */
		EClass COMPONENT_DISLOCATION_CONSTRAINT = eINSTANCE.getComponentDislocationConstraint();

	}

} //LocationPackage
