/**
 */
package org.fortiss.af3.exploration.model.location.impl;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EGenericType;
import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.ETypeParameter;

import org.eclipse.emf.ecore.impl.EPackageImpl;

import org.fortiss.af3.component.model.AF3ComponentPackage;

import org.fortiss.af3.exploration.dsl.model.ModelPackage;

import org.fortiss.af3.exploration.model.CommonPackage;
import org.fortiss.af3.exploration.model.ExplorationPackage;

import org.fortiss.af3.exploration.model.impl.CommonPackageImpl;

import org.fortiss.af3.exploration.model.location.ComponentAllocationConstraint;
import org.fortiss.af3.exploration.model.location.ComponentDislocationConstraint;
import org.fortiss.af3.exploration.model.location.LocationConstraint;
import org.fortiss.af3.exploration.model.location.LocationDimension;
import org.fortiss.af3.exploration.model.location.LocationFactory;
import org.fortiss.af3.exploration.model.location.LocationPackage;

import org.fortiss.af3.exploration.model.time.TimePackage;

import org.fortiss.af3.exploration.model.time.impl.TimePackageImpl;

import org.fortiss.af3.platform.model.AF3PlatformPackage;

import org.fortiss.tooling.base.model.element.ElementPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class LocationPackageImpl extends EPackageImpl implements LocationPackage {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass locationDimensionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass locationConstraintEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass componentAllocationConstraintEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass componentDislocationConstraintEClass = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see org.fortiss.af3.exploration.model.location.LocationPackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private LocationPackageImpl() {
		super(eNS_URI, LocationFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
	 * 
	 * <p>This method is used to initialize {@link LocationPackage#eINSTANCE} when that field is accessed.
	 * Clients should not invoke it directly. Instead, they should simply access that field to obtain the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
	public static LocationPackage init() {
		if (isInited) return (LocationPackage)EPackage.Registry.INSTANCE.getEPackage(LocationPackage.eNS_URI);

		// Obtain or create and register package
		LocationPackageImpl theLocationPackage = (LocationPackageImpl)(EPackage.Registry.INSTANCE.get(eNS_URI) instanceof LocationPackageImpl ? EPackage.Registry.INSTANCE.get(eNS_URI) : new LocationPackageImpl());

		isInited = true;

		// Initialize simple dependencies
		ModelPackage.eINSTANCE.eClass();
		ExplorationPackage.eINSTANCE.eClass();

		// Obtain or create and register interdependencies
		CommonPackageImpl theCommonPackage = (CommonPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(CommonPackage.eNS_URI) instanceof CommonPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(CommonPackage.eNS_URI) : CommonPackage.eINSTANCE);
		TimePackageImpl theTimePackage = (TimePackageImpl)(EPackage.Registry.INSTANCE.getEPackage(TimePackage.eNS_URI) instanceof TimePackageImpl ? EPackage.Registry.INSTANCE.getEPackage(TimePackage.eNS_URI) : TimePackage.eINSTANCE);

		// Create package meta-data objects
		theLocationPackage.createPackageContents();
		theCommonPackage.createPackageContents();
		theTimePackage.createPackageContents();

		// Initialize created meta-data
		theLocationPackage.initializePackageContents();
		theCommonPackage.initializePackageContents();
		theTimePackage.initializePackageContents();

		// Mark meta-data to indicate it can't be changed
		theLocationPackage.freeze();

  
		// Update the registry and return the package
		EPackage.Registry.INSTANCE.put(LocationPackage.eNS_URI, theLocationPackage);
		return theLocationPackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getLocationDimension() {
		return locationDimensionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getLocationConstraint() {
		return locationConstraintEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getComponentAllocationConstraint() {
		return componentAllocationConstraintEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getComponentDislocationConstraint() {
		return componentDislocationConstraintEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public LocationFactory getLocationFactory() {
		return (LocationFactory)getEFactoryInstance();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isCreated = false;

	/**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void createPackageContents() {
		if (isCreated) return;
		isCreated = true;

		// Create classes and their features
		locationDimensionEClass = createEClass(LOCATION_DIMENSION);

		locationConstraintEClass = createEClass(LOCATION_CONSTRAINT);

		componentAllocationConstraintEClass = createEClass(COMPONENT_ALLOCATION_CONSTRAINT);

		componentDislocationConstraintEClass = createEClass(COMPONENT_DISLOCATION_CONSTRAINT);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isInitialized = false;

	/**
	 * Complete the initialization of the package and its meta-model.  This
	 * method is guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void initializePackageContents() {
		if (isInitialized) return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Obtain other dependent packages
		ExplorationPackage theExplorationPackage = (ExplorationPackage)EPackage.Registry.INSTANCE.getEPackage(ExplorationPackage.eNS_URI);
		ElementPackage theElementPackage = (ElementPackage)EPackage.Registry.INSTANCE.getEPackage(ElementPackage.eNS_URI);
		ModelPackage theModelPackage = (ModelPackage)EPackage.Registry.INSTANCE.getEPackage(ModelPackage.eNS_URI);
		AF3ComponentPackage theAF3ComponentPackage = (AF3ComponentPackage)EPackage.Registry.INSTANCE.getEPackage(AF3ComponentPackage.eNS_URI);
		AF3PlatformPackage theAF3PlatformPackage = (AF3PlatformPackage)EPackage.Registry.INSTANCE.getEPackage(AF3PlatformPackage.eNS_URI);

		// Create type parameters
		ETypeParameter locationConstraintEClass_LHT = addETypeParameter(locationConstraintEClass, "LHT");
		ETypeParameter locationConstraintEClass_RHT = addETypeParameter(locationConstraintEClass, "RHT");

		// Set bounds for type parameters
		EGenericType g1 = createEGenericType(theElementPackage.getIModelElement());
		locationConstraintEClass_LHT.getEBounds().add(g1);
		g1 = createEGenericType(theElementPackage.getIModelElement());
		locationConstraintEClass_RHT.getEBounds().add(g1);

		// Add supertypes to classes
		locationDimensionEClass.getESuperTypes().add(theExplorationPackage.getIProblemDimension());
		locationConstraintEClass.getESuperTypes().add(this.getLocationDimension());
		locationConstraintEClass.getESuperTypes().add(theModelPackage.getMOEAExplorationExpression());
		g1 = createEGenericType(this.getLocationConstraint());
		EGenericType g2 = createEGenericType(theAF3ComponentPackage.getComponent());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(theAF3PlatformPackage.getExecutionUnit());
		g1.getETypeArguments().add(g2);
		componentAllocationConstraintEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(theExplorationPackage.getExplorationConstraint());
		g2 = createEGenericType(ecorePackage.getEBooleanObject());
		g1.getETypeArguments().add(g2);
		componentAllocationConstraintEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(this.getLocationConstraint());
		g2 = createEGenericType(theAF3ComponentPackage.getComponent());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(theAF3PlatformPackage.getExecutionUnit());
		g1.getETypeArguments().add(g2);
		componentDislocationConstraintEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(theExplorationPackage.getExplorationConstraint());
		g2 = createEGenericType(ecorePackage.getEBooleanObject());
		g1.getETypeArguments().add(g2);
		componentDislocationConstraintEClass.getEGenericSuperTypes().add(g1);

		// Initialize classes and features; add operations and parameters
		initEClass(locationDimensionEClass, LocationDimension.class, "LocationDimension", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(locationConstraintEClass, LocationConstraint.class, "LocationConstraint", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		EOperation op = addEOperation(locationConstraintEClass, null, "getLeftModelElement", 1, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(locationConstraintEClass_LHT);
		initEOperation(op, g1);

		op = addEOperation(locationConstraintEClass, null, "getRightModelElement", 1, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(locationConstraintEClass_RHT);
		initEOperation(op, g1);

		initEClass(componentAllocationConstraintEClass, ComponentAllocationConstraint.class, "ComponentAllocationConstraint", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(componentDislocationConstraintEClass, ComponentDislocationConstraint.class, "ComponentDislocationConstraint", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
	}

} //LocationPackageImpl
