/**
 */
package org.fortiss.af3.exploration.model.time.impl;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EGenericType;
import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EPackageImpl;

import org.fortiss.af3.component.model.AF3ComponentPackage;

import org.fortiss.af3.exploration.dsl.model.ModelPackage;

import org.fortiss.af3.exploration.dsl.model.expressions.ExpressionsPackage;

import org.fortiss.af3.exploration.dsl.model.operators.OperatorsPackage;

import org.fortiss.af3.exploration.dsl.model.types.TypesPackage;

import org.fortiss.af3.exploration.model.CommonPackage;
import org.fortiss.af3.exploration.model.ExplorationPackage;

import org.fortiss.af3.exploration.model.impl.CommonPackageImpl;

import org.fortiss.af3.exploration.model.location.LocationPackage;

import org.fortiss.af3.exploration.model.location.impl.LocationPackageImpl;

import org.fortiss.af3.exploration.model.time.DeadlineComp;
import org.fortiss.af3.exploration.model.time.DeadlineConstraint;
import org.fortiss.af3.exploration.model.time.LatencyCalc;
import org.fortiss.af3.exploration.model.time.PeriodConstraint;
import org.fortiss.af3.exploration.model.time.TimeDimension;
import org.fortiss.af3.exploration.model.time.TimeFactory;
import org.fortiss.af3.exploration.model.time.TimePackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class TimePackageImpl extends EPackageImpl implements TimePackage {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass timeDimensionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass deadlineConstraintEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass latencyCalcEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass deadlineCompEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass periodConstraintEClass = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see org.fortiss.af3.exploration.model.time.TimePackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private TimePackageImpl() {
		super(eNS_URI, TimeFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
	 * 
	 * <p>This method is used to initialize {@link TimePackage#eINSTANCE} when that field is accessed.
	 * Clients should not invoke it directly. Instead, they should simply access that field to obtain the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
	public static TimePackage init() {
		if (isInited) return (TimePackage)EPackage.Registry.INSTANCE.getEPackage(TimePackage.eNS_URI);

		// Obtain or create and register package
		TimePackageImpl theTimePackage = (TimePackageImpl)(EPackage.Registry.INSTANCE.get(eNS_URI) instanceof TimePackageImpl ? EPackage.Registry.INSTANCE.get(eNS_URI) : new TimePackageImpl());

		isInited = true;

		// Initialize simple dependencies
		ModelPackage.eINSTANCE.eClass();
		ExplorationPackage.eINSTANCE.eClass();

		// Obtain or create and register interdependencies
		CommonPackageImpl theCommonPackage = (CommonPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(CommonPackage.eNS_URI) instanceof CommonPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(CommonPackage.eNS_URI) : CommonPackage.eINSTANCE);
		LocationPackageImpl theLocationPackage = (LocationPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(LocationPackage.eNS_URI) instanceof LocationPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(LocationPackage.eNS_URI) : LocationPackage.eINSTANCE);

		// Create package meta-data objects
		theTimePackage.createPackageContents();
		theCommonPackage.createPackageContents();
		theLocationPackage.createPackageContents();

		// Initialize created meta-data
		theTimePackage.initializePackageContents();
		theCommonPackage.initializePackageContents();
		theLocationPackage.initializePackageContents();

		// Mark meta-data to indicate it can't be changed
		theTimePackage.freeze();

  
		// Update the registry and return the package
		EPackage.Registry.INSTANCE.put(TimePackage.eNS_URI, theTimePackage);
		return theTimePackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTimeDimension() {
		return timeDimensionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDeadlineConstraint() {
		return deadlineConstraintEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getLatencyCalc() {
		return latencyCalcEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDeadlineComp() {
		return deadlineCompEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getPeriodConstraint() {
		return periodConstraintEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TimeFactory getTimeFactory() {
		return (TimeFactory)getEFactoryInstance();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isCreated = false;

	/**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void createPackageContents() {
		if (isCreated) return;
		isCreated = true;

		// Create classes and their features
		timeDimensionEClass = createEClass(TIME_DIMENSION);

		deadlineConstraintEClass = createEClass(DEADLINE_CONSTRAINT);

		latencyCalcEClass = createEClass(LATENCY_CALC);

		deadlineCompEClass = createEClass(DEADLINE_COMP);

		periodConstraintEClass = createEClass(PERIOD_CONSTRAINT);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isInitialized = false;

	/**
	 * Complete the initialization of the package and its meta-model.  This
	 * method is guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void initializePackageContents() {
		if (isInitialized) return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Obtain other dependent packages
		ExplorationPackage theExplorationPackage = (ExplorationPackage)EPackage.Registry.INSTANCE.getEPackage(ExplorationPackage.eNS_URI);
		ModelPackage theModelPackage = (ModelPackage)EPackage.Registry.INSTANCE.getEPackage(ModelPackage.eNS_URI);
		AF3ComponentPackage theAF3ComponentPackage = (AF3ComponentPackage)EPackage.Registry.INSTANCE.getEPackage(AF3ComponentPackage.eNS_URI);
		ExpressionsPackage theExpressionsPackage = (ExpressionsPackage)EPackage.Registry.INSTANCE.getEPackage(ExpressionsPackage.eNS_URI);
		OperatorsPackage theOperatorsPackage = (OperatorsPackage)EPackage.Registry.INSTANCE.getEPackage(OperatorsPackage.eNS_URI);
		TypesPackage theTypesPackage = (TypesPackage)EPackage.Registry.INSTANCE.getEPackage(TypesPackage.eNS_URI);

		// Create type parameters

		// Set bounds for type parameters

		// Add supertypes to classes
		timeDimensionEClass.getESuperTypes().add(theExplorationPackage.getIProblemDimension());
		EGenericType g1 = createEGenericType(this.getTimeDimension());
		deadlineConstraintEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(theExplorationPackage.getExplorationConstraint());
		EGenericType g2 = createEGenericType(ecorePackage.getEDoubleObject());
		g1.getETypeArguments().add(g2);
		deadlineConstraintEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(theModelPackage.getMOEAExplorationExpression());
		deadlineConstraintEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(theExpressionsPackage.getArithmeticExpression());
		g2 = createEGenericType(ecorePackage.getEDoubleObject());
		g1.getETypeArguments().add(g2);
		latencyCalcEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(theOperatorsPackage.getComparisonOp());
		g2 = createEGenericType(ecorePackage.getEDoubleObject());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(this.getLatencyCalc());
		g1.getETypeArguments().add(g2);
		g2 = createEGenericType(theTypesPackage.getNumberLiteral());
		g1.getETypeArguments().add(g2);
		EGenericType g3 = createEGenericType(ecorePackage.getEDoubleObject());
		g2.getETypeArguments().add(g3);
		deadlineCompEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(this.getTimeDimension());
		periodConstraintEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(theExplorationPackage.getExplorationConstraint());
		g2 = createEGenericType(ecorePackage.getEDoubleObject());
		g1.getETypeArguments().add(g2);
		periodConstraintEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(theModelPackage.getMOEAExplorationExpression());
		periodConstraintEClass.getEGenericSuperTypes().add(g1);

		// Initialize classes and features; add operations and parameters
		initEClass(timeDimensionEClass, TimeDimension.class, "TimeDimension", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(deadlineConstraintEClass, DeadlineConstraint.class, "DeadlineConstraint", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		addEOperation(deadlineConstraintEClass, ecorePackage.getEDoubleObject(), "getLimitation", 1, 1, IS_UNIQUE, IS_ORDERED);

		addEOperation(deadlineConstraintEClass, theAF3ComponentPackage.getComponent(), "getStartComponent", 1, 1, IS_UNIQUE, IS_ORDERED);

		EOperation op = addEOperation(deadlineConstraintEClass, null, "setStartComponent", 1, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theAF3ComponentPackage.getComponent(), "component", 1, 1, IS_UNIQUE, IS_ORDERED);

		addEOperation(deadlineConstraintEClass, theAF3ComponentPackage.getComponent(), "getEndComponent", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(deadlineConstraintEClass, null, "setEndComponent", 1, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theAF3ComponentPackage.getComponent(), "component", 1, 1, IS_UNIQUE, IS_ORDERED);

		addEOperation(deadlineConstraintEClass, ecorePackage.getEDoubleObject(), "getDeadline", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(deadlineConstraintEClass, null, "setDeadline", 1, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDoubleObject(), "period", 1, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(latencyCalcEClass, LatencyCalc.class, "LatencyCalc", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(deadlineCompEClass, DeadlineComp.class, "DeadlineComp", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(periodConstraintEClass, PeriodConstraint.class, "PeriodConstraint", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		addEOperation(periodConstraintEClass, ecorePackage.getEDoubleObject(), "getLimitation", 1, 1, IS_UNIQUE, IS_ORDERED);

		addEOperation(periodConstraintEClass, theAF3ComponentPackage.getComponent(), "getComponent", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(periodConstraintEClass, null, "setComponent", 1, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theAF3ComponentPackage.getComponent(), "component", 1, 1, IS_UNIQUE, IS_ORDERED);

		addEOperation(periodConstraintEClass, ecorePackage.getEDoubleObject(), "getPeriod", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = addEOperation(periodConstraintEClass, null, "setPeriod", 1, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEDoubleObject(), "period", 1, 1, IS_UNIQUE, IS_ORDERED);
	}

} //TimePackageImpl
