/**
 */
package org.fortiss.af3.exploration.moea.model;

import org.eclipse.emf.common.util.EList;

import org.fortiss.af3.exploration.model.ExplorationSpecification;
import org.fortiss.af3.exploration.model.IExplorationFeature;

import org.fortiss.af3.exploration.moea.model.parameters.IOptimizer;
import org.fortiss.af3.exploration.moea.model.parameters.SystemParameters;

import org.fortiss.tooling.kernel.model.INamedCommentedElement;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Dse Specification</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * Contains the selected {@link IOptimizer}, the {@link SystemParameter}s, and the {@link ExplorationSpecification} that define a particular DSE problemn.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.fortiss.af3.exploration.moea.model.DseSpecification#getFeatures <em>Features</em>}</li>
 *   <li>{@link org.fortiss.af3.exploration.moea.model.DseSpecification#getOptimizer <em>Optimizer</em>}</li>
 *   <li>{@link org.fortiss.af3.exploration.moea.model.DseSpecification#getParameters <em>Parameters</em>}</li>
 *   <li>{@link org.fortiss.af3.exploration.moea.model.DseSpecification#getTargetSpecification <em>Target Specification</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.fortiss.af3.exploration.moea.model.MoeaPackage#getDseSpecification()
 * @model
 * @generated
 */
public interface DseSpecification extends INamedCommentedElement {
	/**
	 * Returns the value of the '<em><b>Features</b></em>' containment reference list.
	 * The list contents are of type {@link org.fortiss.af3.exploration.model.IExplorationFeature}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Features</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Features</em>' containment reference list.
	 * @see org.fortiss.af3.exploration.moea.model.MoeaPackage#getDseSpecification_Features()
	 * @model containment="true" resolveProxies="true" required="true"
	 * @generated
	 */
	EList<IExplorationFeature> getFeatures();

	/**
	 * Returns the value of the '<em><b>Optimizer</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Selected {@link IOptimizer} that is used to perform the DSE.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Optimizer</em>' containment reference.
	 * @see #setOptimizer(IOptimizer)
	 * @see org.fortiss.af3.exploration.moea.model.MoeaPackage#getDseSpecification_Optimizer()
	 * @model containment="true" resolveProxies="true" required="true"
	 * @generated
	 */
	IOptimizer getOptimizer();

	/**
	 * Sets the value of the '{@link org.fortiss.af3.exploration.moea.model.DseSpecification#getOptimizer <em>Optimizer</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Optimizer</em>' containment reference.
	 * @see #getOptimizer()
	 * @generated
	 */
	void setOptimizer(IOptimizer value);

	/**
	 * Returns the value of the '<em><b>Parameters</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * {@link SystemParameters} that must be considered during the DSE.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Parameters</em>' containment reference.
	 * @see #setParameters(SystemParameters)
	 * @see org.fortiss.af3.exploration.moea.model.MoeaPackage#getDseSpecification_Parameters()
	 * @model containment="true" resolveProxies="true" required="true"
	 * @generated
	 */
	SystemParameters getParameters();

	/**
	 * Sets the value of the '{@link org.fortiss.af3.exploration.moea.model.DseSpecification#getParameters <em>Parameters</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Parameters</em>' containment reference.
	 * @see #getParameters()
	 * @generated
	 */
	void setParameters(SystemParameters value);

	/**
	 * Returns the value of the '<em><b>Target Specification</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Specification of the {@link ExplorationTarget}s, i.e., objectives and constraints, which define the optima and the feasible reagin for the DSE problem.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Target Specification</em>' containment reference.
	 * @see #setTargetSpecification(ExplorationSpecification)
	 * @see org.fortiss.af3.exploration.moea.model.MoeaPackage#getDseSpecification_TargetSpecification()
	 * @model containment="true" resolveProxies="true" required="true"
	 * @generated
	 */
	ExplorationSpecification getTargetSpecification();

	/**
	 * Sets the value of the '{@link org.fortiss.af3.exploration.moea.model.DseSpecification#getTargetSpecification <em>Target Specification</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Target Specification</em>' containment reference.
	 * @see #getTargetSpecification()
	 * @generated
	 */
	void setTargetSpecification(ExplorationSpecification value);

} // DseSpecification
