/**
 */
package org.fortiss.af3.exploration.moea.model;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

import org.fortiss.tooling.base.model.element.ElementPackage;

import org.fortiss.tooling.kernel.model.FortissToolingKernelPackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see org.fortiss.af3.exploration.moea.model.MoeaFactory
 * @model kind="package"
 * @generated
 */
public interface MoeaPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "model";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.fortiss.org/af3/exploration/moea";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "org-fortiss-af3-exploration-moea";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	MoeaPackage eINSTANCE = org.fortiss.af3.exploration.moea.model.impl.MoeaPackageImpl.init();

	/**
	 * The meta object id for the '{@link org.fortiss.af3.exploration.moea.model.impl.ExplorationManagerImpl <em>Exploration Manager</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.fortiss.af3.exploration.moea.model.impl.ExplorationManagerImpl
	 * @see org.fortiss.af3.exploration.moea.model.impl.MoeaPackageImpl#getExplorationManager()
	 * @generated
	 */
	int EXPLORATION_MANAGER = 0;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLORATION_MANAGER__ID = FortissToolingKernelPackage.IPROJECT_ROOT_ELEMENT__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLORATION_MANAGER__NAME = FortissToolingKernelPackage.IPROJECT_ROOT_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Comment</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLORATION_MANAGER__COMMENT = FortissToolingKernelPackage.IPROJECT_ROOT_ELEMENT__COMMENT;

	/**
	 * The feature id for the '<em><b>Dse Specifications</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLORATION_MANAGER__DSE_SPECIFICATIONS = FortissToolingKernelPackage.IPROJECT_ROOT_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Exploration Manager</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLORATION_MANAGER_FEATURE_COUNT = FortissToolingKernelPackage.IPROJECT_ROOT_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link org.fortiss.af3.exploration.moea.model.impl.DseSpecificationImpl <em>Dse Specification</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.fortiss.af3.exploration.moea.model.impl.DseSpecificationImpl
	 * @see org.fortiss.af3.exploration.moea.model.impl.MoeaPackageImpl#getDseSpecification()
	 * @generated
	 */
	int DSE_SPECIFICATION = 1;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DSE_SPECIFICATION__ID = FortissToolingKernelPackage.INAMED_COMMENTED_ELEMENT__ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DSE_SPECIFICATION__NAME = FortissToolingKernelPackage.INAMED_COMMENTED_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Comment</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DSE_SPECIFICATION__COMMENT = FortissToolingKernelPackage.INAMED_COMMENTED_ELEMENT__COMMENT;

	/**
	 * The feature id for the '<em><b>Features</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DSE_SPECIFICATION__FEATURES = FortissToolingKernelPackage.INAMED_COMMENTED_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Optimizer</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DSE_SPECIFICATION__OPTIMIZER = FortissToolingKernelPackage.INAMED_COMMENTED_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Parameters</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DSE_SPECIFICATION__PARAMETERS = FortissToolingKernelPackage.INAMED_COMMENTED_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Target Specification</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DSE_SPECIFICATION__TARGET_SPECIFICATION = FortissToolingKernelPackage.INAMED_COMMENTED_ELEMENT_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Dse Specification</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DSE_SPECIFICATION_FEATURE_COUNT = FortissToolingKernelPackage.INAMED_COMMENTED_ELEMENT_FEATURE_COUNT + 4;

	/**
	 * The meta object id for the '{@link org.fortiss.af3.exploration.moea.model.impl.ImplementsComponentRefImpl <em>Implements Component Ref</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.fortiss.af3.exploration.moea.model.impl.ImplementsComponentRefImpl
	 * @see org.fortiss.af3.exploration.moea.model.impl.MoeaPackageImpl#getImplementsComponentRef()
	 * @generated
	 */
	int IMPLEMENTS_COMPONENT_REF = 2;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IMPLEMENTS_COMPONENT_REF__ID = ElementPackage.IHIDDEN_SPECIFICATION__ID;

	/**
	 * The feature id for the '<em><b>Specification Of</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IMPLEMENTS_COMPONENT_REF__SPECIFICATION_OF = ElementPackage.IHIDDEN_SPECIFICATION__SPECIFICATION_OF;

	/**
	 * The feature id for the '<em><b>Ref Component</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IMPLEMENTS_COMPONENT_REF__REF_COMPONENT = ElementPackage.IHIDDEN_SPECIFICATION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Implements Component Ref</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IMPLEMENTS_COMPONENT_REF_FEATURE_COUNT = ElementPackage.IHIDDEN_SPECIFICATION_FEATURE_COUNT + 1;


	/**
	 * The meta object id for the '{@link org.fortiss.af3.exploration.moea.model.impl.VoterTypeImpl <em>Voter Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.fortiss.af3.exploration.moea.model.impl.VoterTypeImpl
	 * @see org.fortiss.af3.exploration.moea.model.impl.MoeaPackageImpl#getVoterType()
	 * @generated
	 */
	int VOTER_TYPE = 3;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOTER_TYPE__ID = ElementPackage.IHIDDEN_SPECIFICATION__ID;

	/**
	 * The feature id for the '<em><b>Specification Of</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOTER_TYPE__SPECIFICATION_OF = ElementPackage.IHIDDEN_SPECIFICATION__SPECIFICATION_OF;

	/**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOTER_TYPE__TYPE = ElementPackage.IHIDDEN_SPECIFICATION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Voter Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VOTER_TYPE_FEATURE_COUNT = ElementPackage.IHIDDEN_SPECIFICATION_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link org.fortiss.af3.exploration.moea.model.VoterType_t <em>Voter Type t</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.fortiss.af3.exploration.moea.model.VoterType_t
	 * @see org.fortiss.af3.exploration.moea.model.impl.MoeaPackageImpl#getVoterType_t()
	 * @generated
	 */
	int VOTER_TYPE_T = 4;


	/**
	 * Returns the meta object for class '{@link org.fortiss.af3.exploration.moea.model.ExplorationManager <em>Exploration Manager</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Exploration Manager</em>'.
	 * @see org.fortiss.af3.exploration.moea.model.ExplorationManager
	 * @generated
	 */
	EClass getExplorationManager();

	/**
	 * Returns the meta object for the containment reference list '{@link org.fortiss.af3.exploration.moea.model.ExplorationManager#getDseSpecifications <em>Dse Specifications</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Dse Specifications</em>'.
	 * @see org.fortiss.af3.exploration.moea.model.ExplorationManager#getDseSpecifications()
	 * @see #getExplorationManager()
	 * @generated
	 */
	EReference getExplorationManager_DseSpecifications();

	/**
	 * Returns the meta object for class '{@link org.fortiss.af3.exploration.moea.model.DseSpecification <em>Dse Specification</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Dse Specification</em>'.
	 * @see org.fortiss.af3.exploration.moea.model.DseSpecification
	 * @generated
	 */
	EClass getDseSpecification();

	/**
	 * Returns the meta object for the containment reference list '{@link org.fortiss.af3.exploration.moea.model.DseSpecification#getFeatures <em>Features</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Features</em>'.
	 * @see org.fortiss.af3.exploration.moea.model.DseSpecification#getFeatures()
	 * @see #getDseSpecification()
	 * @generated
	 */
	EReference getDseSpecification_Features();

	/**
	 * Returns the meta object for the containment reference '{@link org.fortiss.af3.exploration.moea.model.DseSpecification#getOptimizer <em>Optimizer</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Optimizer</em>'.
	 * @see org.fortiss.af3.exploration.moea.model.DseSpecification#getOptimizer()
	 * @see #getDseSpecification()
	 * @generated
	 */
	EReference getDseSpecification_Optimizer();

	/**
	 * Returns the meta object for the containment reference '{@link org.fortiss.af3.exploration.moea.model.DseSpecification#getParameters <em>Parameters</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Parameters</em>'.
	 * @see org.fortiss.af3.exploration.moea.model.DseSpecification#getParameters()
	 * @see #getDseSpecification()
	 * @generated
	 */
	EReference getDseSpecification_Parameters();

	/**
	 * Returns the meta object for the containment reference '{@link org.fortiss.af3.exploration.moea.model.DseSpecification#getTargetSpecification <em>Target Specification</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Target Specification</em>'.
	 * @see org.fortiss.af3.exploration.moea.model.DseSpecification#getTargetSpecification()
	 * @see #getDseSpecification()
	 * @generated
	 */
	EReference getDseSpecification_TargetSpecification();

	/**
	 * Returns the meta object for class '{@link org.fortiss.af3.exploration.moea.model.ImplementsComponentRef <em>Implements Component Ref</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Implements Component Ref</em>'.
	 * @see org.fortiss.af3.exploration.moea.model.ImplementsComponentRef
	 * @generated
	 */
	EClass getImplementsComponentRef();

	/**
	 * Returns the meta object for the reference '{@link org.fortiss.af3.exploration.moea.model.ImplementsComponentRef#getRefComponent <em>Ref Component</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Ref Component</em>'.
	 * @see org.fortiss.af3.exploration.moea.model.ImplementsComponentRef#getRefComponent()
	 * @see #getImplementsComponentRef()
	 * @generated
	 */
	EReference getImplementsComponentRef_RefComponent();

	/**
	 * Returns the meta object for class '{@link org.fortiss.af3.exploration.moea.model.VoterType <em>Voter Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Voter Type</em>'.
	 * @see org.fortiss.af3.exploration.moea.model.VoterType
	 * @generated
	 */
	EClass getVoterType();

	/**
	 * Returns the meta object for the attribute '{@link org.fortiss.af3.exploration.moea.model.VoterType#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see org.fortiss.af3.exploration.moea.model.VoterType#getType()
	 * @see #getVoterType()
	 * @generated
	 */
	EAttribute getVoterType_Type();

	/**
	 * Returns the meta object for enum '{@link org.fortiss.af3.exploration.moea.model.VoterType_t <em>Voter Type t</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Voter Type t</em>'.
	 * @see org.fortiss.af3.exploration.moea.model.VoterType_t
	 * @generated
	 */
	EEnum getVoterType_t();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	MoeaFactory getMoeaFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link org.fortiss.af3.exploration.moea.model.impl.ExplorationManagerImpl <em>Exploration Manager</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.fortiss.af3.exploration.moea.model.impl.ExplorationManagerImpl
		 * @see org.fortiss.af3.exploration.moea.model.impl.MoeaPackageImpl#getExplorationManager()
		 * @generated
		 */
		EClass EXPLORATION_MANAGER = eINSTANCE.getExplorationManager();

		/**
		 * The meta object literal for the '<em><b>Dse Specifications</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference EXPLORATION_MANAGER__DSE_SPECIFICATIONS = eINSTANCE.getExplorationManager_DseSpecifications();

		/**
		 * The meta object literal for the '{@link org.fortiss.af3.exploration.moea.model.impl.DseSpecificationImpl <em>Dse Specification</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.fortiss.af3.exploration.moea.model.impl.DseSpecificationImpl
		 * @see org.fortiss.af3.exploration.moea.model.impl.MoeaPackageImpl#getDseSpecification()
		 * @generated
		 */
		EClass DSE_SPECIFICATION = eINSTANCE.getDseSpecification();

		/**
		 * The meta object literal for the '<em><b>Features</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DSE_SPECIFICATION__FEATURES = eINSTANCE.getDseSpecification_Features();

		/**
		 * The meta object literal for the '<em><b>Optimizer</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DSE_SPECIFICATION__OPTIMIZER = eINSTANCE.getDseSpecification_Optimizer();

		/**
		 * The meta object literal for the '<em><b>Parameters</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DSE_SPECIFICATION__PARAMETERS = eINSTANCE.getDseSpecification_Parameters();

		/**
		 * The meta object literal for the '<em><b>Target Specification</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DSE_SPECIFICATION__TARGET_SPECIFICATION = eINSTANCE.getDseSpecification_TargetSpecification();

		/**
		 * The meta object literal for the '{@link org.fortiss.af3.exploration.moea.model.impl.ImplementsComponentRefImpl <em>Implements Component Ref</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.fortiss.af3.exploration.moea.model.impl.ImplementsComponentRefImpl
		 * @see org.fortiss.af3.exploration.moea.model.impl.MoeaPackageImpl#getImplementsComponentRef()
		 * @generated
		 */
		EClass IMPLEMENTS_COMPONENT_REF = eINSTANCE.getImplementsComponentRef();

		/**
		 * The meta object literal for the '<em><b>Ref Component</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference IMPLEMENTS_COMPONENT_REF__REF_COMPONENT = eINSTANCE.getImplementsComponentRef_RefComponent();

		/**
		 * The meta object literal for the '{@link org.fortiss.af3.exploration.moea.model.impl.VoterTypeImpl <em>Voter Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.fortiss.af3.exploration.moea.model.impl.VoterTypeImpl
		 * @see org.fortiss.af3.exploration.moea.model.impl.MoeaPackageImpl#getVoterType()
		 * @generated
		 */
		EClass VOTER_TYPE = eINSTANCE.getVoterType();

		/**
		 * The meta object literal for the '<em><b>Type</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute VOTER_TYPE__TYPE = eINSTANCE.getVoterType_Type();

		/**
		 * The meta object literal for the '{@link org.fortiss.af3.exploration.moea.model.VoterType_t <em>Voter Type t</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.fortiss.af3.exploration.moea.model.VoterType_t
		 * @see org.fortiss.af3.exploration.moea.model.impl.MoeaPackageImpl#getVoterType_t()
		 * @generated
		 */
		EEnum VOTER_TYPE_T = eINSTANCE.getVoterType_t();

	}

} //MoeaPackage
