/**
 */
package org.fortiss.af3.exploration.moea.model.feature;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EPackage;

import org.fortiss.af3.exploration.model.ExplorationPackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see org.fortiss.af3.exploration.moea.model.feature.FeatureFactory
 * @model kind="package"
 * @generated
 */
public interface FeaturePackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "feature";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.fortiss.org/af3/exploration/moea/feature";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "org-fortiss-af3-exploration-moea-feature";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	FeaturePackage eINSTANCE = org.fortiss.af3.exploration.moea.model.feature.impl.FeaturePackageImpl.init();

	/**
	 * The meta object id for the '{@link org.fortiss.af3.exploration.moea.model.feature.impl.SafetyExplorationImpl <em>Safety Exploration</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.fortiss.af3.exploration.moea.model.feature.impl.SafetyExplorationImpl
	 * @see org.fortiss.af3.exploration.moea.model.feature.impl.FeaturePackageImpl#getSafetyExploration()
	 * @generated
	 */
	int SAFETY_EXPLORATION = 0;

	/**
	 * The feature id for the '<em><b>Adapters</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAFETY_EXPLORATION__ADAPTERS = ExplorationPackage.IEXPLORATION_FEATURE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Safety Exploration</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SAFETY_EXPLORATION_FEATURE_COUNT = ExplorationPackage.IEXPLORATION_FEATURE_FEATURE_COUNT + 1;

	/**
	 * The meta object id for the '{@link org.fortiss.af3.exploration.moea.model.feature.impl.TaskInstantiationImpl <em>Task Instantiation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.fortiss.af3.exploration.moea.model.feature.impl.TaskInstantiationImpl
	 * @see org.fortiss.af3.exploration.moea.model.feature.impl.FeaturePackageImpl#getTaskInstantiation()
	 * @generated
	 */
	int TASK_INSTANTIATION = 1;

	/**
	 * The number of structural features of the '<em>Task Instantiation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TASK_INSTANTIATION_FEATURE_COUNT = ExplorationPackage.IEXPLORATION_FEATURE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '{@link org.fortiss.af3.exploration.moea.model.feature.impl.TaskMappingImpl <em>Task Mapping</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.fortiss.af3.exploration.moea.model.feature.impl.TaskMappingImpl
	 * @see org.fortiss.af3.exploration.moea.model.feature.impl.FeaturePackageImpl#getTaskMapping()
	 * @generated
	 */
	int TASK_MAPPING = 2;

	/**
	 * The number of structural features of the '<em>Task Mapping</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TASK_MAPPING_FEATURE_COUNT = ExplorationPackage.IEXPLORATION_FEATURE_FEATURE_COUNT + 0;

	/**
	 * The meta object id for the '<em>ISafety Function Adapter</em>' data type.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.fortiss.af3.exploration.alg.dse.sysmodel.arch.ISafetyFunctionAdapter
	 * @see org.fortiss.af3.exploration.moea.model.feature.impl.FeaturePackageImpl#getISafetyFunctionAdapter()
	 * @generated
	 */
	int ISAFETY_FUNCTION_ADAPTER = 3;


	/**
	 * Returns the meta object for class '{@link org.fortiss.af3.exploration.moea.model.feature.SafetyExploration <em>Safety Exploration</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Safety Exploration</em>'.
	 * @see org.fortiss.af3.exploration.moea.model.feature.SafetyExploration
	 * @generated
	 */
	EClass getSafetyExploration();

	/**
	 * Returns the meta object for the attribute list '{@link org.fortiss.af3.exploration.moea.model.feature.SafetyExploration#getAdapters <em>Adapters</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Adapters</em>'.
	 * @see org.fortiss.af3.exploration.moea.model.feature.SafetyExploration#getAdapters()
	 * @see #getSafetyExploration()
	 * @generated
	 */
	EAttribute getSafetyExploration_Adapters();

	/**
	 * Returns the meta object for class '{@link org.fortiss.af3.exploration.moea.model.feature.TaskInstantiation <em>Task Instantiation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Task Instantiation</em>'.
	 * @see org.fortiss.af3.exploration.moea.model.feature.TaskInstantiation
	 * @generated
	 */
	EClass getTaskInstantiation();

	/**
	 * Returns the meta object for class '{@link org.fortiss.af3.exploration.moea.model.feature.TaskMapping <em>Task Mapping</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Task Mapping</em>'.
	 * @see org.fortiss.af3.exploration.moea.model.feature.TaskMapping
	 * @generated
	 */
	EClass getTaskMapping();

	/**
	 * Returns the meta object for data type '{@link org.fortiss.af3.exploration.alg.dse.sysmodel.arch.ISafetyFunctionAdapter <em>ISafety Function Adapter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for data type '<em>ISafety Function Adapter</em>'.
	 * @see org.fortiss.af3.exploration.alg.dse.sysmodel.arch.ISafetyFunctionAdapter
	 * @model instanceClass="org.fortiss.af3.exploration.alg.dse.sysmodel.arch.ISafetyFunctionAdapter"
	 * @generated
	 */
	EDataType getISafetyFunctionAdapter();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	FeatureFactory getFeatureFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link org.fortiss.af3.exploration.moea.model.feature.impl.SafetyExplorationImpl <em>Safety Exploration</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.fortiss.af3.exploration.moea.model.feature.impl.SafetyExplorationImpl
		 * @see org.fortiss.af3.exploration.moea.model.feature.impl.FeaturePackageImpl#getSafetyExploration()
		 * @generated
		 */
		EClass SAFETY_EXPLORATION = eINSTANCE.getSafetyExploration();

		/**
		 * The meta object literal for the '<em><b>Adapters</b></em>' attribute list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SAFETY_EXPLORATION__ADAPTERS = eINSTANCE.getSafetyExploration_Adapters();

		/**
		 * The meta object literal for the '{@link org.fortiss.af3.exploration.moea.model.feature.impl.TaskInstantiationImpl <em>Task Instantiation</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.fortiss.af3.exploration.moea.model.feature.impl.TaskInstantiationImpl
		 * @see org.fortiss.af3.exploration.moea.model.feature.impl.FeaturePackageImpl#getTaskInstantiation()
		 * @generated
		 */
		EClass TASK_INSTANTIATION = eINSTANCE.getTaskInstantiation();

		/**
		 * The meta object literal for the '{@link org.fortiss.af3.exploration.moea.model.feature.impl.TaskMappingImpl <em>Task Mapping</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.fortiss.af3.exploration.moea.model.feature.impl.TaskMappingImpl
		 * @see org.fortiss.af3.exploration.moea.model.feature.impl.FeaturePackageImpl#getTaskMapping()
		 * @generated
		 */
		EClass TASK_MAPPING = eINSTANCE.getTaskMapping();

		/**
		 * The meta object literal for the '<em>ISafety Function Adapter</em>' data type.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.fortiss.af3.exploration.alg.dse.sysmodel.arch.ISafetyFunctionAdapter
		 * @see org.fortiss.af3.exploration.moea.model.feature.impl.FeaturePackageImpl#getISafetyFunctionAdapter()
		 * @generated
		 */
		EDataType ISAFETY_FUNCTION_ADAPTER = eINSTANCE.getISafetyFunctionAdapter();

	}

} //FeaturePackage
