/**
 */
package org.fortiss.af3.exploration.moea.model.impl;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

import org.eclipse.emf.ecore.impl.EPackageImpl;

import org.fortiss.af3.component.model.AF3ComponentPackage;

import org.fortiss.af3.exploration.model.CommonPackage;
import org.fortiss.af3.exploration.model.DimensionsPackage;
import org.fortiss.af3.exploration.model.ExplorationPackage;

import org.fortiss.af3.exploration.moea.model.DseSpecification;
import org.fortiss.af3.exploration.moea.model.ExplorationManager;
import org.fortiss.af3.exploration.moea.model.ImplementsComponentRef;
import org.fortiss.af3.exploration.moea.model.MoeaFactory;
import org.fortiss.af3.exploration.moea.model.MoeaPackage;

import org.fortiss.af3.exploration.moea.model.VoterType;
import org.fortiss.af3.exploration.moea.model.VoterType_t;
import org.fortiss.af3.exploration.moea.model.feature.FeaturePackage;

import org.fortiss.af3.exploration.moea.model.feature.impl.FeaturePackageImpl;

import org.fortiss.af3.exploration.moea.model.parameters.ParametersPackage;

import org.fortiss.af3.exploration.moea.model.parameters.impl.ParametersPackageImpl;

import org.fortiss.af3.exploration.moea.model.predefined.PredefinedPackage;

import org.fortiss.af3.exploration.moea.model.predefined.impl.PredefinedPackageImpl;

import org.fortiss.af3.exploration.moea.model.solutions.SolutionsPackage;

import org.fortiss.af3.exploration.moea.model.solutions.impl.SolutionsPackageImpl;

import org.fortiss.tooling.base.model.element.ElementPackage;

import org.fortiss.tooling.kernel.model.FortissToolingKernelPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class MoeaPackageImpl extends EPackageImpl implements MoeaPackage {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass explorationManagerEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass dseSpecificationEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass implementsComponentRefEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass voterTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum voterType_tEEnum = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see org.fortiss.af3.exploration.moea.model.MoeaPackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private MoeaPackageImpl() {
		super(eNS_URI, MoeaFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
	 * 
	 * <p>This method is used to initialize {@link MoeaPackage#eINSTANCE} when that field is accessed.
	 * Clients should not invoke it directly. Instead, they should simply access that field to obtain the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
	public static MoeaPackage init() {
		if (isInited) return (MoeaPackage)EPackage.Registry.INSTANCE.getEPackage(MoeaPackage.eNS_URI);

		// Obtain or create and register package
		MoeaPackageImpl theMoeaPackage = (MoeaPackageImpl)(EPackage.Registry.INSTANCE.get(eNS_URI) instanceof MoeaPackageImpl ? EPackage.Registry.INSTANCE.get(eNS_URI) : new MoeaPackageImpl());

		isInited = true;

		// Initialize simple dependencies
		CommonPackage.eINSTANCE.eClass();
		DimensionsPackage.eINSTANCE.eClass();

		// Obtain or create and register interdependencies
		FeaturePackageImpl theFeaturePackage = (FeaturePackageImpl)(EPackage.Registry.INSTANCE.getEPackage(FeaturePackage.eNS_URI) instanceof FeaturePackageImpl ? EPackage.Registry.INSTANCE.getEPackage(FeaturePackage.eNS_URI) : FeaturePackage.eINSTANCE);
		ParametersPackageImpl theParametersPackage = (ParametersPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(ParametersPackage.eNS_URI) instanceof ParametersPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(ParametersPackage.eNS_URI) : ParametersPackage.eINSTANCE);
		PredefinedPackageImpl thePredefinedPackage = (PredefinedPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(PredefinedPackage.eNS_URI) instanceof PredefinedPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(PredefinedPackage.eNS_URI) : PredefinedPackage.eINSTANCE);
		SolutionsPackageImpl theSolutionsPackage = (SolutionsPackageImpl)(EPackage.Registry.INSTANCE.getEPackage(SolutionsPackage.eNS_URI) instanceof SolutionsPackageImpl ? EPackage.Registry.INSTANCE.getEPackage(SolutionsPackage.eNS_URI) : SolutionsPackage.eINSTANCE);

		// Create package meta-data objects
		theMoeaPackage.createPackageContents();
		theFeaturePackage.createPackageContents();
		theParametersPackage.createPackageContents();
		thePredefinedPackage.createPackageContents();
		theSolutionsPackage.createPackageContents();

		// Initialize created meta-data
		theMoeaPackage.initializePackageContents();
		theFeaturePackage.initializePackageContents();
		theParametersPackage.initializePackageContents();
		thePredefinedPackage.initializePackageContents();
		theSolutionsPackage.initializePackageContents();

		// Mark meta-data to indicate it can't be changed
		theMoeaPackage.freeze();

  
		// Update the registry and return the package
		EPackage.Registry.INSTANCE.put(MoeaPackage.eNS_URI, theMoeaPackage);
		return theMoeaPackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getExplorationManager() {
		return explorationManagerEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getExplorationManager_DseSpecifications() {
		return (EReference)explorationManagerEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDseSpecification() {
		return dseSpecificationEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDseSpecification_Features() {
		return (EReference)dseSpecificationEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDseSpecification_Optimizer() {
		return (EReference)dseSpecificationEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDseSpecification_Parameters() {
		return (EReference)dseSpecificationEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDseSpecification_TargetSpecification() {
		return (EReference)dseSpecificationEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getImplementsComponentRef() {
		return implementsComponentRefEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getImplementsComponentRef_RefComponent() {
		return (EReference)implementsComponentRefEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getVoterType() {
		return voterTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getVoterType_Type() {
		return (EAttribute)voterTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getVoterType_t() {
		return voterType_tEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MoeaFactory getMoeaFactory() {
		return (MoeaFactory)getEFactoryInstance();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isCreated = false;

	/**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void createPackageContents() {
		if (isCreated) return;
		isCreated = true;

		// Create classes and their features
		explorationManagerEClass = createEClass(EXPLORATION_MANAGER);
		createEReference(explorationManagerEClass, EXPLORATION_MANAGER__DSE_SPECIFICATIONS);

		dseSpecificationEClass = createEClass(DSE_SPECIFICATION);
		createEReference(dseSpecificationEClass, DSE_SPECIFICATION__FEATURES);
		createEReference(dseSpecificationEClass, DSE_SPECIFICATION__OPTIMIZER);
		createEReference(dseSpecificationEClass, DSE_SPECIFICATION__PARAMETERS);
		createEReference(dseSpecificationEClass, DSE_SPECIFICATION__TARGET_SPECIFICATION);

		implementsComponentRefEClass = createEClass(IMPLEMENTS_COMPONENT_REF);
		createEReference(implementsComponentRefEClass, IMPLEMENTS_COMPONENT_REF__REF_COMPONENT);

		voterTypeEClass = createEClass(VOTER_TYPE);
		createEAttribute(voterTypeEClass, VOTER_TYPE__TYPE);

		// Create enums
		voterType_tEEnum = createEEnum(VOTER_TYPE_T);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isInitialized = false;

	/**
	 * Complete the initialization of the package and its meta-model.  This
	 * method is guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void initializePackageContents() {
		if (isInitialized) return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Obtain other dependent packages
		FeaturePackage theFeaturePackage = (FeaturePackage)EPackage.Registry.INSTANCE.getEPackage(FeaturePackage.eNS_URI);
		ParametersPackage theParametersPackage = (ParametersPackage)EPackage.Registry.INSTANCE.getEPackage(ParametersPackage.eNS_URI);
		PredefinedPackage thePredefinedPackage = (PredefinedPackage)EPackage.Registry.INSTANCE.getEPackage(PredefinedPackage.eNS_URI);
		SolutionsPackage theSolutionsPackage = (SolutionsPackage)EPackage.Registry.INSTANCE.getEPackage(SolutionsPackage.eNS_URI);
		FortissToolingKernelPackage theFortissToolingKernelPackage = (FortissToolingKernelPackage)EPackage.Registry.INSTANCE.getEPackage(FortissToolingKernelPackage.eNS_URI);
		ExplorationPackage theExplorationPackage = (ExplorationPackage)EPackage.Registry.INSTANCE.getEPackage(ExplorationPackage.eNS_URI);
		ElementPackage theElementPackage = (ElementPackage)EPackage.Registry.INSTANCE.getEPackage(ElementPackage.eNS_URI);
		AF3ComponentPackage theAF3ComponentPackage = (AF3ComponentPackage)EPackage.Registry.INSTANCE.getEPackage(AF3ComponentPackage.eNS_URI);

		// Add subpackages
		getESubpackages().add(theFeaturePackage);
		getESubpackages().add(theParametersPackage);
		getESubpackages().add(thePredefinedPackage);
		getESubpackages().add(theSolutionsPackage);

		// Create type parameters

		// Set bounds for type parameters

		// Add supertypes to classes
		explorationManagerEClass.getESuperTypes().add(theFortissToolingKernelPackage.getIProjectRootElement());
		dseSpecificationEClass.getESuperTypes().add(theFortissToolingKernelPackage.getINamedCommentedElement());
		implementsComponentRefEClass.getESuperTypes().add(theElementPackage.getIHiddenSpecification());
		voterTypeEClass.getESuperTypes().add(theElementPackage.getIHiddenSpecification());

		// Initialize classes and features; add operations and parameters
		initEClass(explorationManagerEClass, ExplorationManager.class, "ExplorationManager", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getExplorationManager_DseSpecifications(), this.getDseSpecification(), null, "dseSpecifications", null, 0, -1, ExplorationManager.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(dseSpecificationEClass, DseSpecification.class, "DseSpecification", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getDseSpecification_Features(), theExplorationPackage.getIExplorationFeature(), null, "features", null, 1, -1, DseSpecification.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getDseSpecification_Optimizer(), theParametersPackage.getIOptimizer(), null, "optimizer", null, 1, 1, DseSpecification.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getDseSpecification_Parameters(), theParametersPackage.getSystemParameters(), null, "parameters", null, 1, 1, DseSpecification.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getDseSpecification_TargetSpecification(), theExplorationPackage.getExplorationSpecification(), null, "targetSpecification", null, 1, 1, DseSpecification.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(implementsComponentRefEClass, ImplementsComponentRef.class, "ImplementsComponentRef", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getImplementsComponentRef_RefComponent(), theAF3ComponentPackage.getComponent(), null, "refComponent", null, 1, 1, ImplementsComponentRef.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(voterTypeEClass, VoterType.class, "VoterType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getVoterType_Type(), this.getVoterType_t(), "type", null, 1, 1, VoterType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		// Initialize enums and add enum literals
		initEEnum(voterType_tEEnum, VoterType_t.class, "VoterType_t");
		addEEnumLiteral(voterType_tEEnum, VoterType_t.MAJORITY_VOTER);

		// Create resource
		createResource(eNS_URI);
	}

} //MoeaPackageImpl
