/**
 */
package org.fortiss.af3.exploration.moea.model.parameters;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>EA Optimizer</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * {@link IOptimizer} backend for evolutionary algorithms which also contains the relevant parameters for this kind of optimizer.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.fortiss.af3.exploration.moea.model.parameters.EAOptimizer#getAlpha <em>Alpha</em>}</li>
 *   <li>{@link org.fortiss.af3.exploration.moea.model.parameters.EAOptimizer#getMu <em>Mu</em>}</li>
 *   <li>{@link org.fortiss.af3.exploration.moea.model.parameters.EAOptimizer#getIterations <em>Iterations</em>}</li>
 *   <li>{@link org.fortiss.af3.exploration.moea.model.parameters.EAOptimizer#getSpea2Tournament <em>Spea2 Tournament</em>}</li>
 *   <li>{@link org.fortiss.af3.exploration.moea.model.parameters.EAOptimizer#isParallelExecution <em>Parallel Execution</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.fortiss.af3.exploration.moea.model.parameters.ParametersPackage#getEAOptimizer()
 * @model
 * @generated
 */
public interface EAOptimizer extends IOptimizer {
	/**
	 * Returns the value of the '<em><b>Alpha</b></em>' attribute.
	 * The default value is <code>"1000"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Defines the size of the population.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Alpha</em>' attribute.
	 * @see #setAlpha(int)
	 * @see org.fortiss.af3.exploration.moea.model.parameters.ParametersPackage#getEAOptimizer_Alpha()
	 * @model default="1000" required="true"
	 * @generated
	 */
	int getAlpha();

	/**
	 * Sets the value of the '{@link org.fortiss.af3.exploration.moea.model.parameters.EAOptimizer#getAlpha <em>Alpha</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Alpha</em>' attribute.
	 * @see #getAlpha()
	 * @generated
	 */
	void setAlpha(int value);

	/**
	 * Returns the value of the '<em><b>Mu</b></em>' attribute.
	 * The default value is <code>"50"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Number of parents to generate the offspring added to the population for the next iteration of the algorithm.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Mu</em>' attribute.
	 * @see #setMu(int)
	 * @see org.fortiss.af3.exploration.moea.model.parameters.ParametersPackage#getEAOptimizer_Mu()
	 * @model default="50" required="true"
	 * @generated
	 */
	int getMu();

	/**
	 * Sets the value of the '{@link org.fortiss.af3.exploration.moea.model.parameters.EAOptimizer#getMu <em>Mu</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Mu</em>' attribute.
	 * @see #getMu()
	 * @generated
	 */
	void setMu(int value);

	/**
	 * Returns the value of the '<em><b>Iterations</b></em>' attribute.
	 * The default value is <code>"100"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Defines the number of iterations (aka generations) before the optimization terminates and the found solution(s) (if any) are returned.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Iterations</em>' attribute.
	 * @see #setIterations(int)
	 * @see org.fortiss.af3.exploration.moea.model.parameters.ParametersPackage#getEAOptimizer_Iterations()
	 * @model default="100" required="true"
	 * @generated
	 */
	int getIterations();

	/**
	 * Sets the value of the '{@link org.fortiss.af3.exploration.moea.model.parameters.EAOptimizer#getIterations <em>Iterations</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Iterations</em>' attribute.
	 * @see #getIterations()
	 * @generated
	 */
	void setIterations(int value);

	/**
	 * Returns the value of the '<em><b>Spea2 Tournament</b></em>' attribute.
	 * The default value is <code>"5"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Defines the selection pressure for the SPEA2 genetic algorithm.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Spea2 Tournament</em>' attribute.
	 * @see #setSpea2Tournament(int)
	 * @see org.fortiss.af3.exploration.moea.model.parameters.ParametersPackage#getEAOptimizer_Spea2Tournament()
	 * @model default="5" required="true"
	 * @generated
	 */
	int getSpea2Tournament();

	/**
	 * Sets the value of the '{@link org.fortiss.af3.exploration.moea.model.parameters.EAOptimizer#getSpea2Tournament <em>Spea2 Tournament</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Spea2 Tournament</em>' attribute.
	 * @see #getSpea2Tournament()
	 * @generated
	 */
	void setSpea2Tournament(int value);

	/**
	 * Returns the value of the '<em><b>Parallel Execution</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Defines whether the algorithm shall use parallel processing, if available in the algorithm.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Parallel Execution</em>' attribute.
	 * @see #setParallelExecution(boolean)
	 * @see org.fortiss.af3.exploration.moea.model.parameters.ParametersPackage#getEAOptimizer_ParallelExecution()
	 * @model default="false" required="true"
	 * @generated
	 */
	boolean isParallelExecution();

	/**
	 * Sets the value of the '{@link org.fortiss.af3.exploration.moea.model.parameters.EAOptimizer#isParallelExecution <em>Parallel Execution</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Parallel Execution</em>' attribute.
	 * @see #isParallelExecution()
	 * @generated
	 */
	void setParallelExecution(boolean value);

} // EAOptimizer
