/**
 */
package org.fortiss.af3.exploration.moea.model.parameters;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Execution Model</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * <!-- begin-model-doc -->
 * Defines the failure assumption.
 * <!-- end-model-doc -->
 * @see org.fortiss.af3.exploration.moea.model.parameters.ParametersPackage#getExecutionModel()
 * @model
 * @generated
 */
public enum ExecutionModel implements Enumerator {
	/**
	 * The '<em><b>TT FAIL SILENCE</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #TT_FAIL_SILENCE_VALUE
	 * @generated
	 * @ordered
	 */
	TT_FAIL_SILENCE(0, "TT_FAIL_SILENCE", "TT_FAIL_SILENCE"),

	/**
	 * The '<em><b>TT FAULT DETECTION VOTING</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #TT_FAULT_DETECTION_VOTING_VALUE
	 * @generated
	 * @ordered
	 */
	TT_FAULT_DETECTION_VOTING(1, "TT_FAULT_DETECTION_VOTING", "TT_FAULT_DETECTION_VOTING");

	/**
	 * The '<em><b>TT FAIL SILENCE</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>TT FAIL SILENCE</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #TT_FAIL_SILENCE
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int TT_FAIL_SILENCE_VALUE = 0;

	/**
	 * The '<em><b>TT FAULT DETECTION VOTING</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>TT FAULT DETECTION VOTING</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #TT_FAULT_DETECTION_VOTING
	 * @model
	 * @generated
	 * @ordered
	 */
	public static final int TT_FAULT_DETECTION_VOTING_VALUE = 1;

	/**
	 * An array of all the '<em><b>Execution Model</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final ExecutionModel[] VALUES_ARRAY =
		new ExecutionModel[] {
			TT_FAIL_SILENCE,
			TT_FAULT_DETECTION_VOTING,
		};

	/**
	 * A public read-only list of all the '<em><b>Execution Model</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List<ExecutionModel> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>Execution Model</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static ExecutionModel get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			ExecutionModel result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Execution Model</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static ExecutionModel getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			ExecutionModel result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Execution Model</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static ExecutionModel get(int value) {
		switch (value) {
			case TT_FAIL_SILENCE_VALUE: return TT_FAIL_SILENCE;
			case TT_FAULT_DETECTION_VOTING_VALUE: return TT_FAULT_DETECTION_VOTING;
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final int value;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String name;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String literal;

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private ExecutionModel(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getValue() {
	  return value;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
	  return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getLiteral() {
	  return literal;
	}

	/**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}
	
} //ExecutionModel
