/**
 */
package org.fortiss.af3.exploration.moea.model.parameters;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EPackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see org.fortiss.af3.exploration.moea.model.parameters.ParametersFactory
 * @model kind="package"
 * @generated
 */
public interface ParametersPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "parameters";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.fortiss.org/af3/exploration/moea/parameters";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "org-fortiss-af3-exploration-moea-parameters";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	ParametersPackage eINSTANCE = org.fortiss.af3.exploration.moea.model.parameters.impl.ParametersPackageImpl.init();

	/**
	 * The meta object id for the '{@link org.fortiss.af3.exploration.moea.model.parameters.impl.SystemParametersImpl <em>System Parameters</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.fortiss.af3.exploration.moea.model.parameters.impl.SystemParametersImpl
	 * @see org.fortiss.af3.exploration.moea.model.parameters.impl.ParametersPackageImpl#getSystemParameters()
	 * @generated
	 */
	int SYSTEM_PARAMETERS = 0;

	/**
	 * The feature id for the '<em><b>Execution Model</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_PARAMETERS__EXECUTION_MODEL = 0;

	/**
	 * The number of structural features of the '<em>System Parameters</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_PARAMETERS_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link org.fortiss.af3.exploration.moea.model.parameters.IOptimizer <em>IOptimizer</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.fortiss.af3.exploration.moea.model.parameters.IOptimizer
	 * @see org.fortiss.af3.exploration.moea.model.parameters.impl.ParametersPackageImpl#getIOptimizer()
	 * @generated
	 */
	int IOPTIMIZER = 1;

	/**
	 * The number of structural features of the '<em>IOptimizer</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IOPTIMIZER_FEATURE_COUNT = 0;

	/**
	 * The meta object id for the '{@link org.fortiss.af3.exploration.moea.model.parameters.impl.EAOptimizerImpl <em>EA Optimizer</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.fortiss.af3.exploration.moea.model.parameters.impl.EAOptimizerImpl
	 * @see org.fortiss.af3.exploration.moea.model.parameters.impl.ParametersPackageImpl#getEAOptimizer()
	 * @generated
	 */
	int EA_OPTIMIZER = 2;

	/**
	 * The feature id for the '<em><b>Alpha</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EA_OPTIMIZER__ALPHA = IOPTIMIZER_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Mu</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EA_OPTIMIZER__MU = IOPTIMIZER_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Iterations</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EA_OPTIMIZER__ITERATIONS = IOPTIMIZER_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Spea2 Tournament</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EA_OPTIMIZER__SPEA2_TOURNAMENT = IOPTIMIZER_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Parallel Execution</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EA_OPTIMIZER__PARALLEL_EXECUTION = IOPTIMIZER_FEATURE_COUNT + 4;

	/**
	 * The number of structural features of the '<em>EA Optimizer</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EA_OPTIMIZER_FEATURE_COUNT = IOPTIMIZER_FEATURE_COUNT + 5;

	/**
	 * The meta object id for the '{@link org.fortiss.af3.exploration.moea.model.parameters.ExecutionModel <em>Execution Model</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.fortiss.af3.exploration.moea.model.parameters.ExecutionModel
	 * @see org.fortiss.af3.exploration.moea.model.parameters.impl.ParametersPackageImpl#getExecutionModel()
	 * @generated
	 */
	int EXECUTION_MODEL = 3;


	/**
	 * Returns the meta object for class '{@link org.fortiss.af3.exploration.moea.model.parameters.SystemParameters <em>System Parameters</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>System Parameters</em>'.
	 * @see org.fortiss.af3.exploration.moea.model.parameters.SystemParameters
	 * @generated
	 */
	EClass getSystemParameters();

	/**
	 * Returns the meta object for the attribute '{@link org.fortiss.af3.exploration.moea.model.parameters.SystemParameters#getExecutionModel <em>Execution Model</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Execution Model</em>'.
	 * @see org.fortiss.af3.exploration.moea.model.parameters.SystemParameters#getExecutionModel()
	 * @see #getSystemParameters()
	 * @generated
	 */
	EAttribute getSystemParameters_ExecutionModel();

	/**
	 * Returns the meta object for class '{@link org.fortiss.af3.exploration.moea.model.parameters.IOptimizer <em>IOptimizer</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>IOptimizer</em>'.
	 * @see org.fortiss.af3.exploration.moea.model.parameters.IOptimizer
	 * @generated
	 */
	EClass getIOptimizer();

	/**
	 * Returns the meta object for class '{@link org.fortiss.af3.exploration.moea.model.parameters.EAOptimizer <em>EA Optimizer</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>EA Optimizer</em>'.
	 * @see org.fortiss.af3.exploration.moea.model.parameters.EAOptimizer
	 * @generated
	 */
	EClass getEAOptimizer();

	/**
	 * Returns the meta object for the attribute '{@link org.fortiss.af3.exploration.moea.model.parameters.EAOptimizer#getAlpha <em>Alpha</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Alpha</em>'.
	 * @see org.fortiss.af3.exploration.moea.model.parameters.EAOptimizer#getAlpha()
	 * @see #getEAOptimizer()
	 * @generated
	 */
	EAttribute getEAOptimizer_Alpha();

	/**
	 * Returns the meta object for the attribute '{@link org.fortiss.af3.exploration.moea.model.parameters.EAOptimizer#getMu <em>Mu</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Mu</em>'.
	 * @see org.fortiss.af3.exploration.moea.model.parameters.EAOptimizer#getMu()
	 * @see #getEAOptimizer()
	 * @generated
	 */
	EAttribute getEAOptimizer_Mu();

	/**
	 * Returns the meta object for the attribute '{@link org.fortiss.af3.exploration.moea.model.parameters.EAOptimizer#getIterations <em>Iterations</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Iterations</em>'.
	 * @see org.fortiss.af3.exploration.moea.model.parameters.EAOptimizer#getIterations()
	 * @see #getEAOptimizer()
	 * @generated
	 */
	EAttribute getEAOptimizer_Iterations();

	/**
	 * Returns the meta object for the attribute '{@link org.fortiss.af3.exploration.moea.model.parameters.EAOptimizer#getSpea2Tournament <em>Spea2 Tournament</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Spea2 Tournament</em>'.
	 * @see org.fortiss.af3.exploration.moea.model.parameters.EAOptimizer#getSpea2Tournament()
	 * @see #getEAOptimizer()
	 * @generated
	 */
	EAttribute getEAOptimizer_Spea2Tournament();

	/**
	 * Returns the meta object for the attribute '{@link org.fortiss.af3.exploration.moea.model.parameters.EAOptimizer#isParallelExecution <em>Parallel Execution</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Parallel Execution</em>'.
	 * @see org.fortiss.af3.exploration.moea.model.parameters.EAOptimizer#isParallelExecution()
	 * @see #getEAOptimizer()
	 * @generated
	 */
	EAttribute getEAOptimizer_ParallelExecution();

	/**
	 * Returns the meta object for enum '{@link org.fortiss.af3.exploration.moea.model.parameters.ExecutionModel <em>Execution Model</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Execution Model</em>'.
	 * @see org.fortiss.af3.exploration.moea.model.parameters.ExecutionModel
	 * @generated
	 */
	EEnum getExecutionModel();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	ParametersFactory getParametersFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link org.fortiss.af3.exploration.moea.model.parameters.impl.SystemParametersImpl <em>System Parameters</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.fortiss.af3.exploration.moea.model.parameters.impl.SystemParametersImpl
		 * @see org.fortiss.af3.exploration.moea.model.parameters.impl.ParametersPackageImpl#getSystemParameters()
		 * @generated
		 */
		EClass SYSTEM_PARAMETERS = eINSTANCE.getSystemParameters();

		/**
		 * The meta object literal for the '<em><b>Execution Model</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SYSTEM_PARAMETERS__EXECUTION_MODEL = eINSTANCE.getSystemParameters_ExecutionModel();

		/**
		 * The meta object literal for the '{@link org.fortiss.af3.exploration.moea.model.parameters.IOptimizer <em>IOptimizer</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.fortiss.af3.exploration.moea.model.parameters.IOptimizer
		 * @see org.fortiss.af3.exploration.moea.model.parameters.impl.ParametersPackageImpl#getIOptimizer()
		 * @generated
		 */
		EClass IOPTIMIZER = eINSTANCE.getIOptimizer();

		/**
		 * The meta object literal for the '{@link org.fortiss.af3.exploration.moea.model.parameters.impl.EAOptimizerImpl <em>EA Optimizer</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.fortiss.af3.exploration.moea.model.parameters.impl.EAOptimizerImpl
		 * @see org.fortiss.af3.exploration.moea.model.parameters.impl.ParametersPackageImpl#getEAOptimizer()
		 * @generated
		 */
		EClass EA_OPTIMIZER = eINSTANCE.getEAOptimizer();

		/**
		 * The meta object literal for the '<em><b>Alpha</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EA_OPTIMIZER__ALPHA = eINSTANCE.getEAOptimizer_Alpha();

		/**
		 * The meta object literal for the '<em><b>Mu</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EA_OPTIMIZER__MU = eINSTANCE.getEAOptimizer_Mu();

		/**
		 * The meta object literal for the '<em><b>Iterations</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EA_OPTIMIZER__ITERATIONS = eINSTANCE.getEAOptimizer_Iterations();

		/**
		 * The meta object literal for the '<em><b>Spea2 Tournament</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EA_OPTIMIZER__SPEA2_TOURNAMENT = eINSTANCE.getEAOptimizer_Spea2Tournament();

		/**
		 * The meta object literal for the '<em><b>Parallel Execution</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EA_OPTIMIZER__PARALLEL_EXECUTION = eINSTANCE.getEAOptimizer_ParallelExecution();

		/**
		 * The meta object literal for the '{@link org.fortiss.af3.exploration.moea.model.parameters.ExecutionModel <em>Execution Model</em>}' enum.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.fortiss.af3.exploration.moea.model.parameters.ExecutionModel
		 * @see org.fortiss.af3.exploration.moea.model.parameters.impl.ParametersPackageImpl#getExecutionModel()
		 * @generated
		 */
		EEnum EXECUTION_MODEL = eINSTANCE.getExecutionModel();

	}

} //ParametersPackage
