/**
 */
package org.fortiss.af3.exploration.moea.model.predefined;

import org.eclipse.emf.common.util.EList;

import org.fortiss.af3.component.model.Component;

import org.fortiss.af3.exploration.model.ExplorationConstraint;

import org.fortiss.af3.platform.model.ExecutionUnit;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Component Multi Allocation Constraint</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * DEPRECATED/LEGACY. Defines to which {@link ExecutionUnit}s a {@link Component} may be allocated to.
 * <!-- end-model-doc -->
 *
 *
 * @see org.fortiss.af3.exploration.moea.model.predefined.PredefinedPackage#getComponentMultiAllocationConstraint()
 * @model superTypes="org.fortiss.af3.exploration.moea.model.predefined.MultiLocationConstraint<org.fortiss.af3.component.model.Component, org.fortiss.af3.platform.model.ExecutionUnit> org.fortiss.af3.exploration.model.ExplorationConstraint<org.eclipse.emf.ecore.EBooleanObject>"
 * @generated
 */
public interface ComponentMultiAllocationConstraint extends MultiLocationConstraint<Component, ExecutionUnit>, ExplorationConstraint<Boolean> {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Sets the set of allowed {@link ComponentAllocation}s for the given {@link Component} to the set of {@link ExecutionUnit}s. Here, any of the given {@link ExecutionUnit}s is a valid allocation traget, where the given {@link Component} is not required to have an instance on each of the given {@link ExecutionUnit}s.
	 * <!-- end-model-doc -->
	 * @model compRequired="true" execUnitsRequired="true" execUnitsMany="false"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel body='ComponentMultiAllocationConstraintStaticImpl.setComponentMultiAllocations(this, comp, execUnits);'"
	 * @generated
	 */
	void setComponentMultiAllocations(Component comp, EList<ExecutionUnit> execUnits);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Returns the {@link Component} which is restricted in it allocation targets.
	 * <!-- end-model-doc -->
	 * @model kind="operation" required="true"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel body='return getLeftMultiLocationModelElement();'"
	 * @generated
	 */
	Component getComponent();

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Returns the list of {@link ExecutionUnit}s which are allowed allocation targets.
	 * <!-- end-model-doc -->
	 * @model kind="operation" required="true" many="false"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel body='return getAllRightMultiLocationModelElements();'"
	 * @generated
	 */
	EList<ExecutionUnit> getExecutionUnits();

} // ComponentMultiAllocationConstraint
