/**
 */
package org.fortiss.af3.exploration.moea.model.predefined;

import org.fortiss.af3.component.model.Component;

import org.fortiss.af3.exploration.dsl.model.MOEAExplorationExpression;

import org.fortiss.af3.exploration.model.MOExplorationObjective;
import org.fortiss.af3.exploration.model.ResourceDimension;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Failure Min Objective</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * {@link ExplorationObjective} that minimizes the failure probability of a defined task.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.fortiss.af3.exploration.moea.model.predefined.FailureMinObjective#getMode <em>Mode</em>}</li>
 *   <li>{@link org.fortiss.af3.exploration.moea.model.predefined.FailureMinObjective#getType <em>Type</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.fortiss.af3.exploration.moea.model.predefined.PredefinedPackage#getFailureMinObjective()
 * @model superTypes="org.fortiss.af3.exploration.model.ResourceDimension org.fortiss.af3.exploration.dsl.model.MOEAExplorationExpression org.fortiss.af3.exploration.model.MOExplorationObjective<org.eclipse.emf.ecore.EDoubleObject>"
 * @generated
 */
public interface FailureMinObjective extends ResourceDimension, MOEAExplorationExpression, MOExplorationObjective<Double> {
	/**
	 * Returns the value of the '<em><b>Mode</b></em>' attribute.
	 * The default value is <code>"FailSafe"</code>.
	 * The literals are from the enumeration {@link org.fortiss.af3.exploration.moea.model.predefined.FailureMode}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Defines the failure modes of the tasks.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Mode</em>' attribute.
	 * @see org.fortiss.af3.exploration.moea.model.predefined.FailureMode
	 * @see #setMode(FailureMode)
	 * @see org.fortiss.af3.exploration.moea.model.predefined.PredefinedPackage#getFailureMinObjective_Mode()
	 * @model default="FailSafe" required="true"
	 * @generated
	 */
	FailureMode getMode();

	/**
	 * Sets the value of the '{@link org.fortiss.af3.exploration.moea.model.predefined.FailureMinObjective#getMode <em>Mode</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Mode</em>' attribute.
	 * @see org.fortiss.af3.exploration.moea.model.predefined.FailureMode
	 * @see #getMode()
	 * @generated
	 */
	void setMode(FailureMode value);

	/**
	 * Returns the value of the '<em><b>Type</b></em>' attribute.
	 * The literals are from the enumeration {@link org.fortiss.af3.exploration.moea.model.predefined.FailureType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Defines which types of failures shall be considered in the reliability analysis.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Type</em>' attribute.
	 * @see org.fortiss.af3.exploration.moea.model.predefined.FailureType
	 * @see #setType(FailureType)
	 * @see org.fortiss.af3.exploration.moea.model.predefined.PredefinedPackage#getFailureMinObjective_Type()
	 * @model required="true"
	 * @generated
	 */
	FailureType getType();

	/**
	 * Sets the value of the '{@link org.fortiss.af3.exploration.moea.model.predefined.FailureMinObjective#getType <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Type</em>' attribute.
	 * @see org.fortiss.af3.exploration.moea.model.predefined.FailureType
	 * @see #getType()
	 * @generated
	 */
	void setType(FailureType value);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Returns the {@link Component} that is the subject of the {@link ReliabilityAnalysis} which is the target of the minimization.
	 * <!-- end-model-doc -->
	 * @model kind="operation" required="true"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel body='return FailureMinObjectiveStaticImpl.getFailureMinTargetComponent(this);'"
	 * @generated
	 */
	Component getTargetComponent();

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Sets the given {@link Component} as the subject of the {@link ReliabilityAnalysis} which is the target of the minimization.
	 * <!-- end-model-doc -->
	 * @model targetComponentRequired="true"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel body='FailureMinObjectiveStaticImpl.setFailureMinTargetComponent(this, targetComponent);'"
	 * @generated
	 */
	void setTargetComponent(Component targetComponent);

} // FailureMinObjective
