/**
 */
package org.fortiss.af3.exploration.moea.model.predefined;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Failure Mode</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * <!-- begin-model-doc -->
 * Defines the failure modes of tasks.
 * <!-- end-model-doc -->
 * @see org.fortiss.af3.exploration.moea.model.predefined.PredefinedPackage#getFailureMode()
 * @model
 * @generated
 */
public enum FailureMode implements Enumerator {
	/**
	 * The '<em><b>Fail Safe</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #FAIL_SAFE_VALUE
	 * @generated
	 * @ordered
	 */
	FAIL_SAFE(0, "FailSafe", "FailSafe"),

	/**
	 * The '<em><b>Fail Operational</b></em>' literal object.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #FAIL_OPERATIONAL_VALUE
	 * @generated
	 * @ordered
	 */
	FAIL_OPERATIONAL(1, "FailOperational", "FailOperational");

	/**
	 * The '<em><b>Fail Safe</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Fail Safe</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #FAIL_SAFE
	 * @model name="FailSafe"
	 * @generated
	 * @ordered
	 */
	public static final int FAIL_SAFE_VALUE = 0;

	/**
	 * The '<em><b>Fail Operational</b></em>' literal value.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Fail Operational</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @see #FAIL_OPERATIONAL
	 * @model name="FailOperational"
	 * @generated
	 * @ordered
	 */
	public static final int FAIL_OPERATIONAL_VALUE = 1;

	/**
	 * An array of all the '<em><b>Failure Mode</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static final FailureMode[] VALUES_ARRAY =
		new FailureMode[] {
			FAIL_SAFE,
			FAIL_OPERATIONAL,
		};

	/**
	 * A public read-only list of all the '<em><b>Failure Mode</b></em>' enumerators.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final List<FailureMode> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
	 * Returns the '<em><b>Failure Mode</b></em>' literal with the specified literal value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static FailureMode get(String literal) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			FailureMode result = VALUES_ARRAY[i];
			if (result.toString().equals(literal)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Failure Mode</b></em>' literal with the specified name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static FailureMode getByName(String name) {
		for (int i = 0; i < VALUES_ARRAY.length; ++i) {
			FailureMode result = VALUES_ARRAY[i];
			if (result.getName().equals(name)) {
				return result;
			}
		}
		return null;
	}

	/**
	 * Returns the '<em><b>Failure Mode</b></em>' literal with the specified integer value.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static FailureMode get(int value) {
		switch (value) {
			case FAIL_SAFE_VALUE: return FAIL_SAFE;
			case FAIL_OPERATIONAL_VALUE: return FAIL_OPERATIONAL;
		}
		return null;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final int value;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String name;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private final String literal;

	/**
	 * Only this class can construct instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private FailureMode(int value, String name, String literal) {
		this.value = value;
		this.name = name;
		this.literal = literal;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getValue() {
	  return value;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
	  return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getLiteral() {
	  return literal;
	}

	/**
	 * Returns the literal value of the enumerator, which is its string representation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		return literal;
	}
	
} //FailureMode
