/**
 */
package org.fortiss.af3.exploration.moea.model.predefined;

import org.eclipse.emf.common.util.EList;

import org.fortiss.af3.component.model.Component;

import org.fortiss.af3.exploration.dsl.model.MOEAExplorationExpression;

import org.fortiss.af3.exploration.model.ExplorationConstraint;
import org.fortiss.af3.exploration.model.SafetyDimension;

import org.fortiss.af3.safety.model.SIL;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Safety Integrity Level Constraint</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * DEPRECATED/LEGACY. Defines for which {@link Component}s their specified SIL must be considered in the evaluation.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.fortiss.af3.exploration.moea.model.predefined.SafetyIntegrityLevelConstraint#getComponents <em>Components</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.fortiss.af3.exploration.moea.model.predefined.PredefinedPackage#getSafetyIntegrityLevelConstraint()
 * @model
 * @generated
 */
public interface SafetyIntegrityLevelConstraint extends ExplorationConstraint<SIL>, SafetyDimension, MOEAExplorationExpression {
	/**
	 * Returns the value of the '<em><b>Components</b></em>' reference list.
	 * The list contents are of type {@link org.fortiss.af3.component.model.Component}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * List of {@link Component}s whose SIL has to be considered in the allocation.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Components</em>' reference list.
	 * @see org.fortiss.af3.exploration.moea.model.predefined.PredefinedPackage#getSafetyIntegrityLevelConstraint_Components()
	 * @model required="true"
	 * @generated
	 */
	EList<Component> getComponents();

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * TODO: write documentation (in the model!)
	 * <!-- end-model-doc -->
	 * @model kind="operation" required="true" many="false"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel body='return SafetyIntegrityLevelConstraintStaticImpl.getLimitation(this);'"
	 * @generated
	 */
	EList<SIL> getLimitation();

} // SafetyIntegrityLevelConstraint
