/**
 */
package org.fortiss.af3.exploration.moea.model.predefined.impl;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

import org.fortiss.af3.exploration.moea.model.predefined.*;

import org.fortiss.tooling.base.model.element.IModelElement;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class PredefinedFactoryImpl extends EFactoryImpl implements PredefinedFactory {
	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static PredefinedFactory init() {
		try {
			PredefinedFactory thePredefinedFactory = (PredefinedFactory)EPackage.Registry.INSTANCE.getEFactory(PredefinedPackage.eNS_URI);
			if (thePredefinedFactory != null) {
				return thePredefinedFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new PredefinedFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PredefinedFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case PredefinedPackage.FAILURE_MIN_OBJECTIVE: return createFailureMinObjective();
			case PredefinedPackage.RELIABILITY_ANALYSIS: return createReliabilityAnalysis();
			case PredefinedPackage.ENERGY_MIN_OBJECTIVE: return createEnergyMinObjective();
			case PredefinedPackage.MULTI_LOCATION_CONSTRAINT: return createMultiLocationConstraint();
			case PredefinedPackage.COMPONENT_MULTI_ALLOCATION_CONSTRAINT: return createComponentMultiAllocationConstraint();
			case PredefinedPackage.COMPONENT_MULTI_DISLOCATION_CONSTRAINT: return createComponentMultiDislocationConstraint();
			case PredefinedPackage.SAFETY_INTEGRITY_LEVEL_CONSTRAINT: return createSafetyIntegrityLevelConstraint();
			case PredefinedPackage.SAFETY_COMPARISON: return createSafetyComparison();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object createFromString(EDataType eDataType, String initialValue) {
		switch (eDataType.getClassifierID()) {
			case PredefinedPackage.FAILURE_MODE:
				return createFailureModeFromString(eDataType, initialValue);
			case PredefinedPackage.FAILURE_TYPE:
				return createFailureTypeFromString(eDataType, initialValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String convertToString(EDataType eDataType, Object instanceValue) {
		switch (eDataType.getClassifierID()) {
			case PredefinedPackage.FAILURE_MODE:
				return convertFailureModeToString(eDataType, instanceValue);
			case PredefinedPackage.FAILURE_TYPE:
				return convertFailureTypeToString(eDataType, instanceValue);
			default:
				throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public FailureMinObjective createFailureMinObjective() {
		FailureMinObjectiveImpl failureMinObjective = new FailureMinObjectiveImpl();
		return failureMinObjective;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ReliabilityAnalysis createReliabilityAnalysis() {
		ReliabilityAnalysisImpl reliabilityAnalysis = new ReliabilityAnalysisImpl();
		return reliabilityAnalysis;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EnergyMinObjective createEnergyMinObjective() {
		EnergyMinObjectiveImpl energyMinObjective = new EnergyMinObjectiveImpl();
		return energyMinObjective;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public <LHT extends IModelElement, RHT extends IModelElement> MultiLocationConstraint<LHT, RHT> createMultiLocationConstraint() {
		MultiLocationConstraintImpl<LHT, RHT> multiLocationConstraint = new MultiLocationConstraintImpl<LHT, RHT>();
		return multiLocationConstraint;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ComponentMultiAllocationConstraint createComponentMultiAllocationConstraint() {
		ComponentMultiAllocationConstraintImpl componentMultiAllocationConstraint = new ComponentMultiAllocationConstraintImpl();
		return componentMultiAllocationConstraint;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ComponentMultiDislocationConstraint createComponentMultiDislocationConstraint() {
		ComponentMultiDislocationConstraintImpl componentMultiDislocationConstraint = new ComponentMultiDislocationConstraintImpl();
		return componentMultiDislocationConstraint;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SafetyIntegrityLevelConstraint createSafetyIntegrityLevelConstraint() {
		SafetyIntegrityLevelConstraintImpl safetyIntegrityLevelConstraint = new SafetyIntegrityLevelConstraintImpl();
		return safetyIntegrityLevelConstraint;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public <T> SafetyComparison<T> createSafetyComparison() {
		SafetyComparisonImpl<T> safetyComparison = new SafetyComparisonImpl<T>();
		return safetyComparison;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public FailureMode createFailureModeFromString(EDataType eDataType, String initialValue) {
		FailureMode result = FailureMode.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertFailureModeToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public FailureType createFailureTypeFromString(EDataType eDataType, String initialValue) {
		FailureType result = FailureType.get(initialValue);
		if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
		return result;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String convertFailureTypeToString(EDataType eDataType, Object instanceValue) {
		return instanceValue == null ? null : instanceValue.toString();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PredefinedPackage getPredefinedPackage() {
		return (PredefinedPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static PredefinedPackage getPackage() {
		return PredefinedPackage.eINSTANCE;
	}

} //PredefinedFactoryImpl
