/**
 */
package org.fortiss.af3.exploration.moea.model.predefined.util;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;

import org.fortiss.af3.exploration.dsl.model.MOEAExplorationExpression;

import org.fortiss.af3.exploration.dsl.model.expressions.ArithmeticExpression;
import org.fortiss.af3.exploration.dsl.model.expressions.BooleanExpression;
import org.fortiss.af3.exploration.dsl.model.expressions.ElementExpression;
import org.fortiss.af3.exploration.dsl.model.expressions.Expression;

import org.fortiss.af3.exploration.dsl.model.operators.ComparisonOp;
import org.fortiss.af3.exploration.dsl.model.operators.DualOperator;
import org.fortiss.af3.exploration.dsl.model.operators.Operator;

import org.fortiss.af3.exploration.model.EnergyDimension;
import org.fortiss.af3.exploration.model.ExplorationConstraint;
import org.fortiss.af3.exploration.model.ExplorationObjective;
import org.fortiss.af3.exploration.model.ExplorationTarget;
import org.fortiss.af3.exploration.model.IProblemDimension;
import org.fortiss.af3.exploration.model.MOExplorationObjective;
import org.fortiss.af3.exploration.model.ResourceDimension;
import org.fortiss.af3.exploration.model.SafetyDimension;

import org.fortiss.af3.exploration.model.location.LocationConstraint;
import org.fortiss.af3.exploration.model.location.LocationDimension;

import org.fortiss.af3.exploration.moea.model.predefined.*;

import org.fortiss.tooling.base.model.element.IModelElement;

import org.fortiss.tooling.kernel.model.IIdLabeled;
import org.fortiss.tooling.kernel.model.INamedCommentedElement;
import org.fortiss.tooling.kernel.model.INamedElement;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see org.fortiss.af3.exploration.moea.model.predefined.PredefinedPackage
 * @generated
 */
public class PredefinedAdapterFactory extends AdapterFactoryImpl {
	/**
	 * The cached model package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static PredefinedPackage modelPackage;

	/**
	 * Creates an instance of the adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PredefinedAdapterFactory() {
		if (modelPackage == null) {
			modelPackage = PredefinedPackage.eINSTANCE;
		}
	}

	/**
	 * Returns whether this factory is applicable for the type of the object.
	 * <!-- begin-user-doc -->
	 * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
	 * <!-- end-user-doc -->
	 * @return whether this factory is applicable for the type of the object.
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object object) {
		if (object == modelPackage) {
			return true;
		}
		if (object instanceof EObject) {
			return ((EObject)object).eClass().getEPackage() == modelPackage;
		}
		return false;
	}

	/**
	 * The switch that delegates to the <code>createXXX</code> methods.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PredefinedSwitch<Adapter> modelSwitch =
		new PredefinedSwitch<Adapter>() {
			@Override
			public Adapter caseFailureMinObjective(FailureMinObjective object) {
				return createFailureMinObjectiveAdapter();
			}
			@Override
			public Adapter caseReliabilityAnalysis(ReliabilityAnalysis object) {
				return createReliabilityAnalysisAdapter();
			}
			@Override
			public Adapter caseEnergyMinObjective(EnergyMinObjective object) {
				return createEnergyMinObjectiveAdapter();
			}
			@Override
			public <LHT extends IModelElement, RHT extends IModelElement> Adapter caseMultiLocationConstraint(MultiLocationConstraint<LHT, RHT> object) {
				return createMultiLocationConstraintAdapter();
			}
			@Override
			public Adapter caseComponentMultiAllocationConstraint(ComponentMultiAllocationConstraint object) {
				return createComponentMultiAllocationConstraintAdapter();
			}
			@Override
			public Adapter caseComponentMultiDislocationConstraint(ComponentMultiDislocationConstraint object) {
				return createComponentMultiDislocationConstraintAdapter();
			}
			@Override
			public Adapter caseSafetyIntegrityLevelConstraint(SafetyIntegrityLevelConstraint object) {
				return createSafetyIntegrityLevelConstraintAdapter();
			}
			@Override
			public <T> Adapter caseSafetyComparison(SafetyComparison<T> object) {
				return createSafetyComparisonAdapter();
			}
			@Override
			public Adapter caseIIdLabeled(IIdLabeled object) {
				return createIIdLabeledAdapter();
			}
			@Override
			public Adapter caseINamedElement(INamedElement object) {
				return createINamedElementAdapter();
			}
			@Override
			public Adapter caseINamedCommentedElement(INamedCommentedElement object) {
				return createINamedCommentedElementAdapter();
			}
			@Override
			public Adapter caseIProblemDimension(IProblemDimension object) {
				return createIProblemDimensionAdapter();
			}
			@Override
			public Adapter caseResourceDimension(ResourceDimension object) {
				return createResourceDimensionAdapter();
			}
			@Override
			public Adapter caseMOEAExplorationExpression(MOEAExplorationExpression object) {
				return createMOEAExplorationExpressionAdapter();
			}
			@Override
			public <T> Adapter caseExplorationTarget(ExplorationTarget<T> object) {
				return createExplorationTargetAdapter();
			}
			@Override
			public <T> Adapter caseExplorationObjective(ExplorationObjective<T> object) {
				return createExplorationObjectiveAdapter();
			}
			@Override
			public <T> Adapter caseMOExplorationObjective(MOExplorationObjective<T> object) {
				return createMOExplorationObjectiveAdapter();
			}
			@Override
			public Adapter caseExpression(Expression object) {
				return createExpressionAdapter();
			}
			@Override
			public <T> Adapter caseArithmeticExpression(ArithmeticExpression<T> object) {
				return createArithmeticExpressionAdapter();
			}
			@Override
			public <ME extends IModelElement> Adapter caseElementExpression(ElementExpression<ME> object) {
				return createElementExpressionAdapter();
			}
			@Override
			public Adapter caseEnergyDimension(EnergyDimension object) {
				return createEnergyDimensionAdapter();
			}
			@Override
			public Adapter caseLocationDimension(LocationDimension object) {
				return createLocationDimensionAdapter();
			}
			@Override
			public <LHT extends IModelElement, RHT extends IModelElement> Adapter caseLocationConstraint(LocationConstraint<LHT, RHT> object) {
				return createLocationConstraintAdapter();
			}
			@Override
			public <T> Adapter caseExplorationConstraint(ExplorationConstraint<T> object) {
				return createExplorationConstraintAdapter();
			}
			@Override
			public Adapter caseSafetyDimension(SafetyDimension object) {
				return createSafetyDimensionAdapter();
			}
			@Override
			public <OP, RHT> Adapter caseOperator(Operator<OP, RHT> object) {
				return createOperatorAdapter();
			}
			@Override
			public <LHT, OP, RHT> Adapter caseDualOperator(DualOperator<LHT, OP, RHT> object) {
				return createDualOperatorAdapter();
			}
			@Override
			public Adapter caseBooleanExpression(BooleanExpression object) {
				return createBooleanExpressionAdapter();
			}
			@Override
			public <T, LHT extends ArithmeticExpression<T>, RHT extends ArithmeticExpression<T>> Adapter caseComparisonOp(ComparisonOp<T, LHT, RHT> object) {
				return createComparisonOpAdapter();
			}
			@Override
			public Adapter defaultCase(EObject object) {
				return createEObjectAdapter();
			}
		};

	/**
	 * Creates an adapter for the <code>target</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param target the object to adapt.
	 * @return the adapter for the <code>target</code>.
	 * @generated
	 */
	@Override
	public Adapter createAdapter(Notifier target) {
		return modelSwitch.doSwitch((EObject)target);
	}


	/**
	 * Creates a new adapter for an object of class '{@link org.fortiss.af3.exploration.moea.model.predefined.FailureMinObjective <em>Failure Min Objective</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.fortiss.af3.exploration.moea.model.predefined.FailureMinObjective
	 * @generated
	 */
	public Adapter createFailureMinObjectiveAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.fortiss.af3.exploration.moea.model.predefined.ReliabilityAnalysis <em>Reliability Analysis</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.fortiss.af3.exploration.moea.model.predefined.ReliabilityAnalysis
	 * @generated
	 */
	public Adapter createReliabilityAnalysisAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.fortiss.af3.exploration.moea.model.predefined.EnergyMinObjective <em>Energy Min Objective</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.fortiss.af3.exploration.moea.model.predefined.EnergyMinObjective
	 * @generated
	 */
	public Adapter createEnergyMinObjectiveAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.fortiss.af3.exploration.moea.model.predefined.MultiLocationConstraint <em>Multi Location Constraint</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.fortiss.af3.exploration.moea.model.predefined.MultiLocationConstraint
	 * @generated
	 */
	public Adapter createMultiLocationConstraintAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.fortiss.af3.exploration.moea.model.predefined.ComponentMultiAllocationConstraint <em>Component Multi Allocation Constraint</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.fortiss.af3.exploration.moea.model.predefined.ComponentMultiAllocationConstraint
	 * @generated
	 */
	public Adapter createComponentMultiAllocationConstraintAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.fortiss.af3.exploration.moea.model.predefined.ComponentMultiDislocationConstraint <em>Component Multi Dislocation Constraint</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.fortiss.af3.exploration.moea.model.predefined.ComponentMultiDislocationConstraint
	 * @generated
	 */
	public Adapter createComponentMultiDislocationConstraintAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.fortiss.af3.exploration.moea.model.predefined.SafetyIntegrityLevelConstraint <em>Safety Integrity Level Constraint</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.fortiss.af3.exploration.moea.model.predefined.SafetyIntegrityLevelConstraint
	 * @generated
	 */
	public Adapter createSafetyIntegrityLevelConstraintAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.fortiss.af3.exploration.moea.model.predefined.SafetyComparison <em>Safety Comparison</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.fortiss.af3.exploration.moea.model.predefined.SafetyComparison
	 * @generated
	 */
	public Adapter createSafetyComparisonAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.fortiss.tooling.kernel.model.IIdLabeled <em>IId Labeled</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.fortiss.tooling.kernel.model.IIdLabeled
	 * @generated
	 */
	public Adapter createIIdLabeledAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.fortiss.tooling.kernel.model.INamedElement <em>INamed Element</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.fortiss.tooling.kernel.model.INamedElement
	 * @generated
	 */
	public Adapter createINamedElementAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.fortiss.tooling.kernel.model.INamedCommentedElement <em>INamed Commented Element</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.fortiss.tooling.kernel.model.INamedCommentedElement
	 * @generated
	 */
	public Adapter createINamedCommentedElementAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.fortiss.af3.exploration.model.IProblemDimension <em>IProblem Dimension</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.fortiss.af3.exploration.model.IProblemDimension
	 * @generated
	 */
	public Adapter createIProblemDimensionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.fortiss.af3.exploration.model.ResourceDimension <em>Resource Dimension</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.fortiss.af3.exploration.model.ResourceDimension
	 * @generated
	 */
	public Adapter createResourceDimensionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.fortiss.af3.exploration.dsl.model.MOEAExplorationExpression <em>MOEA Exploration Expression</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.fortiss.af3.exploration.dsl.model.MOEAExplorationExpression
	 * @generated
	 */
	public Adapter createMOEAExplorationExpressionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.fortiss.af3.exploration.model.ExplorationTarget <em>Target</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.fortiss.af3.exploration.model.ExplorationTarget
	 * @generated
	 */
	public Adapter createExplorationTargetAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.fortiss.af3.exploration.model.ExplorationObjective <em>Objective</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.fortiss.af3.exploration.model.ExplorationObjective
	 * @generated
	 */
	public Adapter createExplorationObjectiveAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.fortiss.af3.exploration.model.MOExplorationObjective <em>MO Exploration Objective</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.fortiss.af3.exploration.model.MOExplorationObjective
	 * @generated
	 */
	public Adapter createMOExplorationObjectiveAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.fortiss.af3.exploration.dsl.model.expressions.Expression <em>Expression</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.fortiss.af3.exploration.dsl.model.expressions.Expression
	 * @generated
	 */
	public Adapter createExpressionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.fortiss.af3.exploration.dsl.model.expressions.ArithmeticExpression <em>Arithmetic Expression</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.fortiss.af3.exploration.dsl.model.expressions.ArithmeticExpression
	 * @generated
	 */
	public Adapter createArithmeticExpressionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.fortiss.af3.exploration.dsl.model.expressions.ElementExpression <em>Element Expression</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.fortiss.af3.exploration.dsl.model.expressions.ElementExpression
	 * @generated
	 */
	public Adapter createElementExpressionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.fortiss.af3.exploration.model.EnergyDimension <em>Energy Dimension</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.fortiss.af3.exploration.model.EnergyDimension
	 * @generated
	 */
	public Adapter createEnergyDimensionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.fortiss.af3.exploration.model.location.LocationDimension <em>Dimension</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.fortiss.af3.exploration.model.location.LocationDimension
	 * @generated
	 */
	public Adapter createLocationDimensionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.fortiss.af3.exploration.model.location.LocationConstraint <em>Constraint</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.fortiss.af3.exploration.model.location.LocationConstraint
	 * @generated
	 */
	public Adapter createLocationConstraintAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.fortiss.af3.exploration.model.ExplorationConstraint <em>Constraint</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.fortiss.af3.exploration.model.ExplorationConstraint
	 * @generated
	 */
	public Adapter createExplorationConstraintAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.fortiss.af3.exploration.model.SafetyDimension <em>Safety Dimension</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.fortiss.af3.exploration.model.SafetyDimension
	 * @generated
	 */
	public Adapter createSafetyDimensionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.fortiss.af3.exploration.dsl.model.operators.Operator <em>Operator</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.fortiss.af3.exploration.dsl.model.operators.Operator
	 * @generated
	 */
	public Adapter createOperatorAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.fortiss.af3.exploration.dsl.model.operators.DualOperator <em>Dual Operator</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.fortiss.af3.exploration.dsl.model.operators.DualOperator
	 * @generated
	 */
	public Adapter createDualOperatorAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.fortiss.af3.exploration.dsl.model.expressions.BooleanExpression <em>Boolean Expression</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.fortiss.af3.exploration.dsl.model.expressions.BooleanExpression
	 * @generated
	 */
	public Adapter createBooleanExpressionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.fortiss.af3.exploration.dsl.model.operators.ComparisonOp <em>Comparison Op</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.fortiss.af3.exploration.dsl.model.operators.ComparisonOp
	 * @generated
	 */
	public Adapter createComparisonOpAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for the default case.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @generated
	 */
	public Adapter createEObjectAdapter() {
		return null;
	}

} //PredefinedAdapterFactory
