/**
 */
package org.fortiss.af3.exploration.moea.model.predefined.util;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.util.Switch;

import org.fortiss.af3.exploration.dsl.model.MOEAExplorationExpression;

import org.fortiss.af3.exploration.dsl.model.expressions.ArithmeticExpression;
import org.fortiss.af3.exploration.dsl.model.expressions.BooleanExpression;
import org.fortiss.af3.exploration.dsl.model.expressions.ElementExpression;
import org.fortiss.af3.exploration.dsl.model.expressions.Expression;

import org.fortiss.af3.exploration.dsl.model.operators.ComparisonOp;
import org.fortiss.af3.exploration.dsl.model.operators.DualOperator;
import org.fortiss.af3.exploration.dsl.model.operators.Operator;

import org.fortiss.af3.exploration.model.EnergyDimension;
import org.fortiss.af3.exploration.model.ExplorationConstraint;
import org.fortiss.af3.exploration.model.ExplorationObjective;
import org.fortiss.af3.exploration.model.ExplorationTarget;
import org.fortiss.af3.exploration.model.IProblemDimension;
import org.fortiss.af3.exploration.model.MOExplorationObjective;
import org.fortiss.af3.exploration.model.ResourceDimension;
import org.fortiss.af3.exploration.model.SafetyDimension;

import org.fortiss.af3.exploration.model.location.LocationConstraint;
import org.fortiss.af3.exploration.model.location.LocationDimension;

import org.fortiss.af3.exploration.moea.model.predefined.*;

import org.fortiss.tooling.base.model.element.IModelElement;

import org.fortiss.tooling.kernel.model.IIdLabeled;
import org.fortiss.tooling.kernel.model.INamedCommentedElement;
import org.fortiss.tooling.kernel.model.INamedElement;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see org.fortiss.af3.exploration.moea.model.predefined.PredefinedPackage
 * @generated
 */
public class PredefinedSwitch<T1> extends Switch<T1> {
	/**
	 * The cached model package
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static PredefinedPackage modelPackage;

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PredefinedSwitch() {
		if (modelPackage == null) {
			modelPackage = PredefinedPackage.eINSTANCE;
		}
	}

	/**
	 * Checks whether this is a switch for the given package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @parameter ePackage the package in question.
	 * @return whether this is a switch for the given package.
	 * @generated
	 */
	@Override
	protected boolean isSwitchFor(EPackage ePackage) {
		return ePackage == modelPackage;
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	@Override
	protected T1 doSwitch(int classifierID, EObject theEObject) {
		switch (classifierID) {
			case PredefinedPackage.FAILURE_MIN_OBJECTIVE: {
				FailureMinObjective failureMinObjective = (FailureMinObjective)theEObject;
				T1 result = caseFailureMinObjective(failureMinObjective);
				if (result == null) result = caseResourceDimension(failureMinObjective);
				if (result == null) result = caseMOEAExplorationExpression(failureMinObjective);
				if (result == null) result = caseMOExplorationObjective(failureMinObjective);
				if (result == null) result = caseIProblemDimension(failureMinObjective);
				if (result == null) result = caseExplorationObjective(failureMinObjective);
				if (result == null) result = caseExplorationTarget(failureMinObjective);
				if (result == null) result = caseINamedCommentedElement(failureMinObjective);
				if (result == null) result = caseINamedElement(failureMinObjective);
				if (result == null) result = caseIIdLabeled(failureMinObjective);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case PredefinedPackage.RELIABILITY_ANALYSIS: {
				ReliabilityAnalysis reliabilityAnalysis = (ReliabilityAnalysis)theEObject;
				T1 result = caseReliabilityAnalysis(reliabilityAnalysis);
				if (result == null) result = caseArithmeticExpression(reliabilityAnalysis);
				if (result == null) result = caseElementExpression(reliabilityAnalysis);
				if (result == null) result = caseMOEAExplorationExpression(reliabilityAnalysis);
				if (result == null) result = caseExpression(reliabilityAnalysis);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case PredefinedPackage.ENERGY_MIN_OBJECTIVE: {
				EnergyMinObjective energyMinObjective = (EnergyMinObjective)theEObject;
				T1 result = caseEnergyMinObjective(energyMinObjective);
				if (result == null) result = caseMOExplorationObjective(energyMinObjective);
				if (result == null) result = caseEnergyDimension(energyMinObjective);
				if (result == null) result = caseMOEAExplorationExpression(energyMinObjective);
				if (result == null) result = caseExplorationObjective(energyMinObjective);
				if (result == null) result = caseIProblemDimension(energyMinObjective);
				if (result == null) result = caseExplorationTarget(energyMinObjective);
				if (result == null) result = caseINamedCommentedElement(energyMinObjective);
				if (result == null) result = caseINamedElement(energyMinObjective);
				if (result == null) result = caseIIdLabeled(energyMinObjective);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case PredefinedPackage.MULTI_LOCATION_CONSTRAINT: {
				MultiLocationConstraint<?, ?> multiLocationConstraint = (MultiLocationConstraint<?, ?>)theEObject;
				T1 result = caseMultiLocationConstraint(multiLocationConstraint);
				if (result == null) result = caseLocationConstraint(multiLocationConstraint);
				if (result == null) result = caseLocationDimension(multiLocationConstraint);
				if (result == null) result = caseMOEAExplorationExpression(multiLocationConstraint);
				if (result == null) result = caseIProblemDimension(multiLocationConstraint);
				if (result == null) result = caseINamedCommentedElement(multiLocationConstraint);
				if (result == null) result = caseINamedElement(multiLocationConstraint);
				if (result == null) result = caseIIdLabeled(multiLocationConstraint);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case PredefinedPackage.COMPONENT_MULTI_ALLOCATION_CONSTRAINT: {
				ComponentMultiAllocationConstraint componentMultiAllocationConstraint = (ComponentMultiAllocationConstraint)theEObject;
				T1 result = caseComponentMultiAllocationConstraint(componentMultiAllocationConstraint);
				if (result == null) result = caseMultiLocationConstraint(componentMultiAllocationConstraint);
				if (result == null) result = caseExplorationConstraint(componentMultiAllocationConstraint);
				if (result == null) result = caseLocationConstraint(componentMultiAllocationConstraint);
				if (result == null) result = caseExplorationTarget(componentMultiAllocationConstraint);
				if (result == null) result = caseLocationDimension(componentMultiAllocationConstraint);
				if (result == null) result = caseMOEAExplorationExpression(componentMultiAllocationConstraint);
				if (result == null) result = caseIProblemDimension(componentMultiAllocationConstraint);
				if (result == null) result = caseINamedCommentedElement(componentMultiAllocationConstraint);
				if (result == null) result = caseINamedElement(componentMultiAllocationConstraint);
				if (result == null) result = caseIIdLabeled(componentMultiAllocationConstraint);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case PredefinedPackage.COMPONENT_MULTI_DISLOCATION_CONSTRAINT: {
				ComponentMultiDislocationConstraint componentMultiDislocationConstraint = (ComponentMultiDislocationConstraint)theEObject;
				T1 result = caseComponentMultiDislocationConstraint(componentMultiDislocationConstraint);
				if (result == null) result = caseMultiLocationConstraint(componentMultiDislocationConstraint);
				if (result == null) result = caseExplorationConstraint(componentMultiDislocationConstraint);
				if (result == null) result = caseLocationConstraint(componentMultiDislocationConstraint);
				if (result == null) result = caseExplorationTarget(componentMultiDislocationConstraint);
				if (result == null) result = caseLocationDimension(componentMultiDislocationConstraint);
				if (result == null) result = caseMOEAExplorationExpression(componentMultiDislocationConstraint);
				if (result == null) result = caseIProblemDimension(componentMultiDislocationConstraint);
				if (result == null) result = caseINamedCommentedElement(componentMultiDislocationConstraint);
				if (result == null) result = caseINamedElement(componentMultiDislocationConstraint);
				if (result == null) result = caseIIdLabeled(componentMultiDislocationConstraint);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case PredefinedPackage.SAFETY_INTEGRITY_LEVEL_CONSTRAINT: {
				SafetyIntegrityLevelConstraint safetyIntegrityLevelConstraint = (SafetyIntegrityLevelConstraint)theEObject;
				T1 result = caseSafetyIntegrityLevelConstraint(safetyIntegrityLevelConstraint);
				if (result == null) result = caseExplorationConstraint(safetyIntegrityLevelConstraint);
				if (result == null) result = caseSafetyDimension(safetyIntegrityLevelConstraint);
				if (result == null) result = caseMOEAExplorationExpression(safetyIntegrityLevelConstraint);
				if (result == null) result = caseExplorationTarget(safetyIntegrityLevelConstraint);
				if (result == null) result = caseIProblemDimension(safetyIntegrityLevelConstraint);
				if (result == null) result = caseINamedCommentedElement(safetyIntegrityLevelConstraint);
				if (result == null) result = caseINamedElement(safetyIntegrityLevelConstraint);
				if (result == null) result = caseIIdLabeled(safetyIntegrityLevelConstraint);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case PredefinedPackage.SAFETY_COMPARISON: {
				SafetyComparison<?> safetyComparison = (SafetyComparison<?>)theEObject;
				T1 result = caseSafetyComparison(safetyComparison);
				if (result == null) result = caseComparisonOp(safetyComparison);
				if (result == null) result = caseDualOperator(safetyComparison);
				if (result == null) result = caseBooleanExpression(safetyComparison);
				if (result == null) result = caseOperator(safetyComparison);
				if (result == null) result = caseExpression(safetyComparison);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			default: return defaultCase(theEObject);
		}
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Failure Min Objective</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Failure Min Objective</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T1 caseFailureMinObjective(FailureMinObjective object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Reliability Analysis</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Reliability Analysis</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T1 caseReliabilityAnalysis(ReliabilityAnalysis object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Energy Min Objective</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Energy Min Objective</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T1 caseEnergyMinObjective(EnergyMinObjective object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Multi Location Constraint</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Multi Location Constraint</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public <LHT extends IModelElement, RHT extends IModelElement> T1 caseMultiLocationConstraint(MultiLocationConstraint<LHT, RHT> object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Component Multi Allocation Constraint</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Component Multi Allocation Constraint</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T1 caseComponentMultiAllocationConstraint(ComponentMultiAllocationConstraint object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Component Multi Dislocation Constraint</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Component Multi Dislocation Constraint</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T1 caseComponentMultiDislocationConstraint(ComponentMultiDislocationConstraint object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Safety Integrity Level Constraint</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Safety Integrity Level Constraint</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T1 caseSafetyIntegrityLevelConstraint(SafetyIntegrityLevelConstraint object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Safety Comparison</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Safety Comparison</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public <T> T1 caseSafetyComparison(SafetyComparison<T> object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>IId Labeled</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>IId Labeled</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T1 caseIIdLabeled(IIdLabeled object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>INamed Element</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>INamed Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T1 caseINamedElement(INamedElement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>INamed Commented Element</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>INamed Commented Element</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T1 caseINamedCommentedElement(INamedCommentedElement object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>IProblem Dimension</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>IProblem Dimension</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T1 caseIProblemDimension(IProblemDimension object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Resource Dimension</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Resource Dimension</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T1 caseResourceDimension(ResourceDimension object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MOEA Exploration Expression</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MOEA Exploration Expression</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T1 caseMOEAExplorationExpression(MOEAExplorationExpression object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Target</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Target</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public <T> T1 caseExplorationTarget(ExplorationTarget<T> object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Objective</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Objective</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public <T> T1 caseExplorationObjective(ExplorationObjective<T> object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>MO Exploration Objective</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>MO Exploration Objective</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public <T> T1 caseMOExplorationObjective(MOExplorationObjective<T> object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Expression</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Expression</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T1 caseExpression(Expression object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Arithmetic Expression</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Arithmetic Expression</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public <T> T1 caseArithmeticExpression(ArithmeticExpression<T> object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Element Expression</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Element Expression</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public <ME extends IModelElement> T1 caseElementExpression(ElementExpression<ME> object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Energy Dimension</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Energy Dimension</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T1 caseEnergyDimension(EnergyDimension object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Dimension</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Dimension</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T1 caseLocationDimension(LocationDimension object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Constraint</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Constraint</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public <LHT extends IModelElement, RHT extends IModelElement> T1 caseLocationConstraint(LocationConstraint<LHT, RHT> object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Constraint</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Constraint</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public <T> T1 caseExplorationConstraint(ExplorationConstraint<T> object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Safety Dimension</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Safety Dimension</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T1 caseSafetyDimension(SafetyDimension object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Operator</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Operator</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public <OP, RHT> T1 caseOperator(Operator<OP, RHT> object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Dual Operator</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Dual Operator</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public <LHT, OP, RHT> T1 caseDualOperator(DualOperator<LHT, OP, RHT> object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Boolean Expression</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Boolean Expression</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T1 caseBooleanExpression(BooleanExpression object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Comparison Op</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Comparison Op</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public <T, LHT extends ArithmeticExpression<T>, RHT extends ArithmeticExpression<T>> T1 caseComparisonOp(ComparisonOp<T, LHT, RHT> object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch, but this is the last case anyway.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject)
	 * @generated
	 */
	@Override
	public T1 defaultCase(EObject object) {
		return null;
	}

} //PredefinedSwitch
