/**
 */
package org.fortiss.af3.exploration.moea.model.solutions;

import org.eclipse.emf.common.util.EList;

import org.fortiss.af3.exploration.model.ExplorationSolution;
import org.fortiss.af3.exploration.model.ExplorationSpecification;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Exploration Solution Set</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * Contains the set of {@link ExplorationSolution}s that are solutions to the problem defined in the {@link ExplorationSpecification}.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.fortiss.af3.exploration.moea.model.solutions.ExplorationSolutionSet#getInputModelAdapter <em>Input Model Adapter</em>}</li>
 *   <li>{@link org.fortiss.af3.exploration.moea.model.solutions.ExplorationSolutionSet#getTargetSpecification <em>Target Specification</em>}</li>
 *   <li>{@link org.fortiss.af3.exploration.moea.model.solutions.ExplorationSolutionSet#getSolutions <em>Solutions</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.fortiss.af3.exploration.moea.model.solutions.SolutionsPackage#getExplorationSolutionSet()
 * @model
 * @generated
 */
public interface ExplorationSolutionSet extends ExplorationSolution {
	/**
	 * Returns the value of the '<em><b>Input Model Adapter</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * References the corresponding input models.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Input Model Adapter</em>' attribute.
	 * @see #setInputModelAdapter(Object)
	 * @see org.fortiss.af3.exploration.moea.model.solutions.SolutionsPackage#getExplorationSolutionSet_InputModelAdapter()
	 * @model required="true"
	 * @generated
	 */
	Object getInputModelAdapter();

	/**
	 * Sets the value of the '{@link org.fortiss.af3.exploration.moea.model.solutions.ExplorationSolutionSet#getInputModelAdapter <em>Input Model Adapter</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Input Model Adapter</em>' attribute.
	 * @see #getInputModelAdapter()
	 * @generated
	 */
	void setInputModelAdapter(Object value);

	/**
	 * Returns the value of the '<em><b>Target Specification</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * References the {@link ExplorationSpecification} for which {@this ExplorationSolutionSet} provides solutions.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Target Specification</em>' reference.
	 * @see #setTargetSpecification(ExplorationSpecification)
	 * @see org.fortiss.af3.exploration.moea.model.solutions.SolutionsPackage#getExplorationSolutionSet_TargetSpecification()
	 * @model required="true"
	 * @generated
	 */
	ExplorationSpecification getTargetSpecification();

	/**
	 * Sets the value of the '{@link org.fortiss.af3.exploration.moea.model.solutions.ExplorationSolutionSet#getTargetSpecification <em>Target Specification</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Target Specification</em>' reference.
	 * @see #getTargetSpecification()
	 * @generated
	 */
	void setTargetSpecification(ExplorationSpecification value);

	/**
	 * Returns the value of the '<em><b>Solutions</b></em>' containment reference list.
	 * The list contents are of type {@link org.fortiss.af3.exploration.moea.model.solutions.SingleExplorationSolutionMap}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Contains the single solutions that are maps relating the {@link ExplorationTarget}s with their (evaluation) {@link ExplorationResult}s.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Solutions</em>' containment reference list.
	 * @see org.fortiss.af3.exploration.moea.model.solutions.SolutionsPackage#getExplorationSolutionSet_Solutions()
	 * @model containment="true" resolveProxies="true"
	 * @generated
	 */
	EList<SingleExplorationSolutionMap> getSolutions();

} // ExplorationSolutionSet
