/**
 */
package org.fortiss.af3.exploration.moea.model.solutions;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.EMap;

import org.eclipse.emf.ecore.EObject;

import org.fortiss.af3.exploration.model.ExplorationTarget;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Single Exploration Solution Map</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * Represents a single solution as a map relating the {@link ExplorationTarget}s with their (evaluation) {@link ExplorationResult}s.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.fortiss.af3.exploration.moea.model.solutions.SingleExplorationSolutionMap#getSolutionMap <em>Solution Map</em>}</li>
 *   <li>{@link org.fortiss.af3.exploration.moea.model.solutions.SingleExplorationSolutionMap#getSolutionModelMap <em>Solution Model Map</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.fortiss.af3.exploration.moea.model.solutions.SolutionsPackage#getSingleExplorationSolutionMap()
 * @model
 * @generated
 */
public interface SingleExplorationSolutionMap extends EObject {
	/**
	 * Returns the value of the '<em><b>Solution Map</b></em>' map.
	 * The key is of type {@link org.fortiss.af3.exploration.model.ExplorationTarget<?>},
	 * and the value is of type {@link org.fortiss.af3.exploration.moea.model.solutions.ExplorationResult<?>},
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * EMF-implementation of the backend map.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Solution Map</em>' map.
	 * @see org.fortiss.af3.exploration.moea.model.solutions.SolutionsPackage#getSingleExplorationSolutionMap_SolutionMap()
	 * @model mapType="org.fortiss.af3.exploration.moea.model.solutions.ExplorationTargetToExplorationResultMap<org.fortiss.af3.exploration.model.ExplorationTarget<?>, org.fortiss.af3.exploration.moea.model.solutions.ExplorationResult<?>>"
	 * @generated
	 */
	EMap<ExplorationTarget<?>, ExplorationResult<?>> getSolutionMap();

	/**
	 * Returns the value of the '<em><b>Solution Model Map</b></em>' map.
	 * The key is of type {@link java.lang.Class<?>},
	 * and the value is of type {@link java.lang.Object},
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Allows to optionally attach calculated solution models to a single solution. They are identified by their type.
	 * <!-- end-model-doc -->
	 * @return the value of the '<em>Solution Model Map</em>' map.
	 * @see org.fortiss.af3.exploration.moea.model.solutions.SolutionsPackage#getSingleExplorationSolutionMap_SolutionModelMap()
	 * @model mapType="org.fortiss.af3.exploration.moea.model.solutions.EJavaClassToEJavaObjectMap<org.eclipse.emf.ecore.EJavaClass<?>, org.eclipse.emf.ecore.EJavaObject>"
	 * @generated
	 */
	EMap<Class<?>, Object> getSolutionModelMap();

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Mirrors the standard {@link java.util.Map#containsKey} method.
	 * <!-- end-model-doc -->
	 * @model required="true"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel body='return solutionMap.containsKey(key);'"
	 * @generated
	 */
	boolean containsKey(ExplorationTarget<?> key);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Mirrors the standard {@link java.util.Map#containsValue} method.
	 * <!-- end-model-doc -->
	 * @model required="true"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel body='return solutionMap.containsValue(value);'"
	 * @generated
	 */
	boolean containsValue(ExplorationResult<?> value);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Mirrors the standard {@link java.util.Map#get} method, except that the Types of the key ({@link ExplorationTarget}) and the returned value ({@link ExplorationValue}) will match.
	 * <!-- end-model-doc -->
	 * @model required="true"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel body='return (ExplorationResult<T>)solutionMap.get(key);'"
	 * @generated
	 */
	<T> ExplorationResult<T> get(ExplorationTarget<T> key);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Mirrors the standard {@link java.util.Map#keySet} method.
	 * <!-- end-model-doc -->
	 * @model required="true" many="false"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel body='return new <%org.eclipse.emf.common.util.BasicEList%><ExplorationTarget<?>>(solutionMap.keySet());'"
	 * @generated
	 */
	EList<ExplorationTarget<?>> keySet();

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Mirrors the standard {@link java.util.Map#get} method, except that the Types of the key ({@link ExplorationTarget}) and the returned value ({@link ExplorationValue}) must match.
	 * <!-- end-model-doc -->
	 * @model required="true"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel body='return (ExplorationResult<T>)solutionMap.put(key, value);'"
	 * @generated
	 */
	<T> ExplorationResult<T> put(ExplorationTarget<T> key, ExplorationResult<T> value);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Mirrors the standard {@link java.util.Map#removeKey} method, except that the Types of the key ({@link ExplorationTarget}) and the returned value ({@link ExplorationValue}) will match.
	 * <!-- end-model-doc -->
	 * @model required="true"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel body='return (ExplorationResult<T>)solutionMap.get(key);'"
	 * @generated
	 */
	<T> ExplorationResult<T> removeKey(ExplorationTarget<T> key);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Mirrors the standard {@link java.util.Map#values} method, except that its returned value is an {@link EList} instead of a {@link Collection} due to EMF limitations.
	 * <!-- end-model-doc -->
	 * @model required="true" many="false"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel body='return new <%org.eclipse.emf.common.util.BasicEList%><ExplorationResult<?>>(solutionMap.values());'"
	 * @generated
	 */
	EList<ExplorationResult<?>> values();

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Allows to retrieve an attached solution model of this representation of a single solution.
	 * <!-- end-model-doc -->
	 * @model required="true" modelTypeRequired="true"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel body='return SingleExplorationSolutionMapStaticImpl.getModel(this, modelType);'"
	 * @generated
	 */
	<T> T getSolutionModel(Class<T> modelType);

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * <!-- begin-model-doc -->
	 * Allows to attach a solution model to this representation of a single solution.
	 * <!-- end-model-doc -->
	 * @model modelTypeRequired="true" solutionModelRequired="true"
	 *        annotation="http://www.eclipse.org/emf/2002/GenModel body='SingleExplorationSolutionMapStaticImpl.putSolutionModel(this, modelType, solutionModel);'"
	 * @generated
	 */
	<T> void putSolutionModel(Class<T> modelType, T solutionModel);

} // SingleExplorationSolutionMap
