/**
 */
package org.fortiss.af3.exploration.moea.model.solutions;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

import org.fortiss.af3.exploration.model.ExplorationPackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see org.fortiss.af3.exploration.moea.model.solutions.SolutionsFactory
 * @model kind="package"
 * @generated
 */
public interface SolutionsPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "solutions";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.fortiss.org/af3/exploration/moea/solutions";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "org-fortiss-af3-exploration-moea-solutions";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	SolutionsPackage eINSTANCE = org.fortiss.af3.exploration.moea.model.solutions.impl.SolutionsPackageImpl.init();

	/**
	 * The meta object id for the '{@link org.fortiss.af3.exploration.moea.model.solutions.impl.ExplorationResultImpl <em>Exploration Result</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.fortiss.af3.exploration.moea.model.solutions.impl.ExplorationResultImpl
	 * @see org.fortiss.af3.exploration.moea.model.solutions.impl.SolutionsPackageImpl#getExplorationResult()
	 * @generated
	 */
	int EXPLORATION_RESULT = 0;

	/**
	 * The feature id for the '<em><b>Result</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLORATION_RESULT__RESULT = 0;

	/**
	 * The number of structural features of the '<em>Exploration Result</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLORATION_RESULT_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link org.fortiss.af3.exploration.moea.model.solutions.impl.ExplorationSolutionSetImpl <em>Exploration Solution Set</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.fortiss.af3.exploration.moea.model.solutions.impl.ExplorationSolutionSetImpl
	 * @see org.fortiss.af3.exploration.moea.model.solutions.impl.SolutionsPackageImpl#getExplorationSolutionSet()
	 * @generated
	 */
	int EXPLORATION_SOLUTION_SET = 1;

	/**
	 * The feature id for the '<em><b>Input Model Adapter</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLORATION_SOLUTION_SET__INPUT_MODEL_ADAPTER = ExplorationPackage.EXPLORATION_SOLUTION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Target Specification</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLORATION_SOLUTION_SET__TARGET_SPECIFICATION = ExplorationPackage.EXPLORATION_SOLUTION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Solutions</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLORATION_SOLUTION_SET__SOLUTIONS = ExplorationPackage.EXPLORATION_SOLUTION_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Exploration Solution Set</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLORATION_SOLUTION_SET_FEATURE_COUNT = ExplorationPackage.EXPLORATION_SOLUTION_FEATURE_COUNT + 3;

	/**
	 * The meta object id for the '{@link org.fortiss.af3.exploration.moea.model.solutions.impl.SingleExplorationSolutionMapImpl <em>Single Exploration Solution Map</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.fortiss.af3.exploration.moea.model.solutions.impl.SingleExplorationSolutionMapImpl
	 * @see org.fortiss.af3.exploration.moea.model.solutions.impl.SolutionsPackageImpl#getSingleExplorationSolutionMap()
	 * @generated
	 */
	int SINGLE_EXPLORATION_SOLUTION_MAP = 2;

	/**
	 * The feature id for the '<em><b>Solution Map</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SINGLE_EXPLORATION_SOLUTION_MAP__SOLUTION_MAP = 0;

	/**
	 * The feature id for the '<em><b>Solution Model Map</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SINGLE_EXPLORATION_SOLUTION_MAP__SOLUTION_MODEL_MAP = 1;

	/**
	 * The number of structural features of the '<em>Single Exploration Solution Map</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SINGLE_EXPLORATION_SOLUTION_MAP_FEATURE_COUNT = 2;

	/**
	 * The meta object id for the '{@link org.fortiss.af3.exploration.moea.model.solutions.impl.ExplorationTargetToExplorationResultMapImpl <em>Exploration Target To Exploration Result Map</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.fortiss.af3.exploration.moea.model.solutions.impl.ExplorationTargetToExplorationResultMapImpl
	 * @see org.fortiss.af3.exploration.moea.model.solutions.impl.SolutionsPackageImpl#getExplorationTargetToExplorationResultMap()
	 * @generated
	 */
	int EXPLORATION_TARGET_TO_EXPLORATION_RESULT_MAP = 3;

	/**
	 * The feature id for the '<em><b>Key</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLORATION_TARGET_TO_EXPLORATION_RESULT_MAP__KEY = 0;

	/**
	 * The feature id for the '<em><b>Value</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLORATION_TARGET_TO_EXPLORATION_RESULT_MAP__VALUE = 1;

	/**
	 * The number of structural features of the '<em>Exploration Target To Exploration Result Map</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPLORATION_TARGET_TO_EXPLORATION_RESULT_MAP_FEATURE_COUNT = 2;

	/**
	 * The meta object id for the '{@link org.fortiss.af3.exploration.moea.model.solutions.impl.EJavaClassToEJavaObjectMapImpl <em>EJava Class To EJava Object Map</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.fortiss.af3.exploration.moea.model.solutions.impl.EJavaClassToEJavaObjectMapImpl
	 * @see org.fortiss.af3.exploration.moea.model.solutions.impl.SolutionsPackageImpl#getEJavaClassToEJavaObjectMap()
	 * @generated
	 */
	int EJAVA_CLASS_TO_EJAVA_OBJECT_MAP = 4;

	/**
	 * The feature id for the '<em><b>Key</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EJAVA_CLASS_TO_EJAVA_OBJECT_MAP__KEY = 0;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EJAVA_CLASS_TO_EJAVA_OBJECT_MAP__VALUE = 1;

	/**
	 * The number of structural features of the '<em>EJava Class To EJava Object Map</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EJAVA_CLASS_TO_EJAVA_OBJECT_MAP_FEATURE_COUNT = 2;


	/**
	 * Returns the meta object for class '{@link org.fortiss.af3.exploration.moea.model.solutions.ExplorationResult <em>Exploration Result</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Exploration Result</em>'.
	 * @see org.fortiss.af3.exploration.moea.model.solutions.ExplorationResult
	 * @generated
	 */
	EClass getExplorationResult();

	/**
	 * Returns the meta object for the attribute '{@link org.fortiss.af3.exploration.moea.model.solutions.ExplorationResult#getResult <em>Result</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Result</em>'.
	 * @see org.fortiss.af3.exploration.moea.model.solutions.ExplorationResult#getResult()
	 * @see #getExplorationResult()
	 * @generated
	 */
	EAttribute getExplorationResult_Result();

	/**
	 * Returns the meta object for class '{@link org.fortiss.af3.exploration.moea.model.solutions.ExplorationSolutionSet <em>Exploration Solution Set</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Exploration Solution Set</em>'.
	 * @see org.fortiss.af3.exploration.moea.model.solutions.ExplorationSolutionSet
	 * @generated
	 */
	EClass getExplorationSolutionSet();

	/**
	 * Returns the meta object for the attribute '{@link org.fortiss.af3.exploration.moea.model.solutions.ExplorationSolutionSet#getInputModelAdapter <em>Input Model Adapter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Input Model Adapter</em>'.
	 * @see org.fortiss.af3.exploration.moea.model.solutions.ExplorationSolutionSet#getInputModelAdapter()
	 * @see #getExplorationSolutionSet()
	 * @generated
	 */
	EAttribute getExplorationSolutionSet_InputModelAdapter();

	/**
	 * Returns the meta object for the reference '{@link org.fortiss.af3.exploration.moea.model.solutions.ExplorationSolutionSet#getTargetSpecification <em>Target Specification</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Target Specification</em>'.
	 * @see org.fortiss.af3.exploration.moea.model.solutions.ExplorationSolutionSet#getTargetSpecification()
	 * @see #getExplorationSolutionSet()
	 * @generated
	 */
	EReference getExplorationSolutionSet_TargetSpecification();

	/**
	 * Returns the meta object for the containment reference list '{@link org.fortiss.af3.exploration.moea.model.solutions.ExplorationSolutionSet#getSolutions <em>Solutions</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Solutions</em>'.
	 * @see org.fortiss.af3.exploration.moea.model.solutions.ExplorationSolutionSet#getSolutions()
	 * @see #getExplorationSolutionSet()
	 * @generated
	 */
	EReference getExplorationSolutionSet_Solutions();

	/**
	 * Returns the meta object for class '{@link org.fortiss.af3.exploration.moea.model.solutions.SingleExplorationSolutionMap <em>Single Exploration Solution Map</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Single Exploration Solution Map</em>'.
	 * @see org.fortiss.af3.exploration.moea.model.solutions.SingleExplorationSolutionMap
	 * @generated
	 */
	EClass getSingleExplorationSolutionMap();

	/**
	 * Returns the meta object for the map '{@link org.fortiss.af3.exploration.moea.model.solutions.SingleExplorationSolutionMap#getSolutionMap <em>Solution Map</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the map '<em>Solution Map</em>'.
	 * @see org.fortiss.af3.exploration.moea.model.solutions.SingleExplorationSolutionMap#getSolutionMap()
	 * @see #getSingleExplorationSolutionMap()
	 * @generated
	 */
	EReference getSingleExplorationSolutionMap_SolutionMap();

	/**
	 * Returns the meta object for the map '{@link org.fortiss.af3.exploration.moea.model.solutions.SingleExplorationSolutionMap#getSolutionModelMap <em>Solution Model Map</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the map '<em>Solution Model Map</em>'.
	 * @see org.fortiss.af3.exploration.moea.model.solutions.SingleExplorationSolutionMap#getSolutionModelMap()
	 * @see #getSingleExplorationSolutionMap()
	 * @generated
	 */
	EReference getSingleExplorationSolutionMap_SolutionModelMap();

	/**
	 * Returns the meta object for class '{@link java.util.Map.Entry <em>Exploration Target To Exploration Result Map</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Exploration Target To Exploration Result Map</em>'.
	 * @see java.util.Map.Entry
	 * @model keyType="org.fortiss.af3.exploration.model.ExplorationTarget<?>" keyRequired="true"
	 *        valueType="org.fortiss.af3.exploration.moea.model.solutions.ExplorationResult<?>" valueContainment="true" valueResolveProxies="true" valueRequired="true"
	 * @generated
	 */
	EClass getExplorationTargetToExplorationResultMap();

	/**
	 * Returns the meta object for the reference '{@link java.util.Map.Entry <em>Key</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Key</em>'.
	 * @see java.util.Map.Entry
	 * @see #getExplorationTargetToExplorationResultMap()
	 * @generated
	 */
	EReference getExplorationTargetToExplorationResultMap_Key();

	/**
	 * Returns the meta object for the containment reference '{@link java.util.Map.Entry <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Value</em>'.
	 * @see java.util.Map.Entry
	 * @see #getExplorationTargetToExplorationResultMap()
	 * @generated
	 */
	EReference getExplorationTargetToExplorationResultMap_Value();

	/**
	 * Returns the meta object for class '{@link java.util.Map.Entry <em>EJava Class To EJava Object Map</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>EJava Class To EJava Object Map</em>'.
	 * @see java.util.Map.Entry
	 * @model keyDataType="org.eclipse.emf.ecore.EJavaClass<?>" keyRequired="true"
	 *        valueDataType="org.eclipse.emf.ecore.EJavaObject" valueRequired="true"
	 * @generated
	 */
	EClass getEJavaClassToEJavaObjectMap();

	/**
	 * Returns the meta object for the attribute '{@link java.util.Map.Entry <em>Key</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Key</em>'.
	 * @see java.util.Map.Entry
	 * @see #getEJavaClassToEJavaObjectMap()
	 * @generated
	 */
	EAttribute getEJavaClassToEJavaObjectMap_Key();

	/**
	 * Returns the meta object for the attribute '{@link java.util.Map.Entry <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see java.util.Map.Entry
	 * @see #getEJavaClassToEJavaObjectMap()
	 * @generated
	 */
	EAttribute getEJavaClassToEJavaObjectMap_Value();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	SolutionsFactory getSolutionsFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link org.fortiss.af3.exploration.moea.model.solutions.impl.ExplorationResultImpl <em>Exploration Result</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.fortiss.af3.exploration.moea.model.solutions.impl.ExplorationResultImpl
		 * @see org.fortiss.af3.exploration.moea.model.solutions.impl.SolutionsPackageImpl#getExplorationResult()
		 * @generated
		 */
		EClass EXPLORATION_RESULT = eINSTANCE.getExplorationResult();

		/**
		 * The meta object literal for the '<em><b>Result</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EXPLORATION_RESULT__RESULT = eINSTANCE.getExplorationResult_Result();

		/**
		 * The meta object literal for the '{@link org.fortiss.af3.exploration.moea.model.solutions.impl.ExplorationSolutionSetImpl <em>Exploration Solution Set</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.fortiss.af3.exploration.moea.model.solutions.impl.ExplorationSolutionSetImpl
		 * @see org.fortiss.af3.exploration.moea.model.solutions.impl.SolutionsPackageImpl#getExplorationSolutionSet()
		 * @generated
		 */
		EClass EXPLORATION_SOLUTION_SET = eINSTANCE.getExplorationSolutionSet();

		/**
		 * The meta object literal for the '<em><b>Input Model Adapter</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EXPLORATION_SOLUTION_SET__INPUT_MODEL_ADAPTER = eINSTANCE.getExplorationSolutionSet_InputModelAdapter();

		/**
		 * The meta object literal for the '<em><b>Target Specification</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference EXPLORATION_SOLUTION_SET__TARGET_SPECIFICATION = eINSTANCE.getExplorationSolutionSet_TargetSpecification();

		/**
		 * The meta object literal for the '<em><b>Solutions</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference EXPLORATION_SOLUTION_SET__SOLUTIONS = eINSTANCE.getExplorationSolutionSet_Solutions();

		/**
		 * The meta object literal for the '{@link org.fortiss.af3.exploration.moea.model.solutions.impl.SingleExplorationSolutionMapImpl <em>Single Exploration Solution Map</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.fortiss.af3.exploration.moea.model.solutions.impl.SingleExplorationSolutionMapImpl
		 * @see org.fortiss.af3.exploration.moea.model.solutions.impl.SolutionsPackageImpl#getSingleExplorationSolutionMap()
		 * @generated
		 */
		EClass SINGLE_EXPLORATION_SOLUTION_MAP = eINSTANCE.getSingleExplorationSolutionMap();

		/**
		 * The meta object literal for the '<em><b>Solution Map</b></em>' map feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SINGLE_EXPLORATION_SOLUTION_MAP__SOLUTION_MAP = eINSTANCE.getSingleExplorationSolutionMap_SolutionMap();

		/**
		 * The meta object literal for the '<em><b>Solution Model Map</b></em>' map feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SINGLE_EXPLORATION_SOLUTION_MAP__SOLUTION_MODEL_MAP = eINSTANCE.getSingleExplorationSolutionMap_SolutionModelMap();

		/**
		 * The meta object literal for the '{@link org.fortiss.af3.exploration.moea.model.solutions.impl.ExplorationTargetToExplorationResultMapImpl <em>Exploration Target To Exploration Result Map</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.fortiss.af3.exploration.moea.model.solutions.impl.ExplorationTargetToExplorationResultMapImpl
		 * @see org.fortiss.af3.exploration.moea.model.solutions.impl.SolutionsPackageImpl#getExplorationTargetToExplorationResultMap()
		 * @generated
		 */
		EClass EXPLORATION_TARGET_TO_EXPLORATION_RESULT_MAP = eINSTANCE.getExplorationTargetToExplorationResultMap();

		/**
		 * The meta object literal for the '<em><b>Key</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference EXPLORATION_TARGET_TO_EXPLORATION_RESULT_MAP__KEY = eINSTANCE.getExplorationTargetToExplorationResultMap_Key();

		/**
		 * The meta object literal for the '<em><b>Value</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference EXPLORATION_TARGET_TO_EXPLORATION_RESULT_MAP__VALUE = eINSTANCE.getExplorationTargetToExplorationResultMap_Value();

		/**
		 * The meta object literal for the '{@link org.fortiss.af3.exploration.moea.model.solutions.impl.EJavaClassToEJavaObjectMapImpl <em>EJava Class To EJava Object Map</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see org.fortiss.af3.exploration.moea.model.solutions.impl.EJavaClassToEJavaObjectMapImpl
		 * @see org.fortiss.af3.exploration.moea.model.solutions.impl.SolutionsPackageImpl#getEJavaClassToEJavaObjectMap()
		 * @generated
		 */
		EClass EJAVA_CLASS_TO_EJAVA_OBJECT_MAP = eINSTANCE.getEJavaClassToEJavaObjectMap();

		/**
		 * The meta object literal for the '<em><b>Key</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EJAVA_CLASS_TO_EJAVA_OBJECT_MAP__KEY = eINSTANCE.getEJavaClassToEJavaObjectMap_Key();

		/**
		 * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EJAVA_CLASS_TO_EJAVA_OBJECT_MAP__VALUE = eINSTANCE.getEJavaClassToEJavaObjectMap_Value();

	}

} //SolutionsPackage
