/**
 */
package org.fortiss.af3.exploration.moea.model.solutions.util;

import java.util.Map;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;

import org.fortiss.af3.exploration.model.ExplorationSolution;
import org.fortiss.af3.exploration.model.ExplorationTarget;

import org.fortiss.af3.exploration.moea.model.solutions.*;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see org.fortiss.af3.exploration.moea.model.solutions.SolutionsPackage
 * @generated
 */
public class SolutionsAdapterFactory extends AdapterFactoryImpl {
	/**
	 * The cached model package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static SolutionsPackage modelPackage;

	/**
	 * Creates an instance of the adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SolutionsAdapterFactory() {
		if (modelPackage == null) {
			modelPackage = SolutionsPackage.eINSTANCE;
		}
	}

	/**
	 * Returns whether this factory is applicable for the type of the object.
	 * <!-- begin-user-doc -->
	 * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
	 * <!-- end-user-doc -->
	 * @return whether this factory is applicable for the type of the object.
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object object) {
		if (object == modelPackage) {
			return true;
		}
		if (object instanceof EObject) {
			return ((EObject)object).eClass().getEPackage() == modelPackage;
		}
		return false;
	}

	/**
	 * The switch that delegates to the <code>createXXX</code> methods.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SolutionsSwitch<Adapter> modelSwitch =
		new SolutionsSwitch<Adapter>() {
			@Override
			public <T> Adapter caseExplorationResult(ExplorationResult<T> object) {
				return createExplorationResultAdapter();
			}
			@Override
			public Adapter caseExplorationSolutionSet(ExplorationSolutionSet object) {
				return createExplorationSolutionSetAdapter();
			}
			@Override
			public Adapter caseSingleExplorationSolutionMap(SingleExplorationSolutionMap object) {
				return createSingleExplorationSolutionMapAdapter();
			}
			@Override
			public Adapter caseExplorationTargetToExplorationResultMap(Map.Entry<ExplorationTarget<?>, ExplorationResult<?>> object) {
				return createExplorationTargetToExplorationResultMapAdapter();
			}
			@Override
			public Adapter caseEJavaClassToEJavaObjectMap(Map.Entry<Class<?>, Object> object) {
				return createEJavaClassToEJavaObjectMapAdapter();
			}
			@Override
			public Adapter caseExplorationSolution(ExplorationSolution object) {
				return createExplorationSolutionAdapter();
			}
			@Override
			public Adapter defaultCase(EObject object) {
				return createEObjectAdapter();
			}
		};

	/**
	 * Creates an adapter for the <code>target</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param target the object to adapt.
	 * @return the adapter for the <code>target</code>.
	 * @generated
	 */
	@Override
	public Adapter createAdapter(Notifier target) {
		return modelSwitch.doSwitch((EObject)target);
	}


	/**
	 * Creates a new adapter for an object of class '{@link org.fortiss.af3.exploration.moea.model.solutions.ExplorationResult <em>Exploration Result</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.fortiss.af3.exploration.moea.model.solutions.ExplorationResult
	 * @generated
	 */
	public Adapter createExplorationResultAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.fortiss.af3.exploration.moea.model.solutions.ExplorationSolutionSet <em>Exploration Solution Set</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.fortiss.af3.exploration.moea.model.solutions.ExplorationSolutionSet
	 * @generated
	 */
	public Adapter createExplorationSolutionSetAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.fortiss.af3.exploration.moea.model.solutions.SingleExplorationSolutionMap <em>Single Exploration Solution Map</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.fortiss.af3.exploration.moea.model.solutions.SingleExplorationSolutionMap
	 * @generated
	 */
	public Adapter createSingleExplorationSolutionMapAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link java.util.Map.Entry <em>Exploration Target To Exploration Result Map</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see java.util.Map.Entry
	 * @generated
	 */
	public Adapter createExplorationTargetToExplorationResultMapAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link java.util.Map.Entry <em>EJava Class To EJava Object Map</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see java.util.Map.Entry
	 * @generated
	 */
	public Adapter createEJavaClassToEJavaObjectMapAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.fortiss.af3.exploration.model.ExplorationSolution <em>Solution</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.fortiss.af3.exploration.model.ExplorationSolution
	 * @generated
	 */
	public Adapter createExplorationSolutionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for the default case.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @generated
	 */
	public Adapter createEObjectAdapter() {
		return null;
	}

} //SolutionsAdapterFactory
