/**
 */
package org.fortiss.af3.exploration.moea.model.solutions.util;

import java.util.Map;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.util.Switch;

import org.fortiss.af3.exploration.model.ExplorationSolution;
import org.fortiss.af3.exploration.model.ExplorationTarget;

import org.fortiss.af3.exploration.moea.model.solutions.*;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see org.fortiss.af3.exploration.moea.model.solutions.SolutionsPackage
 * @generated
 */
public class SolutionsSwitch<T1> extends Switch<T1> {
	/**
	 * The cached model package
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static SolutionsPackage modelPackage;

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SolutionsSwitch() {
		if (modelPackage == null) {
			modelPackage = SolutionsPackage.eINSTANCE;
		}
	}

	/**
	 * Checks whether this is a switch for the given package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @parameter ePackage the package in question.
	 * @return whether this is a switch for the given package.
	 * @generated
	 */
	@Override
	protected boolean isSwitchFor(EPackage ePackage) {
		return ePackage == modelPackage;
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	@Override
	protected T1 doSwitch(int classifierID, EObject theEObject) {
		switch (classifierID) {
			case SolutionsPackage.EXPLORATION_RESULT: {
				ExplorationResult<?> explorationResult = (ExplorationResult<?>)theEObject;
				T1 result = caseExplorationResult(explorationResult);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SolutionsPackage.EXPLORATION_SOLUTION_SET: {
				ExplorationSolutionSet explorationSolutionSet = (ExplorationSolutionSet)theEObject;
				T1 result = caseExplorationSolutionSet(explorationSolutionSet);
				if (result == null) result = caseExplorationSolution(explorationSolutionSet);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SolutionsPackage.SINGLE_EXPLORATION_SOLUTION_MAP: {
				SingleExplorationSolutionMap singleExplorationSolutionMap = (SingleExplorationSolutionMap)theEObject;
				T1 result = caseSingleExplorationSolutionMap(singleExplorationSolutionMap);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SolutionsPackage.EXPLORATION_TARGET_TO_EXPLORATION_RESULT_MAP: {
				@SuppressWarnings("unchecked") Map.Entry<ExplorationTarget<?>, ExplorationResult<?>> explorationTargetToExplorationResultMap = (Map.Entry<ExplorationTarget<?>, ExplorationResult<?>>)theEObject;
				T1 result = caseExplorationTargetToExplorationResultMap(explorationTargetToExplorationResultMap);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case SolutionsPackage.EJAVA_CLASS_TO_EJAVA_OBJECT_MAP: {
				@SuppressWarnings("unchecked") Map.Entry<Class<?>, Object> eJavaClassToEJavaObjectMap = (Map.Entry<Class<?>, Object>)theEObject;
				T1 result = caseEJavaClassToEJavaObjectMap(eJavaClassToEJavaObjectMap);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			default: return defaultCase(theEObject);
		}
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Exploration Result</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Exploration Result</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public <T> T1 caseExplorationResult(ExplorationResult<T> object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Exploration Solution Set</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Exploration Solution Set</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T1 caseExplorationSolutionSet(ExplorationSolutionSet object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Single Exploration Solution Map</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Single Exploration Solution Map</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T1 caseSingleExplorationSolutionMap(SingleExplorationSolutionMap object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Exploration Target To Exploration Result Map</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Exploration Target To Exploration Result Map</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T1 caseExplorationTargetToExplorationResultMap(Map.Entry<ExplorationTarget<?>, ExplorationResult<?>> object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>EJava Class To EJava Object Map</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>EJava Class To EJava Object Map</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T1 caseEJavaClassToEJavaObjectMap(Map.Entry<Class<?>, Object> object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Solution</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Solution</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T1 caseExplorationSolution(ExplorationSolution object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch, but this is the last case anyway.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject)
	 * @generated
	 */
	@Override
	public T1 defaultCase(EObject object) {
		return null;
	}

} //SolutionsSwitch
