/*--------------------------------------------------------------------------+
$Id: IExplorerBackend.java 3032 2016-06-16 18:13:12Z diewald $
|                                                                          |
| Copyright 2014 ForTISS GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.dse.backend;

import org.fortiss.af3.exploration.alg.dse.CompositeExplorationSolution;
import org.fortiss.af3.exploration.moea.model.parameters.IOptimizer;

/**
 * Common interface for all optimization backends.
 * 
 * @author barner
 * @author $Author: diewald $
 * @version $Rev: 3032 $
 * @ConQAT.Rating RED Hash: C8E9A58BBE654EF0ECB4D5C9A5D2C572
 */
public interface IExplorerBackend<O extends IOptimizer> {
	/**
	 * Execute optimization
	 * 
	 * @throws Exception
	 */
	// TODO: add distinct exceptions if stroing the solution fails.
	public abstract CompositeExplorationSolution<?> explore() throws Exception;
}
