/*--------------------------------------------------------------------------+
$Id: ComposableDecoderBase.java 3451 2016-09-02 13:36:29Z diewald $
|                                                                          |
| Copyright 2016 ForTISS GmbH                     |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.dse.backend.opt4j.extensions.compositegene.decode;

import org.fortiss.af3.exploration.alg.dse.backend.opt4j.extensions.compositegene.genotype.ComposableGenotype;
import org.fortiss.af3.exploration.alg.dse.backend.opt4j.extensions.compositegene.phenotype.ComposablePhenotype;

/**
 * Base class for {@link ComposableDecoder}s.
 * 
 * @author diewald
 * @author $Author: diewald $
 * @version $Rev: 3451 $
 * @ConQAT.Rating RED Hash: B0008945820EBAD3338FE8337FAC6C4F
 */
public abstract class ComposableDecoderBase<G extends ComposableGenotype, P extends ComposablePhenotype<?>>
		implements ComposableDecoder<G, P> {

	// TODO: implement the following method here: The class hierarchy must be traversed. Then, also
	// the interface (ComposableDecoder) can be specialized to Class<P>.
	// public Class<P> getDecodedPhenotypeType() {
	// TypeVariable<?>[] genericTypes = ExplorationUtils.get;
	// assert (genericTypes.length == 2);
	// return (Class<P>)genericTypes[1].getClass();
	// }
}
