/*--------------------------------------------------------------------------+
$Id: DependencyException.java 3480 2016-09-09 13:31:04Z diewald $
|                                                                          |
| Copyright 2016 ForTISS GmbH                     |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.dse.backend.opt4j.extensions.compositegene.exception;

import org.fortiss.af3.exploration.alg.exception.ExplorationException;

/**
 * Exception to be thrown whenever a some dependency in the DSE cannot be satisfied, e.g., if some
 * required input encoding is missing.
 * 
 * @author diewald
 * @author $Author: diewald $
 * @version $Rev: 3480 $
 * @ConQAT.Rating YELLOW Hash: 981897709D5BE431526581521AD916AA
 */
public class DependencyException extends ExplorationException {

	/** Constructor. */
	public DependencyException(String msg) {
		super(msg);
	}

	/** Constructor that stacks the given Exception. */
	public DependencyException(String msg, Exception e) {
		super(msg, e);
	}
}
