/*--------------------------------------------------------------------------+
$Id: DecoderEdge.java 3451 2016-09-02 13:36:29Z diewald $
|                                                                          |
| Copyright 2016 ForTISS GmbH                     |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.dse.backend.opt4j.extensions.compositegene.graph;

import org.fortiss.af3.exploration.alg.dse.backend.opt4j.extensions.compositegene.decode.ComposableDecoder;
import org.fortiss.af3.exploration.alg.dse.backend.opt4j.extensions.compositegene.genotype.ComposableGenotype;
import org.fortiss.af3.exploration.alg.dse.backend.opt4j.extensions.compositegene.phenotype.ComposablePhenotype;
import org.fortiss.af3.exploration.alg.graph.DependencyEdge;

/**
 * Wrapper for the edges in the {@link DecoderDependencyGraph} --> {@link ComposableDecoder}s.
 * 
 * @author diewald
 * @author $Author: diewald $
 * @version $Rev: 3451 $
 * @ConQAT.Rating YELLOW Hash: 67D82E36A9575DE3FD120CB2B0291FAE
 */
public class DecoderEdge<G extends ComposableGenotype, P extends ComposablePhenotype<?>> extends
		DependencyEdge<ComposableDecoder<G, P>> {
	// All required implementation is to found in the parent class.
}
