/*--------------------------------------------------------------------------+
$Id: ComposablePhenotype.java 3797 2016-10-28 11:14:06Z diewald $
|                                                                          |
| Copyright 2015 ForTISS GmbH                     |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.dse.backend.opt4j.extensions.compositegene.phenotype;

import org.fortiss.af3.exploration.alg.dse.backend.opt4j.extensions.compositegene.genotype.ComposableGenotype;
import org.opt4j.core.Genotype;

/**
 * Interface for {@link Phenotype}s that compose a {@link CompositePhenotype}. Counterpart to
 * {@link ComposableGenotype}.
 * 
 * @author diewald
 * @author $Author: diewald $
 * @version $Rev: 3797 $
 * @ConQAT.Rating YELLOW Hash: 81AD202996AB9B1B88CC11FC3B7DD0BC
 */
public interface ComposablePhenotype<G extends Genotype> extends Phenotype {

	/**
	 * Returns the type which shall be used to register the {@link ComposablePhenotype} at its
	 * containing {@link CompositePhenotype}.
	 */
	Class<? extends ComposablePhenotype<?>> getPTypeToRegister();
}
