/*--------------------------------------------------------------------------+
$Id: CopySafetyFunctionArchModule.java 2686 2016-05-04 16:23:35Z diewald $
|                                                                          |
| Copyright 2014 ForTISS GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.dse.backend.opt4j.operator.copy.safetyfunctionarch;

import org.fortiss.af3.exploration.alg.dse.backend.opt4j.encoding.safetyfunctionarch.SafetyFunctionArchEncoding;
import org.opt4j.operators.copy.CopyModule;

/**
 * Opt4J module for the general copy operator of {@link SafetyFunctionArchEncoding}s.
 * 
 * @author diewald
 * @author $Author: diewald $
 * @version $Rev: 2686 $
 * @ConQAT.Rating YELLOW Hash: 0C4D1912C9F9FF041788CE5AB36D79E5
 */
public class CopySafetyFunctionArchModule extends CopyModule {

	/** {@inheritDoc} */
	@Override
	protected void config() {
		addOperator(CopySafetyFunctionArch.class);
	}
}
