/*--------------------------------------------------------------------------+
$Id: CopyInstanceTaskMapping.java 2686 2016-05-04 16:23:35Z diewald $
|                                                                          |
| Copyright 2014 ForTISS GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.dse.backend.opt4j.operator.copy.taskmapping;

import org.fortiss.af3.exploration.alg.dse.backend.opt4j.encoding.taskmapping.TaskMappingEncoding;
import org.fortiss.af3.exploration.alg.dse.backend.opt4j.encoding.taskmapping.instantiatedmapping.InstantiatedTaskMappingEncoding;
import org.opt4j.operators.copy.Copy;

/**
 * Operator that creates copies of a {@link TaskMappingEncoding}s.
 * 
 * @author huang
 * @author $Author: diewald $
 * @version $Rev: 2686 $
 * @ConQAT.Rating YELLOW Hash: F2E82A32BDB0402FB5CCCF026B9C2E57
 */
public class CopyInstanceTaskMapping implements Copy<InstantiatedTaskMappingEncoding<?>> {
	/** {@inheritDoc} */
	@Override
	public InstantiatedTaskMappingEncoding<?> copy(InstantiatedTaskMappingEncoding<?> other) {
		return (InstantiatedTaskMappingEncoding<?>)other.clone();
	}
}
