/*--------------------------------------------------------------------------+
$Id: CopyTaskMappingModule.java 2686 2016-05-04 16:23:35Z diewald $
|                                                                          |
| Copyright 2014 ForTISS GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.dse.backend.opt4j.operator.copy.taskmapping;

import org.fortiss.af3.exploration.alg.dse.backend.opt4j.encoding.taskmapping.TaskMappingEncoding;
import org.opt4j.operators.copy.CopyModule;

/**
 * Opt4J module for the general copy operator of {@link TaskMappingEncoding}s.
 * 
 * @author huang
 * @author $Author: diewald $
 * @version $Rev: 2686 $
 * @ConQAT.Rating YELLOW Hash: 94D0820C8064C2B31F31A35C620CA7D2
 */
public class CopyTaskMappingModule extends CopyModule {
	/** {@inheritDoc} */
	@Override
	protected void config() {
		addOperator(CopyAbstractTaskMapping.class);
		addOperator(CopyInstanceTaskMapping.class);
	}
}
