/*--------------------------------------------------------------------------+
$Id: NopCrossoverSFArchModule.java 3032 2016-06-16 18:13:12Z diewald $
|                                                                          |
| Copyright 2015 ForTISS GmbH                     |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.dse.backend.opt4j.operator.crossover;

import org.fortiss.af3.exploration.alg.dse.backend.opt4j.encoding.safetyfunctionarch.SafetyFunctionArchEncoding;

/**
 * Crossover module selecting the {@link NopCrossover} operator to be applied on
 * {@link SafetyFunctionArchEncoding}s, i.e. no crossover operation will be applied.
 * 
 * @author diewald
 * @author $Author: diewald $
 * @version $Rev: 3032 $
 * @ConQAT.Rating YELLOW Hash: CBE83E121865A892DB07C3EE7906ECE5
 */
public class NopCrossoverSFArchModule extends CrossoverOperatorModuleBase {

	/** {@inheritDoc} */
	@Override
	public void config() {
		super.config();

		addOperatorInstance(SafetyFunctionArchEncoding.class, new NopCrossover());
	}
}
