/*--------------------------------------------------------------------------+
$Id: CrossoverAllocationFaultDetectionVoting.java 3032 2016-06-16 18:13:12Z diewald $
|                                                                          |
| Copyright 2014 ForTISS GmbH                     |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.dse.backend.opt4j.operator.crossover.faultDetectionVoting;

import org.fortiss.af3.exploration.alg.dse.backend.opt4j.encoding.taskmapping.instantiatedmapping.FaultDetectionVotingTaskMappingEncoding;
import org.fortiss.af3.exploration.alg.dse.backend.opt4j.encoding.taskmapping.instantiatedmapping.FaultDetectionVotingTaskMappingEntry;
import org.fortiss.af3.exploration.alg.dse.backend.opt4j.operator.crossover.CrossoverRandManyAllocation;
import org.fortiss.af3.exploration.alg.dse.sysmodel.arch.SystemModelAdapter;

/**
 * Performs the {@link CrossoverRandManyAllocation} operation on
 * {@link FaultDetectionVotingTaskMappingEncoding}s.
 * 
 * @author diewald
 * @author $Author: diewald $
 * @version $Rev: 3032 $
 * @ConQAT.Rating YELLOW Hash: AE8536162EA6AA41F4E14C588914FA75
 */
public class CrossoverAllocationFaultDetectionVoting
		extends
		CrossoverRandManyAllocation<FaultDetectionVotingTaskMappingEntry, FaultDetectionVotingTaskMappingEncoding> {
	/** Constructs a resource allocation crossover operator for fail-silent execution model */
	public CrossoverAllocationFaultDetectionVoting(
			SystemModelAdapter<?, ?, ?, ?, ?, ?> systemModelAdapter, double rate) {
		super(systemModelAdapter, rate);
	}
}
