/*--------------------------------------------------------------------------+
$Id: IGatewayUnitAdapter.java 3038 2016-06-17 13:26:28Z diewald $
|                                                                          |
| Copyright 2014 ForTISS GmbH                     |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.dse.sysmodel.arch;

/**
 * Adapter between the gateway units ({@link IResourceAdapter}s managing the connection between
 * busses) of the system meta-model used in the modeling tool, and the DSE.
 * 
 * @author diewald
 * @author $Author: diewald $
 * @version $Rev: 3038 $
 * @ConQAT.Rating YELLOW Hash: 1AA320145DB47A1C59BA9118030BFF68
 */
public interface IGatewayUnitAdapter<T> extends ICommunicationResourceAdapter<T> {

	/** Returns the worst-case time required to process a single message forwarding request. */
	public double getWCFT();

}
