/*--------------------------------------------------------------------------+
$Id: IModelElementAdapter.java 3038 2016-06-17 13:26:28Z diewald $
|                                                                          |
| Copyright 2014 ForTISS GmbH                     |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.dse.sysmodel.arch;


/**
 * Base interface for adapters between system model elements, and the DSE.
 * 
 * @author barner
 * @author $Author: diewald $
 * @version $Rev: 3038 $
 * @ConQAT.Rating YELLOW Hash: 6BA22C3DA933AE50D529559B901C02E3
 */
public interface IModelElementAdapter<T> {

	/** Returns the model element's name. */
	public String getName();

	/**
	 * Returns a reference to the model element wrapped by this {@link IModelElementAdapter}.
	 * Use with care!
	 */
	public T getObject();
}
