/*--------------------------------------------------------------------------+
$Id: IMappingEntry.java 3560 2016-09-23 14:13:46Z diewald $
|                                                                          |
| Copyright 2014 ForTISS GmbH                     |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.dse.sysmodel.mapping;

import org.fortiss.af3.exploration.alg.dse.sysmodel.arch.IDeployableComponentAdapter;
import org.fortiss.af3.exploration.alg.dse.sysmodel.arch.IExecutionUnitAdapter;
import org.fortiss.af3.exploration.alg.guava.IAssociativeElement;

/**
 * External interface that provides the entries of an {@link IMappingEncoding}.
 * 
 * @author diewald
 * @author $Author: diewald $
 * @version $Rev: 3560 $
 * @ConQAT.Rating YELLOW Hash: 4AF6E3B6A7E704A3A728131D76C903F8
 */
public interface IMappingEntry extends IAssociativeElement<IMappingEntry> {

	/** Return target resource to which the request is mapped. */
	IExecutionUnitAdapter<?> getTarget();

	/**
	 * Returns the {@link IDeployableComponentAdapter} that is represented by this
	 * {@link IMappingEntry}.
	 */
	IDeployableComponentAdapter<?> getDeployableComponent();
}
