/*--------------------------------------------------------------------------+
$Id: InvalidTimingModelException.java 3480 2016-09-09 13:31:04Z diewald $
|                                                                          |
| Copyright 2016 ForTISS GmbH                     |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.exception;

/**
 * {@link InvalidTimingModelException} for invalid timing specification/models.
 * 
 * @author diewald
 * @author $Author: diewald $
 * @version $Rev: 3480 $
 * @ConQAT.Rating YELLOW Hash: B1E181EC9F434BB8642191B0BB7FA91D
 */
public class InvalidTimingModelException extends ExplorationException {

	/** Constructor. */
	public InvalidTimingModelException(String msg) {
		super("Found an invalid timing specification: " + msg);
	}

	/** Constructor attaching the input {@link Exception}. */
	public InvalidTimingModelException(String msg, Exception e) {
		super("Found an invalid timing specification: " + msg, e);
	}
}
