/*--------------------------------------------------------------------------+
$Id: NamedVertex.java 3449 2016-09-02 11:06:00Z diewald $
|                                                                          |
| Copyright 2014 ForTISS GmbH                     |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.graph.display;

import java.io.Serializable;

import org.fortiss.af3.exploration.alg.dse.sysmodel.arch.IModelElementAdapter;
import org.fortiss.tooling.kernel.model.INamedElement;

/**
 * Wrapper class for displaying arbitrary Vertices inheriting from {@link IModelElementAdapter} of a
 * graph (-> JGraphT). It is used to display the name of the elements.
 * 
 * @author diewald
 * @author $Author: diewald $
 * @version $Rev: 3449 $
 * @ConQAT.Rating YELLOW Hash: 4076D1873F0ED1DF903FBA1E64512BB1
 */
public class NamedVertex<V extends IModelElementAdapter<?>> implements Serializable {

	/** The element associated with this vertex wrapper. */
	private INamedElement namedElement;

	/** Constructor. */
	NamedVertex(V currentVertex) {
		namedElement = (INamedElement)currentVertex.getObject();
	}

	/** {@inheritDoc} */
	@Override
	public String toString() {
		return namedElement.getName() + "(ID: " + namedElement.getId() + ")";
	}
}
