/*--------------------------------------------------------------------------+
$Id: codetemplates.xml 1 2011-01-01 00:00:01Z hoelzl $
|                                                                          |
| Copyright 2016 ForTISS GmbH                     |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.guava;

import com.google.common.collect.ClassToInstanceMap;


/**
 * Same as the interface {@link ClassToInstanceMap} with the major difference that instance are not
 * bound to specific types. Maps implementing this interface will also return a sub-type instance of
 * a given type, namely the one which is the closest match in the type hierarchy.
 * 
 * @author diewald
 * @author $Author: hoelzl $
 * @version $Rev: 18709 $
 * @ConQAT.Rating RED Hash: 23C11759241AD2F32712A6AAAC18B0FB
 */
public interface SubClassToInstanceMap<B> extends ClassToInstanceMap<B> {
	// Marker interface.
}
