/*--------------------------------------------------------------------------+
$Id: IExplorationService.java 3404 2016-08-26 15:01:08Z diewald $
|                                                                          |
| Copyright 2016 ForTISS GmbH                     |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.service;

import org.fortiss.tooling.kernel.introspection.IIntrospectiveKernelService;

/**
 * Interface for services provided by the org.fortiss.af3.exploration.alg plugin.
 * 
 * Each service must implement the given startup routines.
 * 
 * @author diewald
 * @author $Author: diewald $
 * @version $Rev: 3404 $
 * @ConQAT.Rating YELLOW Hash: 88FAE0B8442DD8CC25F04F113E0EFD90
 */
public interface IExplorationService<T extends IExplorationModule> extends
		IIntrospectiveKernelService {

	/**
	 * Initialization routine of {@link IExplorationService}s which is the first method to be
	 * launched within services.
	 */
	void initializeService();

	/**
	 * Startup routine of {@link IExplorationEncoding}s which is triggered after <i>all</i> services
	 * have been initialized.
	 */
	void startService();
}
