/*--------------------------------------------------------------------------+
$Id: ElementPropertyStaticImpl.java 3175 2016-07-04 15:25:48Z diewald $
|                                                                          |
| Copyright 2016 ForTISS GmbH                     |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.dsl.model.patterns.impl;

import java.util.function.Function;

import org.fortiss.af3.exploration.dsl.model.patterns.ElementProperty;
import org.fortiss.tooling.base.model.element.IModelElement;

/**
 * Static method implementations for {@link ElementProperty}s.
 * 
 * @author diewald
 * @author $Author: diewald $
 * @version $Rev: 3175 $
 * @ConQAT.Rating RED Hash: 0E2EE4AA6648B6959AED97C78CB6F03A
 */
public class ElementPropertyStaticImpl {

	/** Static implementation of the method {@link ElementProperty#getProperty()} using lambdas. */
	public static <T, ME extends IModelElement> T getProperty(ElementProperty<ME, T> pattern) {
		// FIXME: in the model, there should be a type definition for the java type "Function" to be
		// type-safer.
		Function<ME, T> propRetrievalFunc = pattern.getPropertyGetter();
		if(propRetrievalFunc != null) {
			ME modelElement = pattern.getModelElement();
			if(modelElement != null) {
				return propRetrievalFunc.apply(modelElement);
			}
		}
		return null;
	}
}
