/*--------------------------------------------------------------------------+
$Id: SafetyIntegrityLevelConstraintStaticImpl.java 3175 2016-07-04 15:25:48Z diewald $
|                                                                          |
| Copyright 2016 ForTISS GmbH                     |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.moea.model.predefined.impl;

import org.eclipse.emf.common.util.BasicEList;
import org.eclipse.emf.common.util.EList;
import org.fortiss.af3.component.model.Component;
import org.fortiss.af3.exploration.moea.model.predefined.SafetyIntegrityLevelConstraint;
import org.fortiss.af3.safety.model.SIL;
import org.fortiss.af3.safety.model.annotation.SafetyIntegrityLevel;

/**
 * Static method implementations for {@link SafetyIntegrityLevelConstraint}s.
 * 
 * @author alex
 * @author $Author: diewald $
 * @version $Rev: 3175 $
 * @ConQAT.Rating RED Hash:
 */
public class SafetyIntegrityLevelConstraintStaticImpl {

	/** Static implementation of the method {@link SafetyIntegrityLevelConstraint#getLimitation}. */
	public static EList<SIL> getLimitation(SafetyIntegrityLevelConstraintImpl constr) {
		EList<SIL> comSILs = new BasicEList<>();
		for(Component comp : constr.getComponents()) {
			// TODO: NPE
			SafetyIntegrityLevel sil =
					(SafetyIntegrityLevel)comp.getSpecifications().stream()
							.filter(s -> s instanceof SafetyIntegrityLevel).findAny().get();
			comSILs.add(sil.getSilValue());
		}
		return comSILs;
	}
}
