/*--------------------------------------------------------------------------+
$Id: SingleExplorationSolutionMapStaticImpl.java 3175 2016-07-04 15:25:48Z diewald $
|                                                                          |
| Copyright 2016 ForTISS GmbH                     |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.moea.model.solutions.impl;

import java.util.Map.Entry;

import org.fortiss.af3.exploration.moea.model.solutions.SingleExplorationSolutionMap;

/**
 * Static method implementations for {@link SingleExplorationSolutionMap}s.
 * 
 * @author diewald
 * @author $Author: diewald $
 * @version $Rev: 3175 $
 * @ConQAT.Rating RED Hash:
 */
public class SingleExplorationSolutionMapStaticImpl {

	/**
	 * Static implementation of the method
	 * {@link SingleExplorationSolutionMap#getSolutionModel(Class)}.
	 */
	@SuppressWarnings("unchecked")
	public static <T> T getModel(SingleExplorationSolutionMap singleExpSol, Class<T> modelType) {
		T solutionModel = (T)singleExpSol.getSolutionModelMap().get(modelType);

		if(solutionModel == null) {
			for(Entry<Class<?>, Object> entry : singleExpSol.getSolutionModelMap()) {
				if(modelType.isAssignableFrom(entry.getKey())) {
					solutionModel = (T)entry.getValue();
				}
			}
		}

		return solutionModel;
	}

	/**
	 * Static implementation of the method
	 * {@link SingleExplorationSolutionMap#putSolutionModel(Class, Object)}.
	 */
	public static <T> void putSolutionModel(SingleExplorationSolutionMap singleExpSol,
			Class<T> modelType, T solutionModel) {
		singleExpSol.getSolutionModelMap().put(modelType, solutionModel);
	}
}
