/*--------------------------------------------------------------------------+
$Id: DSLUtils.java 3175 2016-07-04 15:25:48Z diewald $
|                                                                          |
| Copyright 2016 ForTISS GmbH                     |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.util;

import java.util.ArrayList;

import org.fortiss.af3.exploration.dsl.model.expressions.Expression;
import org.fortiss.af3.exploration.dsl.model.operators.DualOperator;
import org.fortiss.af3.exploration.dsl.model.operators.Operator;

/**
 * Utility methods for the constraint DSL.
 * 
 * @author eder
 * @author $Author: diewald $
 * @version $Rev: 3175 $
 * @ConQAT.Rating RED Hash: 1A3F69CC68A6046206A2D005911AC4A6
 */
public class DSLUtils {

	/** Returns an {@link Expression} as a list of all leafs in the expression tree */
	public static
			ArrayList<? extends org.fortiss.af3.exploration.dsl.model.expressions.Expression>
			expressionToList(org.fortiss.af3.exploration.dsl.model.expressions.Expression expression) {
		if(expression instanceof DualOperator<?, ?, ?>) {
			ArrayList<? extends org.fortiss.af3.exploration.dsl.model.expressions.Expression> left =
					expressionToList((org.fortiss.af3.exploration.dsl.model.expressions.Expression)((DualOperator<?, ?, ?>)expression)
							.getLeft());
			ArrayList<? extends org.fortiss.af3.exploration.dsl.model.expressions.Expression> right =
					expressionToList((org.fortiss.af3.exploration.dsl.model.expressions.Expression)((DualOperator<?, ?, ?>)expression)
							.getRight());
			ArrayList<org.fortiss.af3.exploration.dsl.model.expressions.Expression> result =
					new ArrayList<>();
			result.addAll(left);
			result.add((org.fortiss.af3.exploration.dsl.model.expressions.Expression)((DualOperator<?, ?, ?>)expression));
			result.addAll(right);
			return result;
		} else if(expression instanceof Operator<?, ?>) {
			ArrayList<? extends org.fortiss.af3.exploration.dsl.model.expressions.Expression> right =
					expressionToList((org.fortiss.af3.exploration.dsl.model.expressions.Expression)((DualOperator<?, ?, ?>)expression)
							.getRight());
			ArrayList<org.fortiss.af3.exploration.dsl.model.expressions.Expression> result =
					new ArrayList<>();
			result.add((org.fortiss.af3.exploration.dsl.model.expressions.Expression)((Operator<?, ?>)expression));
			result.addAll(right);
			return right;
		} else {
			ArrayList<org.fortiss.af3.exploration.dsl.model.expressions.Expression> list =
					new ArrayList<org.fortiss.af3.exploration.dsl.model.expressions.Expression>();
			list.add(expression);
			return list;
		}
	}
}
